************************************************************************
      subroutine initqqqqhamps
************************************************************************
*       8.1.06 Stefan Dittmaier
************************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
      common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp


      complex*16 dalpz,drbos,drferm
      integer qalp
      common/rscheme/dalpz,drbos,drferm,qalp
      integer out
      common/out/out

c input parameter scheme
      qalp   = salp
c treatment of width
      qwidth = swidth
c contributions W and Z diagrams
      qw     = swdiag
      qz     = szdiag

c initialize independent parameters
      call inputamp

c initialize dependent parameters
      call paraminit

c CP symmetry not used in Born
      qcp = 0
c CP symmetry used in Born
c      qcp = 1
      qcp = scp

c options for radiative corrections
      qborn = 0
      if (sweak.eq.1) then
        sferm = 1
        sbos  = 1
      else if (sweak.eq.2) then
        sferm = 1
        sbos  = 0
      else if (sweak.eq.3) then
        sferm = 0
        sbos  = 1
      else if (sweak.eq.0) then
        sferm = 0
        sbos  = 0
      end if
      qferm=sferm
      qbos=sbos
      if (sendp(0).eq.-1) then
        qsoft = 1
      else
        qsoft = 0
      end if

      qqcddiag = sqcddiag
      qqcdnondiag = sqcdnondiag
      qqcdgsplit = sqcdgsplit
      qqcdggfus = sqcdggfus

c switches for b-quark contributions in LO
      qbini=sbini
      qbfin=sbfin

c switches for s and t-channel contributions and interferences
      qschan=sscha
      qtchan=stcha
      qch2  =sch2
      qchint=schint

c switch for 2-loop heavy Higgs corrections
      qhh2 = shh2

c only for Mat2conv  (not used)
      qfact=1

c switch for anomalous couplings
c      qhvv=shvv

c calculate renormalization constants
      call xcalcrenc
      call xcalcrenc_bgf
      call xcalcrenc_ferm

c set output channel
      out = nout

      if(lnoutmc.ge.5) then
      write(nout,*)
      write(nout,*)  'initqqhamps '
      write(nout,100) qalp,qborn,qferm,qbos,qsoft
      write(nout,110) qwidth,qw,qz,
     &             qqcddiag,qqcdnondiag,qqcdggfus,qqcdgsplit,qfact,qcp
      write(nout,120) qbini,qbfin,qschan,qtchan,qch2,qchint,qhh2
c      write(nout,130) qhvv

 100  format(' qalp  =',i2/
     &    ' qborn =',i2/
     &    ' qferm =',i2,',  qbos =',i2/
     &    ' qsoft =',i2)
 110  format(' qwidth=',i2/
     &    ' qw =   ',i2,',  qz =   ',i2/
     &    ' qqcddiag =',i2,', qqcdnondiag =',i2/
     &    ' qqcdggfus=',i2,', qqcdgsplit =',i2/
     &       ' qfact =',i2,',  qcp =  ',i2)
 120  format(' qbini =',i2,',  qbfin =',i2,/
     &       ' qschan=',i2,',  qtchan=',i2/
     &       ' qch2  =',i2,',  qchint=',i2/
     &       ' qhh2  =',i2)
c 130  format(' qhvv =',i2)
      end if
      end
