***********************************************************************
*     file crosssection.F                                             *
*     adapted from COFFERGG by Markus Roth                            *
*---------------------------------------------------------------------*
*     30.01.06  Ansgar Denner     last changed  31.03.10              *
***********************************************************************



***********************************************************************
      subroutine whzh_crosssection(k,x1,x2,generator,phasespace,em,sp,
     &    switch)
***********************************************************************
*     calculation of cross sections                                   *
*     adapted from COFFERGG by Markus Roth                            *
*     only valid for unpolarized case!!!                              *
*     subtraction terms for 4 flavors!!!!!!                           *
*     Born for 4 or 5 flavors                                         *
*---------------------------------------------------------------------*
*     22.03.06  Ansgar Denner     last changed  07.04.10              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

#ifdef multpdf
#include "multpdf.h"
      integer nset
#endif
c local variables
      integer em,sp
      real*8 k(maxe,0:3),q(0:3),q1(0:3)
      real*8 km(6,0:3),kmcms(6,0:3)
      real*8 kons(6,0:3),konscms(6,0:3)
      real*8 x1,x2
      real*8 sh,bwfac,ghoff
      logical belthr
      integer i1,i2,generator,phasespace,switch,lnext
      integer i3,i4,i6,j1,j2,j3
      integer i6p
      integer nvirtinit
      data nvirtinit /0/
      save nvirtinit

      character*5 part(-5:5)
      real*8 sij(maxe,maxe)

      real*8 m2i(-5:5,-5:5),m2i0(-5:5,-5:5)
      real*8 m2if(-5:5,-5:5,-5:5,-5:5),m2if0(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)

      real*8 m2i_ilep(-5:5,-5:5)

      real*8 m2i_phot(-5:5,-5:5),m2if_phot(-5:5,-5:5,-5:5,-5:5)
      real*8 m2i_iphot(-5:5)
      real*8 pdf1l(-6:6),pdf2l(-6:6)

      real*8 qparton(-16:16)
      data   qparton /
     &     0d0,1d0,0d0,1d0,0d0,1d0,
     &     0d0,0d0,0d0,0d0,
     &    -0.66666666666666666666d0,0.33333333333333333333d0,
     &    -0.66666666666666666666d0,0.33333333333333333333d0,
     &    -0.66666666666666666666d0,0.33333333333333333333d0,0d0,
     &    -0.33333333333333333333d0,0.66666666666666666666d0,
     &    -0.33333333333333333333d0,0.66666666666666666666d0,
     &    -0.33333333333333333333d0,0.66666666666666666666d0,
     &    0d0,0d0,0d0,0d0,
     &    -1d0,0d0,-1d0,0d0,-1d0, 0d0/


      data m2i0/121*0/

c      real*8 test(0:4,0:4),test2(2)
      real*8 constff,constfi,constif,constii
      common/constsub/constff,constfi,constif,constii

      integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
      common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
      complex*16 dalpz,drbos,drferm
      integer qalp
      common/rscheme/dalpz,drbos,drferm,qalp

      integer selprocess
      common/selprocess/selprocess


        real*8 rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz
      	integer qhvv
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

 1031 format(1x,'crosssection: ',a5,a5,a22,':  = ',g18.10)
 1032 format(1x,'crosssection: ',a17,a16,' = ',2g18.10)

 501  format (a5,i2,a1,i2,a3,d25.16)
 491  format (a6,i2,a4,d25.16,a1,d25.16,a1,d25.16,a1,
     &     d25.16,a1)
 492  format (a8,i2,a4,d25.16,a1,d25.16,a1,d25.16,a1,
     &     d25.16,a1)
 504  format (a8,i2,a1,i2,a3,d25.16)
 505  format (a4,i2,a1,i2,a3,d25.16)
 506  format (a10,i2,a3,d25.16)
 511  format (a11,i2,a3,d25.16)
 512  format (a13,i2,a7,d25.16)
 513  format (a15,i2,a3,i2,a3,i2,a12,d25.16)
 514  format (a15,i2,a3,i2,a3,i2,a3,i2,a3,i2,a3,d25.16)
 515  format (a12,i2,a3,d25.16)
 516  format (a13,i2,a5,d25.16)
 517  format (a15,i2,a1,i2,a1,i2,a4,d25.16)
 1493 format (a15,i2,a1,i2,a1,i2,a1,i2,a1,i2,a4,d25.16)
 1494 format (a13,i2,a1,i2,a1,i2,a4,d25.16)
 1495 format (a9,i2,a1,i2,a4,d25.16)
 1496 format (a10,i2,a4,d25.16)

c squared matrix elements from std
c    momenta km(6,0:3), km(1),km(2) incoming, km(3),..,km(6) outgoing
c    Higgs km(5)
c    bremsstrahlung photon km(6)
c    Born matrix elements m2i0(-5:5,-5:5), m2if0(-5:5,-5:5,-5:5,-5:5)
c    Full matrix elements m2i(-5:5,-5:5), m2if(-5:5,-5:5,-5:5,-5:5)
c    m2i, m2i0: summed over final states, including symmetry factor 1/2
c    m2if, m2if0 is populated according to following convention:
c    initial state     populated final states        symmetry factor
c      q1    q2         q3 q4       and q4 q3              1/2
c      q1bar q2bar      q3bar q4bar and q4bar q3bar        1/2
c      q1bar q2         only  q3bar q4                      1
c      q1    q2bar      only  q3    q4bar                   1

c     m2if0_22 contribution of Born matrix element squared where
c              fermion lines connect external fermions 1 and  2
c     m2if0_33 contribution of Born matrix element squared where
c              fermion lines connect external fermions 1 and  3
c     m2if0_44 contribution of Born matrix element squared where
c              fermion lines connect external fermions 1 and  4
c     m2if0_nd contribution of interferences of Born matrix elements

c    real photon matrix elements (outgoing photon):
c                  m2i_phot(-5:5,-5:5), m2if_phot(-5:5,-5:5,-5:5,-5:5)

c        write(*,*) 'crosssection: k1  ',(km(1,i1),i1=0,3)
c        write(*,*) 'crosssection: k2  ',(km(2,i1),i1=0,3)
c        write(*,*) 'crosssection: k3  ',(km(3,i1),i1=0,3)
c        write(*,*) 'crosssection: k4  ',(km(4,i1),i1=0,3)
c        write(*,*) 'crosssection: k5  ',(km(5,i1),i1=0,3)
c        write(*,*) 'crosssection: k  ',km



      if(switch.gt.0)return

      if(generator.eq.0.or.phasespace.gt.1)then
         lnext=5
      else
         lnext=6
      endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  combine momenta of Higgs decay particles to Higgs momentum  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  km = k with Higgs decay momenta replaced by Higgs momentum  c
c         and particle order changed as for stable-Higgs case  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do ext=1,lnext
         do vcomp=0,3
            km(ext,vcomp)=k(ext,vcomp)
         enddo
      enddo
      do ext=lnext+1,6
         do vcomp=0,3
            km(ext,vcomp)=0d0
         enddo
      enddo

      if(shtr.ge.1) then
         if(lnext.eq.5)then
            do vcomp=0,3
               km(5,vcomp)=k(5,vcomp)+k(6,vcomp)
            enddo
         else
            do vcomp=0,3
               km(5,vcomp)=k(5,vcomp)+k(6,vcomp)
               km(6,vcomp)=k(7,vcomp)
            enddo
         endif
      endif

cccccccccccccccccccccccccccccccccccccccccccc
c  Breit-Wigner for off-shell Higgs boson  c
cccccccccccccccccccccccccccccccccccccccccccc
      sh = km(5,0)*km(5,0)-km(5,1)*km(5,1)
     &     -km(5,2)*km(5,2)-km(5,3)*km(5,3)
      if(shtr.eq.0)then
         bwfac=1d0
      else
         if(shbw.eq.0)then
            bwfac = 16d0*pi*hbr*mcm(25)*mcw(25)/
     &           ((sh-mcm(25)*mcm(25))**2+(mcm(25)*mcw(25))**2)
         elseif(shbw.eq.1)then
            call gridHt(sqrt(sh),ghoff)
            bwfac = 16d0*pi*hbr*sqrt(sh)*ghoff/
     &           ((sh-mcm(25)*mcm(25))**2+(mcm(25)*mcw(25))**2)
         elseif(shbw.eq.9)then
            call gridHt(sqrt(sh),ghoff)
            bwfac = 16d0*pi*hbr*sqrt(sh)*mcw(25)/
     &           ((sh-mcm(25)*mcm(25))**2+(mcm(25)*mcw(25))**2)
         elseif(shbw.eq.8)then
            call gridHt(sqrt(sh),ghoff)
            bwfac = 16d0*pi*hbr*sh/mcm(25)*mcw(25)/
     &           ((sh-mcm(25)*mcm(25))**2+(mcm(25)*mcw(25))**2)
         else if(shbw.eq.2)then
            bwfac = 16d0*pi*hbr*sh/mcm(25)*mcw(25)/
     &           ((sh-mcm(25)*mcm(25))**2+(sh/mcm(25)*mcw(25))**2)
         else
            write(*,*) 'shbw: value not supported: shbw = ',shbw
            stop
         endif
      endif


ccccccccccccccccccccccc
c  incoming momentum  c
ccccccccccccccccccccccc
      do vcomp=0,3
         q(vcomp)=km(1,vcomp)+km(2,vcomp)
      enddo

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  boost momenta km to CMS                                        c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  kmcms = km (without on-shell projection) after boost into CMS  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do ext=1,lnext
         do vcomp=0,3
            q1(vcomp)=km(ext,vcomp)
         enddo
         call boost(0d0,q,q1,1d0,switch)
         do vcomp=0,3
            kmcms(ext,vcomp)=q1(vcomp)
         enddo
      enddo
      do ext=lnext+1,6
         do vcomp=0,3
            kmcms(ext,vcomp)=0d0
         enddo
      enddo



cccccccccccccccccccc
c  generator.eq.0  c
cccccccccccccccccccc
      if(generator.eq.0)then


ccccccccccccccccccccc
c  phasespace.eq.1  c
ccccccccccccccccccccc
         if(phasespace.eq.1)then

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of on-shell projected momenta kons           c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  kons = on-shell projected momenta (from km)              c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  belthr -> "below threshold"                              c
c         =  .true.  if no on-shell projection is possible  c
c         =  .false. elsewise                               c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            call onsproj(km,kons,belthr,lnext,switch)
            if(.not.belthr)then

ccccccccccccccccccccccccccccccc
c  incoming on-shell momenta  c
ccccccccccccccccccccccccccccccc
               do vcomp=0,3
                  q(vcomp)=kons(1,vcomp)+kons(2,vcomp)
               enddo

ccccccccccccccccccccccccccccccccccc
c  boost on-shell momenta to cms  c
ccccccccccccccccccccccccccccccccccc
               do ext=1,lnext
                  do vcomp=0,3
                     q1(vcomp)=kons(ext,vcomp)
                  enddo
                  call boost(0d0,q,q1,1d0,switch)
                  do vcomp=0,3
                     konscms(ext,vcomp)=q1(vcomp)
                  enddo
               enddo
            endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of born, I-operator (-> virtual), and K+P (-> convolution) contributions  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            if((lgencon(0,3).or.lgencon(0,4)).and.
     &           ((lgencon(0,2).or.lgencon(0,5))
     &           .and.sendp(generator).eq.1))then

cccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements  c
cccccccccccccccccccccccccccccccccccc
               call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),qhvv)

               if(.not.lonsborn) then
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"
                  do i1=-5,5
                  do i2=-5,5
                  if ((i1*i2.ne.0).and.
     &                    ((selprocess.eq.1.and.
     &                    (abs(qparton(i1)+qparton(i2)-1d0)
     &                    .lt.1d-10)).or.
     &                    ((selprocess.eq.2.and.
     &                    (abs(qparton(i1)+qparton(i2)+1d0)
     &                    .lt.1d-10)).or.
     &                    (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                    (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                    i1.eq.-i2))))) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
                  endif
                  enddo
                  enddo
               endif

#include "whzh_crosssection/setzero_m2pdfpdfqq_0.F"
#include "whzh_crosssection/setzero_m2pdfpdftt_0.F"

               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then

                  if(lgencon(0,3))then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0.F"
                  endif
                  if(lgencon(0,4))then
#include "whzh_crosssection/setzero_m2pdfpdfiitt_0.F"
                  endif

                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif

                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,2).and..not.lonsew)then
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"


#ifdef multpdf
                        do nset=1,pdfmemberto-pdfmemberfrom+1
                           aref=(nset-1)*maxps+phasespace
                           Write(*,*) "unexpected branch for multpdf"
                           Write(*,*) "Program stops here"
                           Stop
                        enddo
#endif
                     endif
                     write(*,*) 'check identity at position 1'

                     if(lgencon(0,5).and..not.lonsqcd)then
#include "whzh_crosssection/calculate_m2pdfpdfiiiitt_0.F"
                     endif

                     if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0.F"
                     endif
                     if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0.F"
                     endif
                  endif
                  if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfqq_0.F"
                  endif

                  if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdftt_0.F"
                  endif
               endif
               enddo
               enddo




               if((lonsborn.or.lonsqcd.or.lonsew).and..not.belthr)then
                  write (*,*)
                  write (*,*) '   subbranch'
                  write (*,*) '(lonsborn.or.lonsqcd.or.lonsew)'
                  write (*,*) '   .and.'
                  write (*,*) '.not.belthr'
                  write (*,*)
                  print *,'      lonsborn =', lonsborn
                  print *,'      lonsqcd =', lonsqcd
                  print *,'      lonsew =', lonsew
                  print *,'      .not.belthr =', .not.belthr

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements in on-shell approximation  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
                  call whzhMat2born(konscms,m2i0,max(sbini,sbfin),qhvv)
               endif

               if(lonsborn)then
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"
                  do i1=-5,5
                  do i2=-5,5
                     if (i1*i2.ne.0) then
                        if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfii_0.F"
                        else
#include "whzh_crosssection/calculate_m2pdfpdfii_0.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
                        endif
                     endif
                  enddo
                  enddo
               endif

               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then
                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif
                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then
                     if(lgencon(0,2).and.lonsew)then
                        if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfiiiiqq_0.F"
                        else
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"
                        endif
                        write(*,*) 'check identity at position 2'
c#include "whzh_crosssection/check_m2pdfpdfiiiiqq_0.F"
                     endif

                     if(lgencon(0,5).and.lonsqcd)then
                        if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfiiiitt_0.F"
                        else
#include "whzh_crosssection/calculate_m2pdfpdfiiiitt_0.F"
                        endif
                     endif
                  endif
               endif
               enddo
               enddo


c average over colours and spins
c          write(*,*) 'crosssection',m2b,m2bb,
c     &        m2pdfpdf_0(phasespace)

c symmetric contributions
               if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_symm.F"
                  do i1=-4,4
                  do i2=-4,4
                  if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_symm.F"
                  endif
                  enddo
                  enddo
               endif

               if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdftt_0_symm.F"
                  do i1=-4,4
                  do i2=-4,4
                  if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_symm.F"
                  endif
                  enddo
                  enddo
               endif


            elseif(lgencon(0,3).or.lgencon(0,4))then

cccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements  c
cccccccccccccccccccccccccccccccccccc

               call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),qhvv)

#include "whzh_crosssection/setzero_m2pdfpdfqq_0.F"
#include "whzh_crosssection/setzero_m2pdfpdftt_0.F"
               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then
                  if(lgencon(0,3))then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0.F"
                  endif
                  if(lgencon(0,4))then
#include "whzh_crosssection/setzero_m2pdfpdfiitt_0.F"
                  endif

                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif

                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0.F"
                     endif
                     if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0.F"
                     endif
                  endif

                  if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfqq_0.F"
                  endif

                  if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdftt_0.F"
                  endif
               endif
               enddo
               enddo


               if(lonsborn.and..not.belthr)then
                  print *, 'non-existing branch'
               endif

#include "whzh_crosssection/setzero_m2pdfpdf_0.F"
               do i1=-5,5
               do i2=-5,5
               if (i1*i2.ne.0) then
                  if(belthr.and.lonsborn)then
                     write (*,*) '(belthr.and.lonsborn)'
#include "whzh_crosssection/setzero_m2pdfpdfii_0.F"
                  else
#include "whzh_crosssection/calculate_m2pdfpdfii_0.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
                  endif
               endif
               enddo
               enddo

               if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_symm.F"
                  do i1=-4,4
                  do i2=-4,4
                  if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_symm.F"
                  endif
                  enddo
                  enddo
               endif

               if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdftt_0_symm.F"
                  do i1=-4,4
                  do i2=-4,4
                  if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_symm.F"
                  endif
                  enddo
                  enddo
               endif


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of virtual (I operator) contributions only (no convolution)  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

            elseif ((lgencon(0,2).or.lgencon(0,5))
     &              .and.sendp(generator).eq.1)then

cccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements  c
cccccccccccccccccccccccccccccccccccc

               call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),qhvv)

               do i1=-4,4
               do i2=-4,4
                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif
                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,2).and..not.lonsew)then
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"
                        write(*,*) 'check identity at position 3'
c#include "whzh_crosssection/check_m2pdfpdfiiiiqq_0.F"
                     endif

                     if(lgencon(0,5).and..not.lonsqcd)then
#include "whzh_crosssection/calculate_m2pdfpdfiiiitt_0.F"
                     endif
                  endif
               enddo
               enddo

               if (lgencon(0,2).and..not.lonsew)then
               endif
               if (lgencon(0,5).and..not.lonsqcd)then
               endif


               if((lonsborn.or.lonsqcd.or.lonsew).and..not.belthr)then
                  call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),qhvv)
               endif

               if(lonsborn)then

                  do i1=-5,5
                  do i2=-5,5
                  if (i1*i2.ne.0) then
                     if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfii_0.F"
                     else
#include "whzh_crosssection/calculate_m2pdfpdfii_0.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
                     endif
                  endif
                  enddo
                  enddo
               endif

               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then
                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif
                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,2).and.lonsew)then
                        if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfiiiiqq_0.F"
                        else
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"
                        endif
                        write(*,*) 'check identity at position 4'
c#include "whzh_crosssection/check_m2pdfpdfiiiiqq_0.F"
                     endif



                     if(lgencon(0,5).and.lonsqcd)then
                        if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfiiiitt_0.F"
                        else
#include "whzh_crosssection/calculate_m2pdfpdfiiiitt_0.F"
                        endif
                     endif
                  endif
               endif
               enddo
               enddo



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of born contribution only (no virtual + convolution, no virtual)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            else if (lgencon(0,1).or.lwborn(0)) then

               if(belthr.and.lonsborn)then
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"
                  do i1=-5,5
                  do i2=-5,5
#include "whzh_crosssection/setzero_m2pdfpdfii_0.F"
                  enddo
                  enddo
               else             ! above threshold
                  call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),qhvv)

                  if(lonsborn)then
                     print *,'Mat2born0 does not exist for whzh!'
                  endif


#include "whzh_crosssection/setzero_m2pdfpdf_0.F"
                  do i1=-5,5
                  do i2=-5,5
                  if (i1*i2.ne.0) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"

                  endif
                  enddo
                  enddo

               endif            ! if(belthr)
            endif



cccccccccccccccccccccccccccccccccccccccc
c  calculation of virtual corrections  c
cccccccccccccccccccccccccccccccccccccccc
            if(svirt(generator).ne.0.and.
     &           (lgencon(0,2).or.lgencon(0,5)))then

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  boost momenta km to CMS                                        c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  kmcms = km (without on-shell projection) after boost into CMS  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               do i1=1,lnext
                  do i2=0,3
                     q1(i2)=km(i1,i2)
                  enddo
                  call boost(0d0,q,q1,1d0,switch)
                  do i2=0,3
                     kmcms(i1,i2)=q1(i2)
                  enddo
               enddo
               if(switch.ne.0) return

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  qcd corrections must be calculated with ew corrections to  c
c  ensure proper use of cache for loop integrals              c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               if((lgencon(0,5).or.
     &              lgencon(0,2).and.sgencon(0,5).eq.1)
     &              .and..not.(lonsqcd.and.belthr)
     &              .and..not.(lonsew.and.belthr.and.nvirtinit.le.10)
     &              )then

cccccccccccccccccccccccccccccccccccccccccc
c  initializes cache for loop integrals  c
cccccccccccccccccccccccccccccccccccccccccc
                  If(lnoutmc.GE.2) Then
                    call fastinit(nout)
		  Else
                    call fastinit(-1)
		  Endif
                  qferm=0
                  qbos =0
                  qhh2 =0
                  if(lonsqcd)then
                     call whzhMat2(konscms,m2i0,m2i)
                  else
                     call whzhMat2(kmcms,m2i0,m2i)
                  endif
                  qferm=sferm
                  qbos =sbos
                  qhh2 =shh2
#include "whzh_crosssection/setzero_m2pdfpdf_vs.F"
                  do i1=-4,4
                  do i2=-4,4
                  if ((i1*i2.ne.0).and.
     &                    ((selprocess.eq.1.and.
     &                    (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10))
     &                    .or.
     &                    ((selprocess.eq.2.and.
     &                    (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10))
     &                    .or.
     &                    (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                    (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                    i1.eq.-i2))))) then
#include "whzh_crosssection/calculate_m2pdfpdfii_vs.F"
#include "whzh_crosssection/calculate_m2pdfpdf_vs.F"
                  endif
                  enddo
                  enddo
               else
                  do i1=-4,4
                  do i2=-4,4
#include "whzh_crosssection/setzero_m2pdfpdfii_vs.F"
                  enddo
                  enddo
#include "whzh_crosssection/setzero_m2pdfpdf_vs.F"
               endif


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  to initialize cache for loop integrals, qcd and ew corrections  c
c  must be calculated for the first 10 times together              c
c  (counted by nvirtinit)                                          c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               if((lgencon(0,2).or.
     &              nvirtinit.le.10.and.lgencon(0,5)
     &              .and..not.(lonsqcd.and.belthr))
     &              .and..not.(lonsew.and.belthr))then
                  nvirtinit=nvirtinit+1
                  qqcddiag=0
                  qqcdnondiag=0
                  qqcdgsplit=0
                  qqcdggfus=0

                  call whzhMat2(konscms,m2i0,m2i)

                  qqcddiag=sqcddiag
                  qqcdnondiag=sqcdnondiag
                  qqcdgsplit=sqcdgsplit
                  qqcdggfus=sqcdggfus

#include "whzh_crosssection/setzero_m2pdfpdf_vw.F"
                  do i1=-4,4
                  do i2=-4,4
                  if ((i1*i2.ne.0).and.
     &                    ((selprocess.eq.1.and.
     &                    (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10))
     &                    .or.
     &                    ((selprocess.eq.2.and.
     &                    (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10))
     &                    .or.
     &                    (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                    (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                    i1.eq.-i2)))))then
#include "whzh_crosssection/calculate_m2pdfpdfii_vw.F"
#include "whzh_crosssection/calculate_m2pdfpdf_vw.F"
                  endif
                  enddo
                  enddo
               else
#include "whzh_crosssection/setzero_m2pdfpdf_vw.F"
                  do i1=-4,4
                  do i2=-4,4
#include "whzh_crosssection/setzero_m2pdfpdfii_vw.F"
                  enddo
                  enddo
               endif
            endif





cccccccccccccccccccccccccccccccccccccccc
c  phasespace.eq.2.or.phasespace.eq.3  c
cccccccccccccccccccccccccccccccccccccccc

         elseif((phasespace.eq.2.or.phasespace.eq.3).and.
     &           (lgencon(0,3).or.lgencon(0,4)))then

            call whzhMat2born(kmcms,m2i0,0,qhvv)

#include "whzh_crosssection/setzero_m2pdfpdfqq_0.F"
#include "whzh_crosssection/setzero_m2pdfpdftt_0.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
               if(lgencon(0,3))then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0.F"
               endif
               if(lgencon(0,4))then
#include "whzh_crosssection/setzero_m2pdfpdfiitt_0.F"
               endif
               if (selprocess.eq.1)then
                  i3 = -11
                  i4 = 12
               elseif (selprocess.eq.2)then
                  i3 = -12
                  i4 = 11
               elseif (selprocess.eq.3)then
                  i3 = -11
                  i4 = 11
               elseif (selprocess.eq.4)then
                  i3 = -12
                  i4 = 12
               endif
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
                  if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0.F"
                  endif
                  if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0.F"
                  endif
               endif
               if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfqq_0.F"
               endif
               if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdftt_0.F"
               endif
            endif
            enddo
            enddo

            if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_symm.F"
               do i1=-4,4
               do i2=-4,4
               if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_symm.F"
               endif
               enddo
               enddo
            endif
            if(lgencon(0,4))then
#include "whzh_crosssection/calculate_m2pdfpdftt_0_symm.F"
               do i1=-4,4
               do i2=-4,4
               if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_symm.F"
               endif
               enddo
               enddo
            endif





         elseif((phasespace.eq.4.or.phasespace.eq.5).and.
     &           (lgencon(0,6).or.lgencon(0,7).or.
     &           lgencon(0,8).or.lgencon(0,9)))then
cccccccccccccccccccccccccccccccccccccccc
c  phasespace.eq.4.or.phasespace.eq.5  c
cccccccccccccccccccccccccccccccccccccccc

            call whzhMat2born(kmcms,m2i0,0,qhvv)

#include "whzh_crosssection/setzero_m2pdfpdfq2_0.F"
#include "whzh_crosssection/setzero_m2pdfpdft2_0.F"
            do i1=-4,4
#include "whzh_crosssection/setzero_m2pdfpdfiiq2_0.F"
#include "whzh_crosssection/setzero_m2pdfpdfiit2_0.F"
            do i2=-4,4
            if (i1*i2.ne.0) then
               if (selprocess.eq.1)then
                  i3 = -11
                  i4 = 12
               elseif (selprocess.eq.2)then
                  i3 = -12
                  i4 = 11
               elseif (selprocess.eq.3)then
                  i3 = -11
                  i4 = 11
               elseif (selprocess.eq.4)then
                  i3 = -12
                  i4 = 12
               endif
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
                  if(lgencon(0,6).or.lgencon(0,7))then
#include "whzh_crosssection/calculate_m2pdfpdfiiq2_0.F"
                  endif
                  if(lgencon(0,8).or.lgencon(0,9))then
#include "whzh_crosssection/calculate_m2pdfpdfiit2_0.F"
                  endif
               endif
            endif
            enddo

            if(lgencon(0,6).or.lgencon(0,7))then
#include "whzh_crosssection/calculate_m2pdfpdfiiq2_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfq2_0.F"
            endif

            if(lgencon(0,8).or.lgencon(0,9))then
#include "whzh_crosssection/calculate_m2pdfpdfiit2_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdft2_0.F"
            endif
            enddo
         endif



         if(qhvv.gt.0) then

ccccccccccccccccccccc
c  phasespace.eq.1  c
ccccccccccccccccccccc
         if(phasespace.eq.1)then


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of born, I-operator (-> virtual), and K+P (-> convolution) contributions  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            if((lgencon(0,3)).and.
     &           ((lgencon(0,2))
     &           .and.sendp(generator).eq.1))then

cccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements  c
cccccccccccccccccccccccccccccccccccc
               call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),0)

#include "whzh_crosssection/setzero_m2pdfpdfqq_0.F"

               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then

                  if(lgencon(0,3))then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0.F"
                  endif

                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif

                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,2).and..not.lonsew)then
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"


#ifdef multpdf
                        do nset=1,pdfmemberto-pdfmemberfrom+1
                           aref=(nset-1)*maxps+phasespace
                           Write(*,*) "unexpected branch for multpdf"
                           Write(*,*) "Program stops here"
                           Stop
                        enddo
#endif
                     endif
                     write(*,*) 'check identity at position 1'

                     if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0.F"
                     endif
                  endif
                  if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfqq_0.F"
                  endif

               endif
               enddo
               enddo




               if((lonsborn.or.lonsqcd.or.lonsew).and..not.belthr)then
                  write (*,*)
                  write (*,*) '   subbranch'
                  write (*,*) '(lonsborn.or.lonsqcd.or.lonsew)'
                  write (*,*) '   .and.'
                  write (*,*) '.not.belthr'
                  write (*,*)
                  print *,'      lonsborn =', lonsborn
                  print *,'      lonsqcd =', lonsqcd
                  print *,'      lonsew =', lonsew
                  print *,'      .not.belthr =', .not.belthr

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements in on-shell approximation  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
                  call whzhMat2born(konscms,m2i0,max(sbini,sbfin),0)
               endif


               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then
                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif
                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then
                     if(lgencon(0,2).and.lonsew)then
                        if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfiiiiqq_0.F"
                        else
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"
                        endif
                        write(*,*) 'check identity at position 2'
c#include "whzh_crosssection/check_m2pdfpdfiiiiqq_0.F"
                     endif

                  endif
               endif
               enddo
               enddo


c symmetric contributions
               if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_symm.F"
                  do i1=-4,4
                  do i2=-4,4
                  if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_symm.F"
                  endif
                  enddo
                  enddo
               endif



            elseif(lgencon(0,3))then

cccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements  c
cccccccccccccccccccccccccccccccccccc

               call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),0)

#include "whzh_crosssection/setzero_m2pdfpdfqq_0.F"
               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then
                  if(lgencon(0,3))then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0.F"
                  endif

                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif

                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0.F"
                     endif
                  endif

                  if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfqq_0.F"
                  endif

               endif
               enddo
               enddo


               if(lonsborn.and..not.belthr)then
                  print *, 'non-existing branch'
               endif

               if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_symm.F"
                  do i1=-4,4
                  do i2=-4,4
                  if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_symm.F"
                  endif
                  enddo
                  enddo
               endif


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of virtual (I operator) contributions only (no convolution)  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

            elseif ((lgencon(0,2))
     &              .and.sendp(generator).eq.1)then

cccccccccccccccccccccccccccccccccccc
c  calculation of matrix elements  c
cccccccccccccccccccccccccccccccccccc

               call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),0)

               do i1=-4,4
               do i2=-4,4
                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif
                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,2).and..not.lonsew)then
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"
                        write(*,*) 'check identity at position 3'
c#include "whzh_crosssection/check_m2pdfpdfiiiiqq_0.F"
                     endif

                  endif
               enddo
               enddo

               if (lgencon(0,2).and..not.lonsew)then
               endif

               if((lonsborn.or.lonsqcd.or.lonsew).and..not.belthr)then
                  call whzhMat2born(kmcms,m2i0,max(sbini,sbfin),0)
               endif

               do i1=-4,4
               do i2=-4,4
               if (i1*i2.ne.0) then
                  if (selprocess.eq.1)then
                     i3 = -11
                     i4 = 12
                  elseif (selprocess.eq.2)then
                     i3 = -12
                     i4 = 11
                  elseif (selprocess.eq.3)then
                     i3 = -11
                     i4 = 11
                  elseif (selprocess.eq.4)then
                     i3 = -12
                     i4 = 12
                  endif
                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &                 i1.eq.-i2)))) then

                     if(lgencon(0,2).and.lonsew)then
                        if(belthr)then
#include "whzh_crosssection/setzero_m2pdfpdfiiiiqq_0.F"
                        else
#include "whzh_crosssection/calculate_m2pdfpdfiiiiqq_0.F"
                        endif
                        write(*,*) 'check identity at position 4'
c#include "whzh_crosssection/check_m2pdfpdfiiiiqq_0.F"
                     endif


                  endif
               endif
               enddo
               enddo

            endif




cccccccccccccccccccccccccccccccccccccccc
c  phasespace.eq.2.or.phasespace.eq.3  c
cccccccccccccccccccccccccccccccccccccccc

         elseif((phasespace.eq.2.or.phasespace.eq.3).and.
     &           (lgencon(0,3)))then

            call whzhMat2born(kmcms,m2i0,0,0)

#include "whzh_crosssection/setzero_m2pdfpdfqq_0.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
               if(lgencon(0,3))then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0.F"
               endif
               if (selprocess.eq.1)then
                  i3 = -11
                  i4 = 12
               elseif (selprocess.eq.2)then
                  i3 = -12
                  i4 = 11
               elseif (selprocess.eq.3)then
                  i3 = -11
                  i4 = 11
               elseif (selprocess.eq.4)then
                  i3 = -12
                  i4 = 12
               endif
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
                  if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0.F"
                  endif
               endif
               if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfqq_0.F"
               endif
            endif
            enddo
            enddo

            if(lgencon(0,3))then
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_symm.F"
               do i1=-4,4
               do i2=-4,4
               if(i1*i2.ne.0)then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_symm.F"
               endif
               enddo
               enddo
            endif





         elseif((phasespace.eq.4.or.phasespace.eq.5).and.
     &           (lgencon(0,6).or.lgencon(0,7)))then
cccccccccccccccccccccccccccccccccccccccc
c  phasespace.eq.4.or.phasespace.eq.5  c
cccccccccccccccccccccccccccccccccccccccc

            call whzhMat2born(kmcms,m2i0,0,0)

#include "whzh_crosssection/setzero_m2pdfpdfq2_0.F"
            do i1=-4,4
#include "whzh_crosssection/setzero_m2pdfpdfiiq2_0.F"
            do i2=-4,4
            if (i1*i2.ne.0) then
               if (selprocess.eq.1)then
                  i3 = -11
                  i4 = 12
               elseif (selprocess.eq.2)then
                  i3 = -12
                  i4 = 11
               elseif (selprocess.eq.3)then
                  i3 = -11
                  i4 = 11
               elseif (selprocess.eq.4)then
                  i3 = -12
                  i4 = 12
               endif
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
                  if(lgencon(0,6).or.lgencon(0,7))then
#include "whzh_crosssection/calculate_m2pdfpdfiiq2_0.F"
                  endif
               endif
            endif
            enddo

            if(lgencon(0,6).or.lgencon(0,7))then
#include "whzh_crosssection/calculate_m2pdfpdfiiq2_0_av.F"
#include "whzh_crosssection/calculate_m2pdfpdfq2_0.F"
            endif

            enddo
         endif


        end if  ! qhvv.gt.0






      elseif(generator.eq.1.and.phasespace.eq.1)then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of real-correction amplitudes with an outgoing photon  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         do i1=-4,4
         do i2=-4,4
            m2i_phot(i1,i2)=0d0
         enddo
         enddo
         call whzhMat2photon_out(kmcms,m2i_phot)
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"
         do i1=-4,4
         do i2=-4,4
         if (i1*i2.ne.0) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0_phot.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
         endif
         enddo
         enddo


      elseif(generator.eq.1.and.phasespace.ne.1)then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in real corrections with an outgoing photon  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         call whzhMat2born(kmcms,m2i0,0,0)
         if (selprocess.eq.1)then
            i3 = -11
            i4 = 12
         elseif (selprocess.eq.2)then
            i3 = -12
            i4 = 11
         elseif (selprocess.eq.3)then
            i3 = -11
            i4 = 11
         elseif (selprocess.eq.4)then
            i3 = -12
            i4 = 12
         endif



         if (em.eq.1.and.sp.eq.2.or.em.eq.2.and.sp.eq.1) then
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_i1_i2.F"

                endif
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo
            enddo



         elseif ((selprocess.eq.1.or.selprocess.eq.3).and.
     &         (em.eq.1.and.sp.eq.3.or.em.eq.3.and.sp.eq.1)) then
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_i1_i3.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo
            enddo



         elseif ((selprocess.eq.2.or.selprocess.eq.3).and.
     &           (em.eq.1.and.sp.eq.4.or.em.eq.4.and.sp.eq.1)) then
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_i1_i4.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo
            enddo



         elseif ((selprocess.eq.1.or.selprocess.eq.3).and.
     &           (em.eq.2.and.sp.eq.3.or.em.eq.3.and.sp.eq.2)) then
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_i2_i3.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo
            enddo



         elseif ((selprocess.eq.2.or.selprocess.eq.3).and.
     &           (em.eq.2.and.sp.eq.4.or.em.eq.4.and.sp.eq.2)) then
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_i2_i4.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo
            enddo

         elseif ((selprocess.eq.3).and.
     &         (em.eq.3.and.sp.eq.4.or.em.eq.4.and.sp.eq.3)) then
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_i3_i4.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo
            enddo



         else
            write(*,*) 'program stopped'
            write(*,*) 'crosssection: outga ',
     &           'not implemented em=co,sp=',em,sp
            stop
         endif







      elseif(generator.eq.2.and.phasespace.eq.1)then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of real-correction amplitudes with an outgoing gluon  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

          call whzhMat2gluon_out(km,m2i_phot)
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"
         do i1=-4,4
         do i2=-4,4
         if ((i1*i2.ne.0).and.
     &           ((selprocess.eq.1.and.
     &           (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &           (selprocess.eq.2.and.
     &           (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &           ((selprocess.eq.3.or.selprocess.eq.4).and.
     &           (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &           i1.eq.-i2))) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0_phot.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
         endif
         enddo
         enddo



      elseif(generator.eq.2.and.phasespace.ne.1)then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in real corrections with an outgoing gluon  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         call whzhMat2born(kmcms,m2i0,0,qhvv)

         if (em.eq.1.and.sp.eq.2.or.em.eq.2.and.sp.eq.1) then
#include "whzh_crosssection/setzero_m2pdfpdftt_0_em_sp.F"
            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiitt_0_em_sp.F"
               if ((selprocess.eq.1.and.
     &              (abs(qparton(i1)+qparton(i2)-1d0).lt.1d-10)).or.
     &              ((selprocess.eq.2.and.
     &              (abs(qparton(i1)+qparton(i2)+1d0).lt.1d-10)).or.
     &              (((selprocess.eq.3.or.selprocess.eq.4).and.
     &              (abs(qparton(i1)+qparton(i2)).lt.1d-10).and.
     &              i1.eq.-i2)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_i1_i2.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdftt_0_em_sp.F"
            endif
            enddo
            enddo



         elseif (em.eq.1.and.sp.eq.3.or.em.eq.3.and.sp.eq.1) then
            print *,'x(em.eq.1.and.sp.eq.3.or.em.eq.3.and.sp.eq.1)'
         elseif (em.eq.1.and.sp.eq.4.or.em.eq.4.and.sp.eq.1) then
            print *,'x(em.eq.1.and.sp.eq.4.or.em.eq.4.and.sp.eq.1)'
         elseif (em.eq.2.and.sp.eq.3.or.em.eq.3.and.sp.eq.2) then
            print *,'x(em.eq.2.and.sp.eq.3.or.em.eq.3.and.sp.eq.2)'
         elseif (em.eq.2.and.sp.eq.4.or.em.eq.4.and.sp.eq.2) then
            print *,'x(em.eq.2.and.sp.eq.4.or.em.eq.4.and.sp.eq.2)'
         elseif (em.eq.3.and.sp.eq.4.or.em.eq.4.and.sp.eq.3) then
            print *,'x(em.eq.3.and.sp.eq.4.or.em.eq.4.and.sp.eq.3)'
         else
            write(*,*) 'program stopped'
            write(*,*) 'crosssection: outgl ',
     &           'not implemented em=co,sp=',em,sp
            stop
         endif







      elseif(generator.eq.3.and.phasespace.eq.1)then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of real-correction amplitudes with an incoming photon (1)  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#include "whzh_crosssection/setzero_m2i_iphot.F"

         call whzhMat2photon_in1(kmcms,m2i_iphot)
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"

         i1=0
         pdf1l(i1)=pdf_phot1
         do i2=-4,4
         if (i2.ne.0) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0_inphot1.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
         endif
         enddo




      elseif(generator.eq.3.and.phasespace.ne.1)then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in real corrections with an incoming photon (1)  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         if ((selprocess.eq.1.and.em.eq.3).or.
     &        (selprocess.eq.2.and.em.eq.4)) then

ccccccccccccccccccccccccccccccccccccc
c  gamma -> f f* subtraction terms  c
ccccccccccccccccccccccccccccccccccccc
#include "whzh_crosssection/setzero_m2i_ilep.F"

            call whzhMat2lepton_in1(kmcms,m2i_ilep,0)
#include "whzh_crosssection/setzero_m2pdfpdflq_0_em_sp.F"
            i1=0
            pdf1l(i1)=pdf_phot1
            if (selprocess.eq.1) then
               i6p = 11
               i6 = 1
            else if (selprocess.eq.2) then
               i6p = -11
               i6 = -1
            endif

            do i2=-4,4
               if (i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiilq_0_em_sp.F"
                  if ((selprocess.eq.1.and.qparton(i2).gt.0d0).or.
     &                 (selprocess.eq.2.and.qparton(i2).lt.0d0)) then
#include "whzh_crosssection/calculate_m2pdfpdfiilq_0_inlept1_i6.F"
                  endif
#include "whzh_crosssection/calculate_m2pdfpdflq_0_em_sp.F"
               endif
            enddo



         elseif ((em.eq.6.and.shtr.eq.0.or.
     &           em.eq.7.and.shtr.gt.0).and.sp.eq.2) then

cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  normal QED subtraction terms for incoming photon 1  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            call whzhMat2born(kmcms,m2i0,0,0)
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"
            i1=0
            pdf1l(i1)=pdf_phot1
            do i2=-4,4
            if (i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               do j3=1,4
                  i6 = sign(j3,i2)
                  if ((selprocess.eq.1.and.
     &                 (abs(-qparton(i6)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(-qparton(i6)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(-qparton(i6)+qparton(i2)).lt.1d-10).and.
     &                 i2.eq.i6)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_inphot1_i6.F"
                  endif
               enddo
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo



       else
          write(*,*) 'program stopped'
          write(*,*) 'crosssection: inga1 ',
     &         'not implemented em=co,sp=',em,sp
          stop
       endif







      elseif(generator.eq.4.and.phasespace.eq.1)then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of real-correction amplitudes with an incoming photon (2)  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         call whzhMat2photon_in2(kmcms,m2i_iphot)
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"

         i2=0
         pdf2l(i2)=pdf_phot2
         do i1=-4,4
         if (i1.ne.0) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0_inphot2.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
         endif
         enddo




      elseif(generator.eq.4.and.phasespace.ne.1)then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in real corrections with an incoming photon (2)  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         if ((selprocess.eq.1.and.em.eq.3).or.
     &        (selprocess.eq.2.and.em.eq.4)) then

ccccccccccccccccccccccccccccccccccccc
c  gamma -> f f* subtraction terms  c
ccccccccccccccccccccccccccccccccccccc
#include "whzh_crosssection/setzero_m2i_ilep.F"

            call whzhMat2lepton_in2(kmcms,m2i_ilep,0)
#include "whzh_crosssection/setzero_m2pdfpdfql_0_em_sp.F"
            i2=0
            pdf2l(i2)=pdf_phot2
            if (selprocess.eq.1) then
               i6p = 11
               i6 = 1
            else if (selprocess.eq.2) then
               i6p = -11
               i6 = -1
            endif

            do i1=-4,4
               if (i1.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiql_0_em_sp.F"
                  if ((selprocess.eq.1.and.qparton(i1).gt.0d0).or.
     &                 (selprocess.eq.2.and.qparton(i1).lt.0d0)) then
#include "whzh_crosssection/calculate_m2pdfpdfiiql_0_inlept2_i6.F"
                  endif
#include "whzh_crosssection/calculate_m2pdfpdfql_0_em_sp.F"
               endif
            enddo



         elseif ((em.eq.6.and.shtr.eq.0.or.em.eq.7.and.shtr.gt.0)
     &           .and.sp.eq.1) then

cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  normal QED subtraction terms for incoming photon 2  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

            call whzhMat2born(kmcms,m2i0,0,0)
#include "whzh_crosssection/setzero_m2pdfpdfqq_0_em_sp.F"

            i2=0
            pdf2l(i2)=pdf_phot2
            do i1=-4,4
            if (i1.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiqq_0_em_sp.F"
               do j3=1,4
                  i6 = sign(j3,i1)
                  if ((selprocess.eq.1.and.
     &                 (abs(qparton(i1)-qparton(i6)-1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.2.and.
     &                 (abs(qparton(i1)-qparton(i6)+1d0).lt.1d-10)).or.
     &                 (((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(qparton(i1)-qparton(i6)).lt.1d-10).and.
     &                 i1.eq.i6)))) then
#include "whzh_crosssection/calculate_m2pdfpdfiiqq_0_inphot2_i6.F"
                  endif
               enddo
#include "whzh_crosssection/calculate_m2pdfpdfqq_0_em_sp.F"
            endif
            enddo



       else
          write(*,*) 'program stopped'
          write(*,*) 'crosssection: inga2 ',
     &         'not implemented em=co,sp=',em,sp
          stop
       endif







      elseif(generator.eq.5.and.phasespace.eq.1)then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of real-correction amplitudes with an incoming gluon (1)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         call whzhMat2gluon_in1(kmcms,m2i_iphot)
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"

         i1=0
         pdf1l(i1)=pdf1(0)
         do i2=-4,4
         if (i2.ne.0) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0_inglu1.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
         endif
         enddo



      elseif(generator.eq.5.and.phasespace.ne.1)then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in real corrections with an incoming gluon (1)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     em=co here!
         if (em.eq.3.and.sp.eq.2) then
            print *,'x(em.eq.3.and.sp.eq.2)'
         elseif (em.eq.4.and.sp.eq.2) then
            print *,'x(em.eq.4.and.sp.eq.2)'
         elseif ((em.eq.6.and.shtr.eq.0.or.em.eq.7.and.shtr.gt.0)
     &           .and.sp.eq.2) then
            call whzhMat2born(kmcms,m2i0,0,qhvv)
#include "whzh_crosssection/setzero_m2pdfpdftt_0_em_sp.F"

            i1=0
            pdf1l(i1)=pdf1(0)
            do i2=-4,4
            if (i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiitt_0_em_sp.F"
               do j3=1,4
                  i6 = sign(j3,i2)
                  if ((selprocess.eq.1.and.
     &                 (abs(-qparton(i6)+qparton(i2)-1d0).lt.1d-10)).or.
     &                 (selprocess.eq.2.and.
     &                 (abs(-qparton(i6)+qparton(i2)+1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(-qparton(i6)+qparton(i2)).lt.1d-10).and.
     &                 i2.eq.i6)) then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_inglu1_i6.F"
                  endif
               enddo
#include "whzh_crosssection/calculate_m2pdfpdftt_0_em_sp.F"
            endif
            enddo



       else
          write(*,*) 'program stopped'
          write(*,*) 'crosssection: ingl1 ',
     &         'not implemented em=co,sp=',em,sp
          stop

       endif







      elseif(generator.eq.6.and.phasespace.eq.1)then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of real-correction amplitudes with an incoming gluon (2)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         call whzhMat2gluon_in2(kmcms,m2i_iphot)
#include "whzh_crosssection/setzero_m2pdfpdf_0.F"

         i2=0
         pdf2l(i2)=pdf2(0)
         do i1=-4,4
         if (i1.ne.0) then
#include "whzh_crosssection/calculate_m2pdfpdfii_0_inglu2.F"
#include "whzh_crosssection/calculate_m2pdfpdf_0.F"
         endif
         enddo




      elseif(generator.eq.6.and.phasespace.ne.1)then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in real corrections with an incoming gluon (2)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c em=co here!

         if (em.eq.3.and.sp.eq.1) then
            print *, 'x(em.eq.3.and.sp.eq.1)'
         elseif (em.eq.4.and.sp.eq.1) then
            print *,'x(em.eq.4.and.sp.eq.1)'
         elseif ((em.eq.6.and.shtr.eq.0.or.em.eq.7.and.shtr.gt.0)
     &           .and.sp.eq.1) then
            call whzhMat2born(kmcms,m2i0,0,qhvv)
#include "whzh_crosssection/setzero_m2pdfpdftt_0_em_sp.F"

            i2=0
            pdf2l(i2)=pdf2(0)
            do i1=-4,4
            if (i1.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiitt_0_em_sp.F"
               do j3=1,4
                  i6 = sign(j3,i1)
                  if ((selprocess.eq.1.and.
     &                 (abs(-qparton(i6)+qparton(i1)-1d0).lt.1d-10)).or.
     &                 (selprocess.eq.2.and.
     &                 (abs(-qparton(i6)+qparton(i1)+1d0).lt.1d-10)).or.
     &                 ((selprocess.eq.3.or.selprocess.eq.4).and.
     &                 (abs(-qparton(i6)+qparton(i1)).lt.1d-10).and.
     &                 i1.eq.i6)) then
#include "whzh_crosssection/calculate_m2pdfpdfiitt_0_inglu2_i6.F"
                  endif
               enddo
#include "whzh_crosssection/calculate_m2pdfpdftt_0_em_sp.F"
            endif
            enddo
         else
            write(*,*) 'program stopped'
            write(*,*) 'crosssection: ingl2 ',
     &           'not implemented em=co,sp=',em,sp
            stop
         endif



      elseif(generator.eq.7)then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in convolution contributions with an incoming lepton (1)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

cccccccccccccccccccccccccccccccccccccccccccccccc
c  gamma -> f f* integrated subtraction terms  c
cccccccccccccccccccccccccccccccccccccccccccccccc
#include "whzh_crosssection/setzero_m2i_ilep.F"
         call whzhMat2lepton_in1(kmcms,m2i_ilep,0)
#include "whzh_crosssection/setzero_m2pdfpdflq_0_em_sp.F"
         i1=0
         pdf1l(i1)=pdf_phot1
         if (selprocess.eq.1) then
            i6p = 11
            i6 = 1
         else if (selprocess.eq.2) then
            i6p = -11
            i6 = -1
         endif

         do i2=-4,4
            if (i2.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiilq_0_em_sp.F"
               if ((selprocess.eq.1.and.qparton(i2).gt.0d0).or.
     &              (selprocess.eq.2.and.qparton(i2).lt.0d0)) then
#include "whzh_crosssection/calculate_m2pdfpdfiilq_0_inlept1_i6.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdflq_0_em_sp.F"
            endif
         enddo



      elseif(generator.eq.8)then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  calculation of tree-level amplitudes needed for dipoles in convolution contributions with an incoming lepton (2)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

cccccccccccccccccccccccccccccccccccccccccccccccc
c  gamma -> f f* integrated subtraction terms  c
cccccccccccccccccccccccccccccccccccccccccccccccc
#include "whzh_crosssection/setzero_m2i_ilep.F"
         call whzhMat2lepton_in2(kmcms,m2i_ilep,0)
#include "whzh_crosssection/setzero_m2pdfpdfql_0_em_sp.F"
         i2=0
         pdf2l(i2)=pdf_phot2
         if (selprocess.eq.1) then
            i6p = 11
            i6 = 1
         else if (selprocess.eq.2) then
            i6p = -11
            i6 = -1
         endif

         do i1=-4,4
            if (i1.ne.0) then
#include "whzh_crosssection/setzero_m2pdfpdfiiql_0_em_sp.F"
               if ((selprocess.eq.1.and.qparton(i1).gt.0d0).or.
     &              (selprocess.eq.2.and.qparton(i1).lt.0d0)) then
#include "whzh_crosssection/calculate_m2pdfpdfiiql_0_inlept2_i6.F"
               endif
#include "whzh_crosssection/calculate_m2pdfpdfql_0_em_sp.F"
            endif
         enddo
      endif
      end
