************************************************************************
        subroutine whzhMat2photon_in1(p,m2i_phot)
************************************************************************
*       squared amplitudes for 
*	photon(p1) + q(p2)    --> lbar(p3) + l'(p4)    + H(p5) + q'(p6)
*	photon(p1) + qbar(p2) --> l(p3)    + l'bar(p4) + H(p5) + q'bar(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2photq(5,5),m2photqbar(5,5)
        real*8 m2i_phot(-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	if ((qschan.ne.1).or.(qtchan.ne.1)) then
	  write(*,*) 'Separation of s/t channels not gauge invariant'
	  write(*,*) 'for photon-induced processes!'
	  write(*,*) '-> Only qschan=qtchan=1 possible in this case.'
	  stop
	endif

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	  m2photq(i1,i2)    = 0d0
	  m2photqbar(i1,i2) = 0d0
100	continue

	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1
	do i1=0,3
	  k(3,i1) = p(3,i1) 
	  k(4,i1) = p(4,i1) 
	  k(5,i1) = p(5,i1)   
	  k(6,i1) = p(1,i1)   
	enddo

c a-q --> lbar-l-q
	dir(1) = +1
	dir(2) = -1
	do i1=0,3
	  k(1,i1) = p(6,i1) 
	  k(2,i1) = p(2,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_phot(k,m2photq,1,2,3,4)

c a-qbar --> l-lbar-qbar
	dir(1) = -1
	dir(2) = +1
	do i1=0,3
	  k(1,i1) = p(2,i1) 
	  k(2,i1) = p(6,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_phot(k,m2photqbar,1,2,3,4)

c add final states for fixed initial states
        do 200 i2=1,4
          m2i_phot( i2) = 0d0
          m2i_phot(-i2) = 0d0
        do 300 i1=1,4
          m2i_phot(i2) = m2i_phot(i2) + m2photq(i1,i2)
          m2i_phot(-i2) = m2i_phot(-i2) + m2photqbar(i2,i1)
300     continue
200     continue

	end

************************************************************************
        subroutine whzhMat2photon_in2(p,m2i_phot)
************************************************************************
*       squared amplitudes for 
*	qbar(p1) + photon(p2)  --> lbar(p3) + l'(p4)    + H(p5) + q'bar(p6)
*	q(p1)    + photon(p2)  --> l(p3)    + l'bar(p4) + H(p5) + q'(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2photq(5,5),m2photqbar(5,5)
        real*8 m2i_phot(-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	if ((qschan.ne.1).or.(qtchan.ne.1)) then
	  write(*,*) 'Separation of s/t channels not gauge invariant'
	  write(*,*) 'for photon-induced processes!'
	  write(*,*) '-> Only qschan=qtchan=1 possible in this case.'
	  stop
	endif

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	  m2photq(i1,i2)    = 0d0
	  m2photqbar(i1,i2) = 0d0
100	continue

	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1
	do i1=0,3
	  k(3,i1) = p(3,i1) 
	  k(4,i1) = p(4,i1) 
	  k(5,i1) = p(5,i1)   
	  k(6,i1) = p(2,i1)   
	enddo

c q-a --> lbar-l-q
	dir(1) = +1
	dir(2) = -1
	do i1=0,3
	  k(1,i1) = p(6,i1) 
	  k(2,i1) = p(1,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_phot(k,m2photq,1,2,3,4)

c qbar-a --> l-lbar-qbar
	dir(1) = -1
	dir(2) = +1
	do i1=0,3
	  k(1,i1) = p(1,i1) 
	  k(2,i1) = p(6,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_phot(k,m2photqbar,1,2,3,4)

c add final states for fixed initial states
        do 200 i1=1,4
          m2i_phot( i1) = 0d0
          m2i_phot(-i1) = 0d0
        do 300 i2=1,4
          m2i_phot(i1) = m2i_phot(i1) + m2photq(i2,i1)
          m2i_phot(-i1) = m2i_phot(-i1) + m2photqbar(i1,i2)
300     continue
200     continue

	end

************************************************************************
        subroutine whzhMat2photon_out(p,m2i_phot)
************************************************************************
*       squared amplitudes for 
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5) + photon(p6)
*-----------------------------------------------------------------------
*       10.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6),k(6,0:3)
	real*8 m2aqq_phot(5,5),m2qaq_phot(5,5)
        real*8 m2i_phot(-5:5,-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	dir(1) = -1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = +1
	do i1=0,3
	  k(3,i1) = p(3,i1) 
	  k(4,i1) = p(4,i1) 
	  k(5,i1) = p(5,i1)   
	  k(6,i1) = p(6,i1)   
	enddo

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	  m2aqq_phot(i1,i2)  = 0d0
	  m2qaq_phot(i1,i2)  = 0d0
100	continue

c qbar-q --> qbar-q
	do i1=0,3
	  k(1,i1) = p(1,i1) 
	  k(2,i1) = p(2,i1) 
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_phot(k,m2aqq_phot,1,2,3,4)

c q-qbar --> q-qbar
	do i1=0,3
	  k(1,i1) = p(2,i1) 
	  k(2,i1) = p(1,i1) 
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_phot(k,m2qaq_phot,1,2,3,4)

c add final states for fixed initial states
        do 200 i1=1,4
        do 200 i2=1,4
          m2i_phot(-i1,i2) = m2aqq_phot(i1,i2)
          m2i_phot(i1,-i2) = m2qaq_phot(i2,i1)
300     continue
200     continue

	end

************************************************************************
        subroutine whzhMat2aqq_phot(p,m2aqq_phot,q1,q2,q3,q4)
************************************************************************
*       squared amplitudes for 
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5) + photon(p6)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 mats,matt,wmats,wmatt
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 guu,gdd,gnn,gll     
        complex*16 msHWW4fa(-1:1),msHZZ4fa(-1:1,-1:1,-1:1)
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6),m2aqq_phot(5,5)
	integer q1,q2,q3,q4,selprocess
	integer ia,i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/prods4/sp,csp,vp
        common/selprocess/selprocess

	el8 = el**8

c qbar-q scattering
c
c   s-channel:                     
c
c   fa(p1) \_          / fd(p3)   
c          |\        |/           
c            \       /-           
c             *vvvvv*             
c           _/       \            
c           /|        \|          
c   fb(p2) /          -\ fc(p4)   

        if (selprocess.eq.2) then

c Type: ubar-d -> nbar l-
c------------------------

c ubar-d -W-> cbar-s     (k1->-p1,k2->-p2,k3->p4,k4->p3)   
c-------------------

	call M_WW_phot(msHWW4fa,qu,qd,ql,qn,q1,q2,q4,q3)    

c*** individual channels
	do 200 ia=-1,1,2
 	do 200 g1=1,2
 	do 200 g2=1,2
 	  wmats  = cv(g1,g2)*msHWW4fa(ia)
 	  f1 = 2*g1
 	  f2 = 2*g2-1
 	  m2aqq_phot(f1,f2) = m2aqq_phot(f1,f2) + el8*(
     &		+ qch2*3d0*abs(wmats)**2 )
200	continue

        elseif (selprocess.eq.1) then

c Type: dbar-u -> l+ n  
c---------------------

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	call M_WW_phot(msHWW4fa,qn,ql,qd,qu,q4,q3,q1,q2)    

	do 205 ia=-1,1,2
 	do 205 g1=1,2
 	do 205 g2=1,2
 	  wmats = v(g2,g1)*msHWW4fa(ia)
 	  f1 = 2*g1-1
 	  f2 = 2*g2
 	    m2aqq_phot(f1,f2) = m2aqq_phot(f1,f2) + el8*(
     &		+ qch2*3d0*abs(wmats)**2 )
205	continue

        elseif (selprocess.eq.3) then

c Type: ubar-u -> l+l-  
c---------------------

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	call M_ZZ_phot(msHZZ4fa,qu,ql,guu,gll,q1,q2,q4,q3)

	do 202 i2=-1,1,2
	do 202 i3=-1,1,2
	do 202 ia=-1,1,2
 	  mats = msHZZ4fa(i2,i3,ia)
 	  m2aqq_phot(2,2) = m2aqq_phot(2,2) + el8*qch2*3d0*abs(mats)**2 
202	continue
	  m2aqq_phot(4,4) = m2aqq_phot(2,2)

c Type: dbar-d -> l+l-  
c---------------------

c dbar-d -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
      	  call M_ZZ_phot(msHZZ4fa,qd,ql,gdd,gll,q1,q2,q4,q3)

	do 203 i2=-1,1,2
	do 203 i3=-1,1,2
	do 203 ia=-1,1,2
	  mats = msHZZ4fa(i2,i3,ia)
	  m2aqq_phot(1,1) = m2aqq_phot(1,1) + el8*qch2*3d0*abs(mats)**2 
203	continue
	  m2aqq_phot(3,3) = m2aqq_phot(1,1)

        elseif (selprocess.eq.4) then

c Type: ubar-u -> anti-nu_l nu_l
c------------------------------- 

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
     	call M_ZZ_phot(msHZZ4fa,qu,qn,guu,gnn,q1,q2,q4,q3)

	do 201 i2=-1,1,2
	do 201 i3=-1,1,2
	do 201 ia=-1,1,2
	  mats = msHZZ4fa(i2,i3,ia)
	  m2aqq_phot(2,2) = m2aqq_phot(2,2) + el8*qch2*3d0*abs(mats)**2 
201	continue
	  m2aqq_phot(4,4) = m2aqq_phot(2,2) 

c Type: dbar-d -> anti-nu_l nu_l
c-------------------------------

c dbar-d -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
     	call M_ZZ_phot(msHZZ4fa,qd,qn,gdd,gnn,q1,q2,q4,q3)

	do 204 i2=-1,1,2
	do 204 i3=-1,1,2
	do 204 ia=-1,1,2
	  mats = msHZZ4fa(i2,i3,ia)
          m2aqq_phot(1,1) = m2aqq_phot(1,1) + el8*qch2*3d0*abs(mats)**2 
204	continue
          m2aqq_phot(3,3) = m2aqq_phot(1,1) 

	endif

	end

************************************************************************
        subroutine whzhMat2gluon_in1(p,m2i_gluon)
************************************************************************
*       squared amplitudes for 
*	gluon(p1) + q(p2)    --> lbar(p3) + l'(p4)    + H(p5) + q'(p6)
*	gluon(p1) + qbar(p2) --> l(p3)    + l'bar(p4) + H(p5) + q'bar(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2gluonq(5,5),m2gluonqbar(5,5)
        real*8 m2i_gluon(-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	if ((qschan.ne.1).or.(qtchan.ne.1)) then
	  write(*,*) 'Separation of s/t channels not gauge invariant'
	  write(*,*) 'for gluon-induced processes!'
	  write(*,*) '-> Only qschan=qtchan=1 possible in this case.'
	  stop
	endif

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	  m2gluonq(i1,i2)    = 0d0
	  m2gluonqbar(i1,i2) = 0d0
100	continue

	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1
	do i1=0,3
	  k(3,i1) = p(3,i1) 
	  k(4,i1) = p(4,i1) 
	  k(5,i1) = p(5,i1)   
	  k(6,i1) = p(1,i1)   
	enddo

c a-q --> lbar-l-q
	dir(1) = +1
	dir(2) = -1
	do i1=0,3
	  k(1,i1) = p(6,i1) 
	  k(2,i1) = p(2,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_gluon(k,m2gluonq,1,2,3,4)

c a-qbar --> l-lbar-qbar
	dir(1) = -1
	dir(2) = +1
	do i1=0,3
	  k(1,i1) = p(2,i1) 
	  k(2,i1) = p(6,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_gluon(k,m2gluonqbar,1,2,3,4)

c add final states for fixed initial states
        do 200 i2=1,4
          m2i_gluon( i2) = 0d0
          m2i_gluon(-i2) = 0d0
        do 300 i1=1,4
          m2i_gluon(i2) = m2i_gluon(i2) + m2gluonq(i1,i2)
          m2i_gluon(-i2) = m2i_gluon(-i2) + m2gluonqbar(i2,i1)
300     continue
200     continue

	end

************************************************************************
        subroutine whzhMat2gluon_in2(p,m2i_gluon)
************************************************************************
*       squared amplitudes for 
*	qbar(p1) + gluon(p2)  --> lbar(p3) + l'(p4)    + H(p5) + q'bar(p6)
*	q(p1)    + gluon(p2)  --> l(p3)    + l'bar(p4) + H(p5) + q'(p6)
*-----------------------------------------------------------------------
*       22.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),k(6,0:3),vp(6,6)
        real*8 m2gluonq(5,5),m2gluonqbar(5,5)
        real*8 m2i_gluon(-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	if ((qschan.ne.1).or.(qtchan.ne.1)) then
	  write(*,*) 'Separation of s/t channels not gauge invariant'
	  write(*,*) 'for gluon-induced processes!'
	  write(*,*) '-> Only qschan=qtchan=1 possible in this case.'
	  stop
	endif

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	  m2gluonq(i1,i2)    = 0d0
	  m2gluonqbar(i1,i2) = 0d0
100	continue

	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = -1
	do i1=0,3
	  k(3,i1) = p(3,i1) 
	  k(4,i1) = p(4,i1) 
	  k(5,i1) = p(5,i1)   
	  k(6,i1) = p(2,i1)   
	enddo

c q-a --> lbar-l-q
	dir(1) = +1
	dir(2) = -1
	do i1=0,3
	  k(1,i1) = p(6,i1) 
	  k(2,i1) = p(1,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_gluon(k,m2gluonq,1,2,3,4)

c qbar-a --> l-lbar-qbar
	dir(1) = -1
	dir(2) = +1
	do i1=0,3
	  k(1,i1) = p(1,i1) 
	  k(2,i1) = p(6,i1)   
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_gluon(k,m2gluonqbar,1,2,3,4)

c add final states for fixed initial states
        do 200 i1=1,4
          m2i_gluon( i1) = 0d0
          m2i_gluon(-i1) = 0d0
        do 300 i2=1,4
          m2i_gluon(i1) = m2i_gluon(i1) + m2gluonq(i2,i1)
          m2i_gluon(-i1) = m2i_gluon(-i1) + m2gluonqbar(i1,i2)
300     continue
200     continue

	end

************************************************************************
        subroutine whzhMat2gluon_out(p,m2i_gluon)
************************************************************************
*       squared amplitudes for 
*	    parton1(p1) + parton2(p2) --> f(p3) + f'(p4) + H(p5) + gluon(p6)
*-----------------------------------------------------------------------
*       10.3.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 v,cv
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6),k(6,0:3)
	real*8 m2aqq_gluon(5,5),m2qaq_gluon(5,5)
        real*8 m2i_gluon(-5:5,-5:5)
	integer i1,i2,i3,i4,dir(6)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/prods4/sp,csp,vp
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

	dir(1) = -1
	dir(2) = -1
	dir(3) = +1
	dir(4) = +1
	dir(5) = +1
	dir(6) = +1
	do i1=0,3
	  k(3,i1) = p(3,i1) 
	  k(4,i1) = p(4,i1) 
	  k(5,i1) = p(5,i1)   
	  k(6,i1) = p(6,i1)   
	enddo

c*** initializations
	do 100 i1=1,4
	do 100 i2=1,4
	  m2aqq_gluon(i1,i2)  = 0d0
	  m2qaq_gluon(i1,i2)  = 0d0
100	continue

c qbar-q --> qbar-q
	do i1=0,3
	  k(1,i1) = p(1,i1) 
	  k(2,i1) = p(2,i1) 
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_gluon(k,m2aqq_gluon,1,2,3,4)

c q-qbar --> q-qbar
	do i1=0,3
	  k(1,i1) = p(2,i1) 
	  k(2,i1) = p(1,i1) 
	enddo
	call setprods4(k,dir)
	call whzhMat2aqq_gluon(k,m2qaq_gluon,1,2,3,4)

c add final states for fixed initial states
        do 200 i1=1,4
        do 200 i2=1,4
          m2i_gluon(-i1,i2) = m2aqq_gluon(i1,i2)
          m2i_gluon(i1,-i2) = m2qaq_gluon(i2,i1)
300     continue
200     continue

	end

************************************************************************
        subroutine whzhMat2aqq_gluon(p,m2aqq_gluon,q1,q2,q3,q4)
************************************************************************
*       squared amplitudes for 
*	    anti-q(p1) + q(p2) --> f(p3) + f'(p4) + H(p5) + gluon(p6)
*
*       from generic amplitudes for
*	    H(p) --> fa(k1) + anti-fb(k2) + fc(k3) + anti-fd(k4)
*	         CC: f1     + anti-f2     + f3     + anti-f4     
*	         NC: f1     + anti-f1     + f3     + anti-f3     
*	             f2     + anti-f2     + f3     + anti-f3     
*	             f1     + anti-f1     + f4     + anti-f4     
*
*	fermions: f1,f4 = generic   up-type fermions
*	          f2,f3 = generic down-type fermions
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 mats,matt,wmats,wmatt
	complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
	complex*16 guu,gdd,gnn,gll     
        complex*16 msHWW4fg1(-1:1),msHZZ4fg1(-1:1,-1:1,-1:1)
        complex*16 msHWW4fg2(-1:1),msHZZ4fg2(-1:1,-1:1,-1:1)
	complex*16 sp(6,6),csp(6,6)
        real*8 p(6,0:3),vp(6,6),m2aqq_gluon(5,5)
	integer q1,q2,q3,q4,selprocess
	integer ia,i1,i2,i3,i4,j,j1,j2,f1,f2,f3,f4,g1,g2,g3,g4
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        integer qhvv

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &			 qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/qf/qu,qd,ql,qn,qf(4),mu,mu2,md,md2,mlep,mlep2,
     &            guu(-1:1),gdd(-1:1),gnn(-1:1),gll(-1:1)
        common/prods4/sp,csp,vp
        common/selprocess/selprocess
        common/hvv/rsm,d,db,dt,dtb,lambdahvv,
     &             a1hww,a2hww,a3hww,a1haa,a2haa,a3haa,
     &             a1haz,a2haz,a3haz,a1hzz,a2hzz,a3hzz,qhvv

        gs2el6 = el**6*4d0*pi*alphas

c qbar-q scattering
c
c   s-channel:                     
c
c   fa(p1) \_          / fd(p3)   
c          |\        |/           
c            \       /-           
c             *vvvvv*             
c           _/       \            
c           /|        \|          
c   fb(p2) /          -\ fc(p4)   

        if (selprocess.eq.2) then

c Type: ubar-d -> nbar l-
c------------------------

c ubar-d -W-> cbar-s     (k1->-p1,k2->-p2,k3->p4,k4->p3)   
c-------------------

	call M_WW_gluon(msHWW4fg1,msHWW4fg2,q1,q2,q4,q3,qhvv)    

c*** individual channels
	do 200 ia=-1,1,2
 	do 200 g1=1,2
 	do 200 g2=1,2
 	  wmats  = cv(g1,g2)*msHWW4fg1(ia)
 	  f1 = 2*g1
 	  f2 = 2*g2-1
 	  m2aqq_gluon(f1,f2) = m2aqq_gluon(f1,f2) 
     &	                       + gs2el6*qch2*4d0*abs(wmats)**2 
200	continue


        elseif (selprocess.eq.1) then

c Type: dbar-u -> l+ n  
c---------------------

c dbar-u -W-> sbar-c    (k3->-p1,k4->-p2,k1->p4,k2->p3)   
	call M_WW_gluon(msHWW4fg1,msHWW4fg2,q4,q3,q1,q2,qhvv)    

	do 205 ia=-1,1,2
 	do 205 g1=1,2
 	do 205 g2=1,2
 	  wmats = v(g2,g1)*msHWW4fg2(ia)
 	  f1 = 2*g1-1
 	  f2 = 2*g2
 	    m2aqq_gluon(f1,f2) = m2aqq_gluon(f1,f2) 
     &		                 + gs2el6*qch2*4d0*abs(wmats)**2 
205	continue

        elseif (selprocess.eq.3) then

c Type: ubar-u -> l+l-  
c---------------------

c ubar-u -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
	call M_ZZ_gluon(msHZZ4fg1,msHZZ4fg2,
     &	                guu,gll,qu,ql,q1,q2,q4,q3,qhvv)

	do 202 i2=-1,1,2
	do 202 i3=-1,1,2
	do 202 ia=-1,1,2
 	  mats = msHZZ4fg1(i2,i3,ia)
 	  m2aqq_gluon(2,2) = m2aqq_gluon(2,2) 
     &	                     + gs2el6*qch2*4d0*abs(mats)**2 
202	continue
	  m2aqq_gluon(4,4) = m2aqq_gluon(2,2)

c Type: dbar-d -> l+l-  
c---------------------

c dbar-d -Z-> sbar-s  (k1->-p1,k2->-p2,k3->p4,k4->p3)
      	call M_ZZ_gluon(msHZZ4fg1,msHZZ4fg2,
     &	                gdd,gll,qd,ql,q1,q2,q4,q3,qhvv)

	do 203 i2=-1,1,2
	do 203 i3=-1,1,2
	do 203 ia=-1,1,2
	  mats = msHZZ4fg1(i2,i3,ia)
	  m2aqq_gluon(1,1) = m2aqq_gluon(1,1) 
     &	                     + gs2el6*qch2*4d0*abs(mats)**2 
203	continue
	  m2aqq_gluon(3,3) = m2aqq_gluon(1,1)

        elseif (selprocess.eq.4) then

c Type: ubar-u -> anti-nu_l nu_l
c------------------------------- 

c ubar-u -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
     	call M_ZZ_gluon(msHZZ4fg1,msHZZ4fg2,
     &	                guu,gnn,qu,qn,q1,q2,q4,q3,qhvv)

	do 201 i2=-1,1,2
	do 201 i3=-1,1,2
	do 201 ia=-1,1,2
	  mats = msHZZ4fg1(i2,i3,ia)
	  m2aqq_gluon(2,2) = m2aqq_gluon(2,2) 
     &	                     + gs2el6*qch2*4d0*abs(mats)**2 
201	continue
	  m2aqq_gluon(4,4) = m2aqq_gluon(2,2) 

c Type: dbar-d -> anti-nu_l nu_l
c-------------------------------

c dbar-d -Z-> cbar-c  (k1->-p1,k2->-p2,k3->p4,k4->p3)
     	call M_ZZ_gluon(msHZZ4fg1,msHZZ4fg2,
     &	                gdd,gnn,qd,qn,q1,q2,q4,q3,qhvv)

	do 204 i2=-1,1,2
	do 204 i3=-1,1,2
	do 204 ia=-1,1,2
	  mats = msHZZ4fg1(i2,i3,ia)
          m2aqq_gluon(1,1) = m2aqq_gluon(1,1) 
     &	                     + gs2el6*qch2*4d0*abs(mats)**2 
204	continue
          m2aqq_gluon(3,3) = m2aqq_gluon(1,1) 

	endif

	end

***********************************************************************
        subroutine whzhMat2lepton_in1(p,m2i0,qbcalc)
************************************************************************
*       Born structures needed for subtraction function for
*	photon-induced processes
*
*	  l(p1)    + q(p2)    --> l'(p3)    + q'(p4)    + H(p5) 
*	  lbar(p1) + q(p2)    --> l'bar(p3) + q'(p4)    + H(p5) 
*	  l(p1)    + qbar(p2) --> l'(p3)    + q'bar(p4) + H(p5) 
*	  lbar(p1) + qbar(p2) --> l'bar(p3) + q'bar(p4) + H(p5) 
*
*	Note: i1=+1/-1: l-/l+   and   i1=+2/-2: nu_l/anti-nu_l
*
*       qbcalc = 0/1: b-quarks ex-/in-cluded in evaluation
*-----------------------------------------------------------------------
*       25.11.11 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pws,pws12,pwt11,pwt22,pwt12,pwt21
        complex*16 pzs,pzs12,pzt11,pzt22,pzt12,pzt21
        real*8 p(6,0:3)
        real*8 m2aqq0ss(5,5),m2qaq0ss(5,5)
        real*8 m2qq0ss(5,5),m2aqaq0ss(5,5)
        real*8 m2i0(-5:5,-5:5)
        integer i1,i2,i3,i4,i,j,qb,qbcalc
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

      integer selprocess
      common/selprocess/selprocess

        data m2aqq0ss/25*0/

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
        e1   = p(3,0)
        e2   = p(4,0)
        cth1 = p(3,3)/p(3,0)
        cth2 = p(4,3)/p(4,0)
        if (p(1,3).lt.0d0) then
          cth1 = -cth1
          cth2 = -cth2
        endif
        sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
        sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
        if (cth1.gt.0d0) then
          c22th1 = (1d0+cth1)*.5d0
          s22th1 = sth1**2/(4d0*c22th1)
        else
          s22th1 = (1d0-cth1)*.5d0
          c22th1 = sth1**2/(4d0*s22th1)
        endif
        if (cth2.gt.0d0) then
          c22th2 = (1d0+cth2)*.5d0
          s22th2 = sth2**2/(4d0*c22th2)
        else
          s22th2 = (1d0-cth2)*.5d0
          c22th2 = sth2**2/(4d0*s22th2)
        endif

c invariants
        s    = 4d0*eb1*eb2
        t11  = -4d0*eb1*e1*s22th1
        t12  = -4d0*eb1*e2*s22th2
        t21  = -4d0*eb2*e1*c22th1
        t22  = -4d0*eb2*e2*c22th2
c        s12  = mh2-s+4d0*e1*eb1*s22th1+4d0*e1*eb2*c22th1
c     &             +4d0*e2*eb1*s22th2+4d0*e2*eb2*c22th2
        s12  = 2d0*( p(3,0)*p(4,0)-p(3,1)*p(4,1)
     &              -p(3,2)*p(4,2)-p(3,3)*p(4,3))

c propagators
        if(qwidth.eq.1) then
          pwt11 = 1d0/(t11-cmw2)
          pzt11 = 1d0/(t11-cmz2)
          pwt22 = 1d0/(t22-cmw2)
          pzt22 = 1d0/(t22-cmz2)
        else

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
            pwt11 = 1d0/(t11-mw2)
            pzt11 = 1d0/(t11-mz2)
          else
            pwt11 = 1d0/(t11-cmw2)
            pzt11 = 1d0/(t11-cmz2)
          endif

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s.lt.0d0))) then
            pwt22 = 1d0/(t22-mw2)
            pzt22 = 1d0/(t22-mz2)
          else
            pwt22 = 1d0/(t22-cmw2)
            pzt22 = 1d0/(t22-cmz2)
          endif

        endif

c*** initializations
       do 100 i1=1,5
       do 100 i2=1,5
         m2aqq0ss(i1,i2)  = 0d0
100    continue

        qb = qbcalc
        if ((qbini.eq.0).and.(qbfin.eq.0)) qb = 0
c>sk        print *, 'qbcalc = ',qbcalc,'   qb = ',qb

c l-q --> l-q
        call whzhMat2aqqborn(m2aqq0ss,
     &           t22,t11,t12,s,s12,t21,pwt22,pwt11,pzt22,pzt11,qb)
	if ((selprocess.eq.1).or.(selprocess.eq.3)) then
	  j = 1
	elseif ((selprocess.eq.2).or.(selprocess.eq.4)) then
	  j = 2
	endif
        do 300 i2=1,4+qbini
          m2i0(j,i2) = 0d0
        do 300 i1=1,4+qbini
          m2i0(j,i2) = m2i0(j,i2) + m2aqq0ss(i1,i2)
300     continue

c lbar-q --> lbar-q
        call whzhMat2aqqborn(m2aqq0ss,
     &           t22,t11,s12,t21,t12,s,pwt22,pwt11,pzt22,pzt11,qb)
	if ((selprocess.eq.2).or.(selprocess.eq.3)) then
	  j = -1
	elseif ((selprocess.eq.1).or.(selprocess.eq.4)) then
	  j = -2
	endif
        do 400 i2=1,4+qbini
          m2i0(j,i2) = 0d0
        do 400 i1=1,4+qbini
          m2i0(j,i2) = m2i0(j,i2) + m2aqq0ss(i1,i2)
400     continue

c l-qbar --> l-qbar
        call whzhMat2aqqborn(m2aqq0ss,
     &           t22,t11,s,t12,t21,s12,pwt22,pwt11,pzt22,pzt11,qb)
	if ((selprocess.eq.1).or.(selprocess.eq.3)) then
	  j = 1
	elseif ((selprocess.eq.2).or.(selprocess.eq.4)) then
	  j = 2
	endif
        do 500 i1=1,4+qbini
          m2i0(j,-i1) = 0d0
        do 500 i2=1,4+qbini
          m2i0(j,-i1) = m2i0(j,-i1) + m2aqq0ss(i1,i2)
500     continue

c lbar-qbar --> lbar-qbar
        call whzhMat2aqqborn(m2aqq0ss,
     &           t22,t11,t21,s12,s,t12,pwt22,pwt11,pzt22,pzt11,qb)
	if ((selprocess.eq.2).or.(selprocess.eq.3)) then
	  j = -1
	elseif ((selprocess.eq.1).or.(selprocess.eq.4)) then
	  j = -2
	endif
        do 600 i1=1,4+qbini
          m2i0(j,-i1) = 0d0
        do 600 i2=1,4+qbini
          m2i0(j,-i1) = m2i0(j,-i1) + m2aqq0ss(i1,i2)
600     continue

        end

***********************************************************************
        subroutine whzhMat2lepton_in2(p,m2i0,qbcalc)
************************************************************************
*       Born structures needed for subtraction function for
*	photon-induced processes
*
*	  q(p1)    + l(p2)    --> q'(p3)    + l'(p4)    + H(p5) 
*	  qbar(p1) + l(p2)    --> q'bar(p3) + l'(p4)    + H(p5) 
*	  q(p1)    + lbar(p2) --> q'(p3)    + l'bar(p4) + H(p5) 
*	  qbar(p1) + lbar(p2) --> q'bar(p3) + l'bar(p4) + H(p5) 
*
*	Note: i1=+1/-1: l-/l+   and   i1=+2/-2: nu_l/anti-nu_l
*
*       qbcalc = 0/1: b-quarks ex-/in-cluded in evaluation
*-----------------------------------------------------------------------
*       25.11.11 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 v,cv
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 pws,pws12,pwt11,pwt22,pwt12,pwt21
        complex*16 pzs,pzs12,pzt11,pzt22,pzt12,pzt21
        real*8 p(6,0:3)
        real*8 m2aqq0ss(5,5),m2qaq0ss(5,5)
        real*8 m2qq0ss(5,5),m2aqaq0ss(5,5)
        real*8 m2i0(-5:5,-5:5)
        integer i1,i2,i3,i4,i,j,qb,qbcalc
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

      integer selprocess
      common/selprocess/selprocess

        data m2aqq0ss/25*0/

c energies and angles
        eb1  = p(1,0)
        eb2  = p(2,0)
        e1   = p(3,0)
        e2   = p(4,0)
        cth1 = p(3,3)/p(3,0)
        cth2 = p(4,3)/p(4,0)
        if (p(1,3).lt.0d0) then
          cth1 = -cth1
          cth2 = -cth2
        endif
        sth1 = sqrt(p(3,1)**2+p(3,2)**2)/p(3,0)
        sth2 = sqrt(p(4,1)**2+p(4,2)**2)/p(4,0)
        if (cth1.gt.0d0) then
          c22th1 = (1d0+cth1)*.5d0
          s22th1 = sth1**2/(4d0*c22th1)
        else
          s22th1 = (1d0-cth1)*.5d0
          c22th1 = sth1**2/(4d0*s22th1)
        endif
        if (cth2.gt.0d0) then
          c22th2 = (1d0+cth2)*.5d0
          s22th2 = sth2**2/(4d0*c22th2)
        else
          s22th2 = (1d0-cth2)*.5d0
          c22th2 = sth2**2/(4d0*s22th2)
        endif

c invariants
        s    = 4d0*eb1*eb2
        t11  = -4d0*eb1*e1*s22th1
        t12  = -4d0*eb1*e2*s22th2
        t21  = -4d0*eb2*e1*c22th1
        t22  = -4d0*eb2*e2*c22th2
c        s12  = mh2-s+4d0*e1*eb1*s22th1+4d0*e1*eb2*c22th1
c     &             +4d0*e2*eb1*s22th2+4d0*e2*eb2*c22th2
        s12  = 2d0*( p(3,0)*p(4,0)-p(3,1)*p(4,1)
     &              -p(3,2)*p(4,2)-p(3,3)*p(4,3))

c propagators
        if(qwidth.eq.1) then
          pwt11 = 1d0/(t11-cmw2)
          pzt11 = 1d0/(t11-cmz2)
          pwt22 = 1d0/(t22-cmw2)
          pzt22 = 1d0/(t22-cmz2)
        else

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
            pwt11 = 1d0/(t11-mw2)
            pzt11 = 1d0/(t11-mz2)
          else
            pwt11 = 1d0/(t11-cmw2)
            pzt11 = 1d0/(t11-cmz2)
          endif

          if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s.lt.0d0))) then
            pwt22 = 1d0/(t22-mw2)
            pzt22 = 1d0/(t22-mz2)
          else
            pwt22 = 1d0/(t22-cmw2)
            pzt22 = 1d0/(t22-cmz2)
          endif

        endif

c*** initializations
       do 100 i1=1,5
       do 100 i2=1,5
         m2aqq0ss(i1,i2)  = 0d0
100    continue

        qb = qbcalc
        if ((qbini.eq.0).and.(qbfin.eq.0)) qb = 0
c>sk        print *, 'qbcalc = ',qbcalc,'   qb = ',qb

c q-l --> q-l
        call whzhMat2aqqborn(m2aqq0ss,
     &           t11,t22,t21,s,s12,t12,pwt11,pwt22,pzt11,pzt22,qb)
	if ((selprocess.eq.1).or.(selprocess.eq.3)) then
	  j = 1
	elseif ((selprocess.eq.2).or.(selprocess.eq.4)) then
	  j = 2
	endif
        do 300 i2=1,4+qbini
          m2i0(i2,j) = 0d0
        do 300 i1=1,4+qbini
          m2i0(i2,j) = m2i0(i2,j) + m2aqq0ss(i1,i2)
300     continue

c q-lbar --> q-lbar
        call whzhMat2aqqborn(m2aqq0ss,
     &           t11,t22,s12,t12,t21,s,pwt11,pwt22,pzt11,pzt22,qb)
	if ((selprocess.eq.2).or.(selprocess.eq.3)) then
	  j = -1
	elseif ((selprocess.eq.1).or.(selprocess.eq.4)) then
	  j = -2
	endif
        do 400 i2=1,4+qbini
          m2i0(i2,j) = 0d0
        do 400 i1=1,4+qbini
          m2i0(i2,j) = m2i0(i2,j) + m2aqq0ss(i1,i2)
400     continue

c qbar-l --> qbar-l
        call whzhMat2aqqborn(m2aqq0ss,
     &           t11,t22,s,t21,t12,s12,pwt11,pwt22,pzt11,pzt22,qb)
	if ((selprocess.eq.1).or.(selprocess.eq.3)) then
	  j = 1
	elseif ((selprocess.eq.2).or.(selprocess.eq.4)) then
	  j = 2
	endif
        do 500 i1=1,4+qbini
          m2i0(-i1,j) = 0d0
        do 500 i2=1,4+qbini
          m2i0(-i1,j) = m2i0(-i1,j) + m2aqq0ss(i1,i2)
500     continue

c qbar-lbar --> qbar-lbar
        call whzhMat2aqqborn(m2aqq0ss,
     &           t11,t22,t12,s12,s,t21,pwt11,pwt22,pzt11,pzt22,qb)
	if ((selprocess.eq.2).or.(selprocess.eq.3)) then
	  j = -1
	elseif ((selprocess.eq.1).or.(selprocess.eq.4)) then
	  j = -2
	endif
        do 600 i1=1,4+qbini
          m2i0(-i1,j) = 0d0
        do 600 i2=1,4+qbini
          m2i0(-i1,j) = m2i0(-i1,j) + m2aqq0ss(i1,i2)
600     continue

        end

