
#define PRINTWEIGHTMAX

***********************************************************************
      subroutine vbfh_integrand(random,ln,channel,generator,switch)
***********************************************************************
*     phase space integrand                                           *
*     adapted from COFFERGG by Markus Roth                            *
*                                                                     *
*     LOOPS OVER EMITTER AND SPECTATOR ASSUME UNCHARGED HIGGS!!!!     *
*                                                                     *
*---------------------------------------------------------------------*
*     21.02.06  Ansgar Denner     last changed  05.12.10              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

#ifdef multpdf
#include "multpdf.h"
      integer nset
#endif
c local variables
      real*8 random(3*maxe),rand1,rand2
      real*8 k(maxe,0:3),kbeam(2,0:3),xconv(2)
      real*8 fac(maxps),g(maxch,maxps),gsum(maxps)
c      real*8 wconv
      real*8 woaisr(maxps),woafsr,pf,f,p2,logs,krec(maxe,0:3),fp,fg
      real*8 sk(maxe,maxe),s(maxe,maxe,maxps),y,z,x,v,omz
      real*8 ck(0:3),ckt(0:3),omx,mapx,jacobianx,sfx(2),sfz,weighttot
      real*8 xd,omxd,sfxd(2),woaisrd(maxps),fpd,fgd
      real*8 xisr(maxps),omxisr(maxps),xdisr(maxps),omxdisr(maxps)
      real*8 fac1,fac2,p2b,lam1,lam2,pij,mi2,mj2,kk,kvec
      real*8 s12max,s12min,x1,x2,s12
c      real*8 pdf1,pdf2,pdf_phot1,pdf_phot2
c      real*8 qcdfacscale,qcdfacscale2,qedfacscale,qedfacscale2,
      real*8 tau0,tau,par,g1
      real*8 wfac,wfacg,wfacp
      real*8 dir(maxe)
      real*8 kcms(maxe,0:3),q(0:3),q1(0:3),ecms(maxe,maxps)
      real*8 dli2
      real*8 spp,shat,xminpl
      real*8 omz2,z2,aux,collfact,spk,collfact1
      integer generator,channel,switch,ln,cut(maxps),j
      integer phasespace,em,sp,co,cutall,last
      integer i1,i2,psflag

      data dir /-1d0,-1d0,maxf*1d0/
      data par /1d0/

c      real*8 test

      real*8 m2iendp(-4:4,-4:4)
      real*8 m2ifendp(-4:4,-4:4,-4:4,-4:4)

      real*8 constff,constfi,constif,constii
      common/constsub/constff,constfi,constif,constii

      integer iNumProcs,iMyRank
      common/mpistuff/iNumProcs,iMyRank

c      real*8 m2i(-4:4,-4:4)
c      real*8 m2if(-4:4,-4:4,-4:4,-4:4)
c      character*5 part(-4:4)


c use of random numbers
c random2 choice of proton direction
c random3 optimization of x1
c random4 optimization of x2
c random5 x1  parton energy fraction
c random6 x2  parton energy fraction
c random7 z   energy fraction after collinear photon emission
c (random8 (1-z) for exclusive final states)
c random9- (3*maxe)  (3*maxe-8) phase space variable for maxe-2
c                    final state particles [(3maxe - 10) needed]

c       write(*,*) 'integrand: generator = ',generator
c       write(*,*) 'integrand: random = ',random

 1050           format(1x,a22,": phasespace,weight = ",3i4,g24.10
     &              /4g24.10)
 1051           format(1x,a22,":            weight = ",4x,g24.10
     &              /3g24.10)

c initialize

      do iphsp=1,nphsp(generator)
c        m2pdfpdf_0(iphsp)=0d0
c        m2pdfpdf_vw(iphsp)=0d0
c        m2pdfpdf_vs(iphsp)=0d0

#ifdef SUBPROCESSES
c        do parton1 = -4,4
c        do parton2 = -4,4
c          m2pdfpdfii_0(iphsp,parton1,parton2)=0d0
c          m2pdfpdfii_vw(iphsp,parton1,parton2)=0d0
c          m2pdfpdfii_vs(iphsp,parton1,parton2)=0d0
c          do ext=1,nexternal(generator)
c          do ext1=1,nexternal(generator)
c            m2pdfpdfiiqq_0(iphsp,parton1,parton2,ext,ext1)=0d0
c            m2pdfpdfiitt_0(iphsp,parton1,parton2,ext,ext1)=0d0
c          enddo
c          enddo
c        enddo
c        enddo
#endif

        do ext=1,nextme(generator)
        do ext1=1,nextme(generator)
          m2pdfpdfqq_0(iphsp,ext,ext1)=0d0
          m2pdfpdftt_0(iphsp,ext,ext1)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+iphsp
        mm2pdfpdfqq_0(iref1,ext,ext1)=0d0
        mm2pdfpdftt_0(iref1,ext,ext1)=0d0
      enddo
#endif
        enddo
        enddo
        do icon=1,ncontr(generator)
          weight(icon,iphsp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
          mweight(nset,icon,iphsp)=0d0
      enddo
#endif
          rejectedcon(icon,iphsp)=0

#ifdef SUBPROCESSES
          do parton1 = -4,4
          do parton2 = -4,4
              weightii(icon,parton1,parton2,iphsp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
              mweightii(nset,icon,parton1,parton2,iphsp)=0d0
      enddo
#endif
            enddo
          enddo
#endif

        enddo
        gsum(iphsp)=0d0
c added AD 18.10.06
        cut(iphsp)=0
        do ext=1,maxe
        do vcomp=0,3
          pevent(ext,vcomp,iphsp)=0d0
        enddo
        enddo
      enddo

      weight_0=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
      mweight_0(nset)=0d0
      enddo
#endif
#ifdef SUBPROCESSES
      do parton1 = -4,4
      do parton2 = -4,4
        weightii_0(parton1,parton2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        mweightii_0(nset,parton1,parton2)=0d0
      enddo
#endif
      enddo
      enddo
#endif
      do ext=1,maxe
      do vcomp=0,3
        pborn(ext,vcomp)=0d0
      enddo
      enddo
      do icon=1,ncontr(generator)
        rejected(icon)=0
      enddo
c end initialize

c      write(*,*) 'integration endini',weight(1,1),nphsp(generator),
c     &    ncontr(generator)

 1200 format(a30,5e24.16)
 1202 format(a30,2i3,5e24.16)
 1203 format(a30,3i3,5e24.16)


c      write(*,*) 'generator: switch = ',switch,sconv(generator)
      if(switch.gt.0)return

c convolution with parton distributions
      if(sconv(generator).eq.1)then
        wconv=1d0
c vegas-like mapping for x1 and x2

c        write(*,*) 'integrand generator    ',generator
c        write(*,*) 'integrand use random(2)',random(2)
c        write(*,*) 'integrand use random(3)',random(3)
c        write(*,*) 'integrand use random(4)',random(4)
c        write(*,*) 'integrand use random(5)',random(5)
c        write(*,*) 'integrand use random(6)',random(6)

c        rand1=random(5)
c        rand2=random(6)
        call ranopt(random(3),random(5),rand1,wconv,ln,1,generator,
     &      switch)
        call ranopt(random(4),random(6),rand2,wconv,ln,2,generator,
     &      switch)
c        write(*,*) 'integrand: random   ',(random(i1),i1=2,6)

c        write(*,*) 'integrand redef rand1',rand1
c        write(*,*) 'integrand redef rand2',rand2

c        pdfmap=3
c        pdfmap=1
        if (pdfmap.eq.0) then
c     flat mapping for x1 and tau
          s12max=energy**2
          s12min=xmin(generator)*energy**2
          s12=s12min+(s12max-s12min)*rand2
          wconv=wconv*(s12max-s12min)

          if(random(2).le.0.5d0)then
            x1=s12/s12max+(1d0-s12/s12max)*rand1
            x2=s12/s12max/x1
            wconv=wconv/s12max/x1*(1d0-s12/s12max)
          else
            x2=s12/s12max+(1d0-s12/s12max)*rand1
            x1=s12/s12max/x2
            wconv=wconv/s12max/x2*(1d0-s12/s12max)
          endif

        else if (pdfmap.eq.1) then
c    flat mapping for x1 and tau
          tau0  = xmin(generator)
          tau   = tau0+rand2*(1d0-tau0)
          wconv = wconv*(1d0-tau0)
          if(random(2).le.0.5d0)then
            x1=tau+(1d0-tau)*rand1
            x2=tau/x1
            wconv=wconv/x1*(1d0-tau)
          else
            x2=tau+(1d0-tau)*rand1
            x1=tau/x2
            wconv=wconv/x2*(1d0-tau)
          endif

        else if (pdfmap.eq.2) then
c    preferred  mapping for x1 and tau of std
c    maps x1/tau
         tau0  = xmin(generator)
          tau   = tau0**rand2
          if(random(2).le.0.5d0)then
            x1=tau+(1d0-tau)*rand1
            x2=tau/x1
            wconv = -(wconv * tau*log(tau0)*(1d0-tau)/x1)
          else
            x2=tau+(1d0-tau)*rand1
            x1=tau/x2
            wconv = -(wconv * tau*log(tau0)*(1d0-tau)/x2)
          endif

        else if (pdfmap.eq.3) then
c    alternative mapping for x1 and tau of std
c    maps 1/tau and 1/x1
          tau0  = xmin(generator)
          if(shtr.gt.0)then
             tau0 =  max(xmin(generator)+ (mcm(25)*mcm(25)
     &          + mcm(25)*mcw(25)*tan(random(1)-.5d0))/energy**2,
     &          xmin(generator),1d-5)


          endif
          tau   = tau0**rand2
          if(random(2).le.0.5d0)then
            x1   = tau**rand1
            x2=tau/x1
            wconv = wconv * tau*log(tau0)*log(tau)
          else
            x2   = tau**rand1
            x1=tau/x2
            wconv = wconv * tau*log(tau0)*log(tau)
          endif

        else if (pdfmap.eq.4) then
c    mapping for x1 and tau for off-shell Higgs
          tau0  = xmin(generator)
c          tau   = tau0**rand2

          if(shtr.eq.0)then
            tau   = tau0**rand2
            if(random(2).le.0.5d0)then
              x1   = tau**rand1
              x2=tau/x1
              wconv = wconv * tau*log(tau0)*log(tau)
            else
              x2   = tau**rand1
              x1=tau/x2
              wconv = wconv * tau*log(tau0)*log(tau)
            endif
          elseif(mcw(25).lt.1d-6*mcm(25))then
            tau0 = max(tau0,mcm(25)*(mcm(25)-200*mcw(25))/energy**2)
            tau   = tau0**rand2
            if(random(2).le.0.5d0)then
              x1   = tau**rand1
              x2=tau/x1
              wconv = wconv * tau*log(tau0)*log(tau)
            else
              x2   = tau**rand1
              x1=tau/x2
              wconv = wconv * tau*log(tau0)*log(tau)
            endif
          else
            if(tau0*energy**2.gt.
     &                 mcm(25)*mcm(25)-par*mcm(25)*mcw(25))then
              tau=tau0**(1d0-rand2)
              wconv = -wconv * tau * log(tau0)
            else
              g1=mcm(25)*mcw(25)/energy**2*
     &            log((mcm(25)*mcm(25)-tau0*energy**2)/
     &            (par*mcm(25)*mcw(25)))
     &            + (mcm(25)*mcm(25)-par*mcm(25)*mcw(25))
     &            /(par*energy**2)*
     &            log(energy**2/(mcm(25)*mcm(25)-par*mcm(25)*mcw(25)))

              if(g1*rand2.gt.mcm(25)*mcw(25)/energy**2*
     &            log((mcm(25)*mcm(25)-tau0*energy**2)/
     &            (par*mcm(25)*mcw(25))))
     &            then
                tau = (mcm(25)*mcm(25)-par*mcm(25)*mcw(25))/(energy**2)
     &              *exp((g1*rand2-mcm(25)*mcw(25)/energy**2*
     &              log((mcm(25)*mcm(25)-tau0*energy**2)
     &              /(par*mcm(25)*mcw(25))))
     &              *par*energy**2
     &              /(mcm(25)*mcm(25)-par*mcm(25)*mcw(25)))
                wconv = wconv * g1 * par * tau * energy**2/
     &              (mcm(25)*mcm(25)-par*mcm(25)*mcw(25))
              else
                tau=1d0/(energy**2)*(mcm(25)*mcm(25)-
     &              (mcm(25)*mcm(25)-tau0*energy**2)
     &              *exp(-energy**2*g1*rand2/(mcm(25)*mcw(25))))
                wconv = wconv * g1 /( mcm(25)*mcw(25)) *
     &              (mcm(25)*mcm(25)-tau*energy**2)

              endif
            endif
            if(random(2).le.0.5d0)then
              x1   = tau**rand1
              x2=tau/x1
              wconv = -wconv * log(tau)
            else
              x2   = tau**rand1
              x1=tau/x2
              wconv = -wconv * log(tau)
            endif
          endif
        endif

c  adjustment of flux factor included in wconv
        wconv = wconv/tau

c        write(*,*) 'integrand: ran ',rand2,rand1
c        write(*,*) 'integrand: s12 ',s12,s12max,s12min
c        write(*,*) 'integrand: x   ',x1,x2,wconv

c  fixing of factorization scales
        call getqcdfacscale(mcm(24))
        call getqedfacscale(mcm(24))



#ifdef multpdf
        call wpdf(x1,qcdfacscale,shadin1,pdf1,mpdf1,
     &            pdf_phot1,mpdf_phot1,spdf)
        call wpdf(x2,qcdfacscale,shadin2,pdf2,mpdf2,
     &            pdf_phot2,mpdf_phot2,spdf)
#else
        call wpdf(x1,qcdfacscale,shadin1,pdf1,pdf_phot1,spdf)
        call wpdf(x2,qcdfacscale,shadin2,pdf2,pdf_phot2,spdf)
#endif
        xconv(1)=x1
        xconv(2)=x2


      else
        do i1=-4,4
          pdf1(i1) = 1d0
          pdf2(i1) = 1d0
        enddo
#ifdef multpdf
        do nset=1,pdfmemberto-pdfmemberfrom+1
          do i1=-4,4
            mpdf1(nset,i1) = 1d0
            mpdf2(nset,i1) = 1d0
            mpdf_phot1(nset) = 1d0
            mpdf_phot2(nset) = 1d0
          enddo
        enddo
#endif
        pdf_phot1 = 1d0
        pdf_phot2 = 1d0
        xconv(1)=1d0
        xconv(2)=1d0

        wconv=1d0
        call getqedfacscale(mcm(24))
        call getqcdfacscale(mcm(24))
      endif

c      write(*,*) 'integrand: conv',xconv,wconv
c       write(*,*) 'integrand xmin= ',xmin(generator),xconv(1)*xconv(2)

      xminp=xmin(generator)/(xconv(1)*xconv(2))
      xminpl=xminp
      if(ssub(0).gt.0) then
c finite xminpl not yet implemented for subtraction
        xminpl=0
      endif
c      xminpl=0d0
c      if(xmin(generator).ge.xconv(1)*xconv(2))return
c      write(*,*) 'montecarlo 1 ',xminp
      if(xminp.ge.1d0.or.xmin(generator).ge.xconv(1)*xconv(2))then
        cut(1)=1
        weight_0=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        mweight_0(nset)=0d0
      enddo
#endif
        do iphsp=1,nphsp(generator)
          weight(generator,iphsp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
          mweight(nset,generator,iphsp)=0d0
      enddo
#endif
        enddo

        write(*,*) 'integrand cut1 ',xminp,xmin(generator),
     &      xconv(1)*xconv(2),1d0-xminp,
     &      xconv(1)*xconv(2)-xmin(generator)

        return
      endif
c      write(*,*) 'montecarlo 2 ',xminp
c      write(*,*) 'integrand: after pdf, '

c end convolution with parton distributions

#ifdef PRINTWEIGHTMAX
         x1print=xconv(1)
         x2print=xconv(2)
#endif

c      write(*,*) 'integrand befcon',generator,sgen(generator)
c        write(*,*) 'integrand befcon',generator,sgen(generator),
c     &      freqgencon(generator,1),mod(nevt,freqgencon(generator,1))
c     &    ,nevt
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     tree-level process, virtual corrections, and                c
c     corresponding subtraction terms                             c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if(generator.eq.0.and.sgen(generator).ne.0)then
        if(ssub(generator).ne.0.or.ssli(generator).ne.0.or.
     &      seff(generator).ne.0.or.soaisr(generator).ne.0)then
          if(sexcl.eq.0)then
            nphsp(generator)=5
c           x = 1, x1, x2
          else
            nphsp(generator)=3*(nextgen(generator)-1)
          endif
        else
          nphsp(generator)=1
        endif
        ncontr(generator)=9

c local switches
c switch for lowest-order contributions
        lwborn(0)=swborn(0).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,1)).lt.iNumProcs
c switch for lowest-order contributions
        lgencon(0,1)=sgencon(0,1).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,1)).lt.iNumProcs
c switch for electroweak virtual corrections
        lgencon(0,2)=sgencon(0,2).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,2)).lt.iNumProcs
c switch for qcd virtual corrections
        lgencon(0,5)=sgencon(0,5).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,5)).lt.iNumProcs
c switch for photon convolution contributions
        lgencon(0,3)=sgencon(0,3).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,3)).lt.iNumProcs
c switch for gluon convolution contributions
        lgencon(0,4)=sgencon(0,4).eq.1.and.
     &        mod(nevt,iNumProcs*freqgencon(generator,4)).lt.iNumProcs
c switch for incoming photon convolution contributions
        lgencon(0,6)=sgencon(0,6).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,6)).lt.iNumProcs
        lgencon(0,7)=sgencon(0,7).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,7)).lt.iNumProcs
c switch for incoming gluon convolution contributions
        lgencon(0,8)=sgencon(0,8).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,8)).lt.iNumProcs
        lgencon(0,9)=sgencon(0,9).eq.1.and.
     &      mod(nevt,iNumProcs*freqgencon(generator,9)).lt.iNumProcs

c        write(*,*) 'integrand sgencon ',sgencon(0,3),lgencon(0,3)

        psflag=0


c generation of momenta and calculation of jacobians and crosssection
        do phasespace=1,nphsp(generator)
        if(phasespace.eq.1.and.(lwborn(0).or.lgencon(0,1)
     &        .or.lgencon(0,2).or.lgencon(0,5))
     &        .or.
     &        (phasespace.eq.2.or.phasespace.eq.3).and.
     &        (lgencon(0,3).or.lgencon(0,4))
     &        .or.
     &        (phasespace.eq.4.or.phasespace.eq.5).and.
     &        (lgencon(0,6).or.lgencon(0,7).or.
     &         lgencon(0,8).or.lgencon(0,9))
     &        )then


c        write(*,*) 'integrand psloop ',lgencon(0,3),phasespace


          do vcomp=0,3
            kbeam(1,vcomp)=xconv(1)*pbeam(1,vcomp)
            kbeam(2,vcomp)=xconv(2)*pbeam(2,vcomp)
          enddo
c          write(nout,*) ' integrand: xc  =',(xconv(vcomp),vcomp=1,2)
c          write(nout,*) ' integrand: pb1 =',(pbeam(1,vcomp),vcomp=0,3)
c          write(nout,*) ' integrand: pb2 =',(pbeam(2,vcomp),vcomp=0,3)
c          write(nout,*) ' integrand: kb1 =',(kbeam(1,vcomp),vcomp=0,3)
c          write(nout,*) ' integrand: kb2 =',(kbeam(2,vcomp),vcomp=0,3)

* part without collinear photon
          if(phasespace.eq.1)then
            em=0
            x=1d0
c            woaisr(phasespace)=1d0
            spp=xconv(1)*xconv(2)*energy*energy
* parts with collinear photons with energy fraction 1-x
          elseif(phasespace.eq.2.or.phasespace.eq.3) then
* maps 1/(1-x)^powersplitf     for incoming fermions
c CHANGED 16.11.06 AD
c            omx=mpinv(random(7),powersplitf,0d0,0d0,1d0,switch)
            em=phasespace-1
            if(1d0-xminpl.gt.omxmaxf)then

c              write(*,*) 'integrand use random(7)',random(7)

              omx=mapx(random(7),powersplitf,0d0,omxmaxf,1d0-xminpl,
     &            switch)
c           write(*,*) 'integrand x= ',omx,random(7),powersplitf
c     &           ,omxmaxf,1d0-xminpl
            else
              cut(phasespace)=1
            endif
            omxd=mapx(random(7),powersplitf,0d0,omxmaxf,1d0,switch)

            if(omx.eq.0d0.or.omxd.eq.0)then
              switch=27
              if(numout.lt.maxout.and.lnoutmc.ge.5)then
 100            format(/" event = ",i9,", gen = ",i4,", channel = ",i4,
     &              ", exit = ",i4,(a))
                write(nout,100) nevt,cogen,cocha,switch,
     &              ', integrand: x = 1'
                numout=numout+1
              endif
              return
            endif
c     CHANGED 16.11.06 AD
c     woaisr(phasespace)=jacobianinv(powersplitf,0d0,omx,0d0,
c     &          1d0,switch)
            if(cut(phasespace).eq.0)then
              woaisr(phasespace)=jacobianx(powersplitf,0d0,omx,omxmaxf,
     &            1d0-xminpl,switch)
c                write(*,*) 'integrand j= ',woaisr(phasespace)
              x=1d0-omx
              sfx(em)=(1d0+x*x)/omx
            endif
            do vcomp=0,3
              kbeam(em,vcomp)=x*kbeam(em,vcomp)
            enddo
            woaisrd(phasespace)=jacobianx(powersplitf,0d0,omxd,omxmaxf,
     &          1d0,switch)
            xd=1d0-omxd
            sfxd(em)=(1d0+xd*xd)/omxd


          elseif(phasespace.eq.4.or.phasespace.eq.5) then
* maps 1/(1-x)^powersplitp   for incoming gauge bosons
c CHANGED 16.11.06 AD
c            omx=mpinv(random(7),powersplitp,0d0,0d0,1d0,switch)
              em=phasespace-3
              if(1d0-xminpl.gt.omxmaxp)then
                omx=mapx(random(7),powersplitp,0d0,omxmaxp,1d0-xminpl,
     &              switch)
c                write(*,*) 'integrand x= ',omx,random(7),powersplitp
c     &           ,omxmaxp,1d0-xminpl
              else
                cut(phasespace)=1
              endif

            if(omx.eq.0d0)then
              switch=27
              if(numout.lt.maxout.and.lnoutmc.ge.5)then
                write(nout,100) nevt,cogen,cocha,switch,
c                write(*,'(" event= ",i9,",",(a))'),nevt,
     &              ' integrand: x = 1'
                numout=numout+1
              endif
c             mcexitevt(1,generator)=mcexitevt(1,generator)+1
              return
            endif
c     CHANGED 16.11.06 AD
c     woaisr(phasespace)=jacobianinv(powersplitp,0d0,omx,0d0,
c     &          1d0,switch)
            if(cut(phasespace).eq.0)then
              woaisr(phasespace)=jacobianx(powersplitp,0d0,omx,omxmaxp,
     &            1d0-xminpl,switch)
c                write(*,*) 'integrand j= ',woaisr(phasespace)
              x=1d0-omx
            endif
            do vcomp=0,3
              kbeam(em,vcomp)=x*kbeam(em,vcomp)
            enddo


          else
            write(*,*) 'integrand: phasespace not defined:',phasespace
            stop
          endif

#ifdef PRINTWEIGHTMAX
       xprint=x
       omxprint=omx
#endif


c          write(*,*) 'integrand afterxgen',phasespace,x,
c     &      x*xconv(1)*xconv(2),xmin(generator),cut(phasespace)

          if(x*xconv(1)*xconv(2).gt.xmin(generator)
     &        .and.cut(phasespace).eq.0
     &        )then
c          if(x.gt.xminp)then

            shat=x*xconv(1)*xconv(2)*energy*energy

            call generate_momenta(random(9),kbeam,k,kcms,
     &          g(1,phasespace),channel,generator,switch)


c            call generation(random(9),kbeam,k,g(1,phasespace),
c     &          channel,generator,switch)
c phase space point for testing
            if (em.eq.0)then
            endif

#ifdef PRINTWEIGHTMAX
            if(lprintweightmax)then
              do vcomp=0,3
                do ext=1,nextgen(generator)
                  pprint(ext,vcomp)=k(ext,vcomp)
                enddo
              enddo
            endif
#endif

c        write(*,*) ' integrand: k =',
c     &      ((k(ext,vcomp),ext=1,nextgen(generator)),vcomp=0,3)

c            write(*,*) 'integrand: g switch= ',switch,
c     &          channel,generator
            do ext=1,nextgen(generator)
               do vcomp=0,3
                  pevent(ext,vcomp,phasespace)=k(ext,vcomp)
                  if(phasespace.eq.1.and.swborn(generator).eq.1)then
                     pborn(ext,vcomp)=k(ext,vcomp)
                  endif
               enddo
            enddo


            call recombination(pbeam,k,krec,generator,
     &          nextgen(generator),cut(phasespace),switch)

            do ext=1,nextgen(generator)
               do vcomp=0,3
                  pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
                  if(phasespace.eq.1.and.swborn(generator).eq.1)then
                     pborn(ext,vcomp)=krec(ext,vcomp)
                  endif
               enddo
            enddo



c          write(*,*) 'integrand args ',
c     &      generator,nextgen(generator),cut(phasespace),switch
c            write(*,*) 'integrand: c switch= ',
c     &          switch,sexcl,cut(phasespace)

            cutall=cut(phasespace)

c "exclusive" subtraction terms
            if(sexcl.eq.1)then
              write(*,*) 'integrand: sexcl = 1 never used'
              write(*,*) 'integrand: check implementation!'
c not implemented, old code modified, change 'phasespaces'!!!!
              stop
              omz=mapx(random(8),powersplitf,0d0,0d0,1d0,switch)
              z=1d0-omz
              sfz=(1d0+z*z)/omz
              woafsr=jacobianx(powersplitf,0d0,omz,0d0,1d0,switch)
              do ext=3,nextgen(generator)
c                pf=qedfactor(ext,ext,generator)
c     &            +qcdfactor(ext,ext,generator)
                pf= mcalpha*factor(generator)
                if(pf.ne.0d0)then
c CHECK
c                  phasespace=3+em*(nextgen(generator)-2)+ext-2
                  em= (phasespace-3+2-ext)/(nextgen(generator)-2)
                  do ext2=1,nextgen(generator)
                  do vcomp=0,3
                    pevent(ext2,vcomp,phasespace)=k(ext2,vcomp)
                  enddo
                  enddo
                  do vcomp=0,3
                    pevent(ext,vcomp,phasespace)=z*k(ext,vcomp)
                    pevent(nextgen(generator)+1,vcomp,phasespace)=
     &                  (1d0-z)*k(ext,vcomp)
                  enddo
                  call recombination(pbeam,pevent(1,0,phasespace),
     &              krec,generator,nextgen(generator)+1,
     &              cut(phasespace),switch)
c check cutall
                  cutall=min(cutall,cut(phasespace))
                  do ext2=1,nextgen(generator)+1
                  do vcomp=0,3
                    if(cut(phasespace).eq.0)then
                      pevent(ext2,vcomp,phasespace)=krec(ext2,vcomp)
                    else
                      pevent(ext2,vcomp,phasespace)=0d0
                    endif
                  enddo
                  enddo
                endif
              enddo
            endif

c            write(*,*) 'integrand: d cutall= ',cutall,switch

            if(cutall.eq.0.and.switch.eq.0)then
              call density(k,g(1,phasespace),generator,switch)
              if(switch.eq.0)then
                do cha=1,nchannel(generator)
c ADDED for testing AD 6.04.06
                  gcha(cha,phasespace)=g(cha,phasespace)
                  gsum(phasespace)=gsum(phasespace)+g(cha,phasespace)
     &              *alphaopt(cha,opt(generator),generator)
                enddo
c ADDED for testing AD 6.04.06
                gsumm(phasespace)=gsum(phasespace)
                if(gsum(phasespace).eq.0d0)then
                  switch=28
                  if(numout.lt.maxout.and.lnoutmc.ge.5)then
                    write(nout,100) nevt,cogen,cocha,switch,
c                    write(*,'(" event= ",i9,",",(a))'),nevt,
     &                  ' integrand: gsum = 0'
                    numout=numout+1
                  endif
c                  mcexitevt(2,generator)=mcexitevt(2,generator)+1
                  return
                endif


#ifndef SYMEVENTS
                call crosssection(k,xconv(1),xconv(2),
     &              generator,phasespace,0,0,switch)


#endif
#ifdef SYMEVENTS
c SYMEVENTS not correct for distributions!
                if(phasespace.le.2.or.phasespace.eq.4)then
                  call crosssection(k,xconv(1),xconv(2),
     &                generator,phasespace,0,0,switch)
                  psflag=phasespace
                elseif (phasespace.eq.3) then
                  if(psflag.eq.2) then
                    if(lgencon(0,3))then
                      m2pdfpdfqq_0(3,2,1)=m2pdfpdfqq_0(2,2,1)
                      m2pdfpdfqq_0(3,3,1)=m2pdfpdfqq_0(2,3,1)
                      m2pdfpdfqq_0(3,4,1)=m2pdfpdfqq_0(2,4,1)
                      m2pdfpdfqq_0(3,3,2)=m2pdfpdfqq_0(2,3,2)
                      m2pdfpdfqq_0(3,4,2)=m2pdfpdfqq_0(2,4,2)
                      m2pdfpdfqq_0(3,4,3)=m2pdfpdfqq_0(2,4,3)
                      m2pdfpdfqq_0(3,1,2)=m2pdfpdfqq_0(2,1,2)
                      m2pdfpdfqq_0(3,1,3)=m2pdfpdfqq_0(2,1,3)
                      m2pdfpdfqq_0(3,1,4)=m2pdfpdfqq_0(2,1,4)
                      m2pdfpdfqq_0(3,2,3)=m2pdfpdfqq_0(2,2,3)
                      m2pdfpdfqq_0(3,2,4)=m2pdfpdfqq_0(2,2,4)
                      m2pdfpdfqq_0(3,3,4)=m2pdfpdfqq_0(2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+3
	     iref2=(nset-1)*maxps+2
        mm2pdfpdfqq_0(iref1,2,1)=mm2pdfpdfqq_0(iref2,2,1)
        mm2pdfpdfqq_0(iref1,3,1)=mm2pdfpdfqq_0(iref2,3,1)
        mm2pdfpdfqq_0(iref1,4,1)=mm2pdfpdfqq_0(iref2,4,1)
        mm2pdfpdfqq_0(iref1,3,2)=mm2pdfpdfqq_0(iref2,3,2)
        mm2pdfpdfqq_0(iref1,4,2)=mm2pdfpdfqq_0(iref2,4,2)
        mm2pdfpdfqq_0(iref1,4,3)=mm2pdfpdfqq_0(iref2,4,3)
        mm2pdfpdfqq_0(iref1,1,2)=mm2pdfpdfqq_0(iref2,1,2)
        mm2pdfpdfqq_0(iref1,1,3)=mm2pdfpdfqq_0(iref2,1,3)
        mm2pdfpdfqq_0(iref1,1,4)=mm2pdfpdfqq_0(iref2,1,4)
        mm2pdfpdfqq_0(iref1,2,3)=mm2pdfpdfqq_0(iref2,2,3)
        mm2pdfpdfqq_0(iref1,2,4)=mm2pdfpdfqq_0(iref2,2,4)
        mm2pdfpdfqq_0(iref1,3,4)=mm2pdfpdfqq_0(iref2,3,4)
      enddo
#endif
                      do i1=-4,4
                        do i2=-4,4
                          if(i1*i2.ne.0)then
                            m2pdfpdfiiqq_0(3,i1,i2,1,2)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,1,2)
                            m2pdfpdfiiqq_0(3,i1,i2,1,3)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,1,3)
                            m2pdfpdfiiqq_0(3,i1,i2,1,4)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,1,4)
                            m2pdfpdfiiqq_0(3,i1,i2,2,3)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,2,3)
                            m2pdfpdfiiqq_0(3,i1,i2,2,4)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,2,4)
                            m2pdfpdfiiqq_0(3,i1,i2,3,4)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,3,4)
                            m2pdfpdfiiqq_0(3,i1,i2,2,1)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,2,1)
                            m2pdfpdfiiqq_0(3,i1,i2,3,1)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,3,1)
                            m2pdfpdfiiqq_0(3,i1,i2,4,1)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,4,1)
                            m2pdfpdfiiqq_0(3,i1,i2,3,2)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,3,2)
                            m2pdfpdfiiqq_0(3,i1,i2,4,2)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,4,2)
                            m2pdfpdfiiqq_0(3,i1,i2,4,3)
     &                          =m2pdfpdfiiqq_0(2,i1,i2,4,3)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+3
	     iref2=(nset-1)*maxps+2
        mm2pdfpdfiiqq_0(iref1,i1,i2,1,2)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,1,2)
        mm2pdfpdfiiqq_0(iref1,i1,i2,1,3)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,1,3)
        mm2pdfpdfiiqq_0(iref1,i1,i2,1,4)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,1,4)
        mm2pdfpdfiiqq_0(iref1,i1,i2,2,3)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,2,3)
        mm2pdfpdfiiqq_0(iref1,i1,i2,2,4)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,2,4)
        mm2pdfpdfiiqq_0(iref1,i1,i2,3,4)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,3,4)
        mm2pdfpdfiiqq_0(iref1,i1,i2,2,1)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,2,1)
        mm2pdfpdfiiqq_0(iref1,i1,i2,3,1)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,3,1)
        mm2pdfpdfiiqq_0(iref1,i1,i2,4,1)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,4,1)
        mm2pdfpdfiiqq_0(iref1,i1,i2,3,2)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,3,2)
        mm2pdfpdfiiqq_0(iref1,i1,i2,4,2)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,4,2)
        mm2pdfpdfiiqq_0(iref1,i1,i2,4,3)
     &  =mm2pdfpdfiiqq_0(iref2,i1,i2,4,3)
      enddo
#endif
                          endif
                        enddo
                      enddo
                    endif
                    if(lgencon(0,4))then
                      m2pdfpdftt_0(3,2,1)=m2pdfpdftt_0(2,2,1)
                      m2pdfpdftt_0(3,3,1)=m2pdfpdftt_0(2,3,1)
                      m2pdfpdftt_0(3,4,1)=m2pdfpdftt_0(2,4,1)
                      m2pdfpdftt_0(3,3,2)=m2pdfpdftt_0(2,3,2)
                      m2pdfpdftt_0(3,4,2)=m2pdfpdftt_0(2,4,2)
                      m2pdfpdftt_0(3,4,3)=m2pdfpdftt_0(2,4,3)
                      m2pdfpdftt_0(3,1,2)=m2pdfpdftt_0(2,1,2)
                      m2pdfpdftt_0(3,1,3)=m2pdfpdftt_0(2,1,3)
                      m2pdfpdftt_0(3,1,4)=m2pdfpdftt_0(2,1,4)
                      m2pdfpdftt_0(3,2,3)=m2pdfpdftt_0(2,2,3)
                      m2pdfpdftt_0(3,2,4)=m2pdfpdftt_0(2,2,4)
                      m2pdfpdftt_0(3,3,4)=m2pdfpdftt_0(2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+3
	     iref2=(nset-1)*maxps+2
        mm2pdfpdftt_0(iref1,2,1)=mm2pdfpdftt_0(iref2,2,1)
        mm2pdfpdftt_0(iref1,3,1)=mm2pdfpdftt_0(iref2,3,1)
        mm2pdfpdftt_0(iref1,4,1)=mm2pdfpdftt_0(iref2,4,1)
        mm2pdfpdftt_0(iref1,3,2)=mm2pdfpdftt_0(iref2,3,2)
        mm2pdfpdftt_0(iref1,4,2)=mm2pdfpdftt_0(iref2,4,2)
        mm2pdfpdftt_0(iref1,4,3)=mm2pdfpdftt_0(iref2,4,3)
        mm2pdfpdftt_0(iref1,1,2)=mm2pdfpdftt_0(iref2,1,2)
        mm2pdfpdftt_0(iref1,1,3)=mm2pdfpdftt_0(iref2,1,3)
        mm2pdfpdftt_0(iref1,1,4)=mm2pdfpdftt_0(iref2,1,4)
        mm2pdfpdftt_0(iref1,2,3)=mm2pdfpdftt_0(iref2,2,3)
        mm2pdfpdftt_0(iref1,2,4)=mm2pdfpdftt_0(iref2,2,4)
        mm2pdfpdftt_0(iref1,3,4)=mm2pdfpdftt_0(iref2,3,4)
      enddo
#endif
                      do i1=-4,4
                        do i2=-4,4
                          if(i1*i2.ne.0)then
                            m2pdfpdfiitt_0(3,i1,i2,1,2)
     &                          =m2pdfpdfiitt_0(2,i1,i2,1,2)
                            m2pdfpdfiitt_0(3,i1,i2,1,3)
     &                          =m2pdfpdfiitt_0(2,i1,i2,1,3)
                            m2pdfpdfiitt_0(3,i1,i2,1,4)
     &                          =m2pdfpdfiitt_0(2,i1,i2,1,4)
                            m2pdfpdfiitt_0(3,i1,i2,2,3)
     &                          =m2pdfpdfiitt_0(2,i1,i2,2,3)
                            m2pdfpdfiitt_0(3,i1,i2,2,4)
     &                          =m2pdfpdfiitt_0(2,i1,i2,2,4)
                            m2pdfpdfiitt_0(3,i1,i2,3,4)
     &                          =m2pdfpdfiitt_0(2,i1,i2,3,4)
                            m2pdfpdfiitt_0(3,i1,i2,2,1)
     &                          =m2pdfpdfiitt_0(2,i1,i2,2,1)
                            m2pdfpdfiitt_0(3,i1,i2,3,1)
     &                          =m2pdfpdfiitt_0(2,i1,i2,3,1)
                            m2pdfpdfiitt_0(3,i1,i2,4,1)
     &                          =m2pdfpdfiitt_0(2,i1,i2,4,1)
                            m2pdfpdfiitt_0(3,i1,i2,3,2)
     &                          =m2pdfpdfiitt_0(2,i1,i2,3,2)
                            m2pdfpdfiitt_0(3,i1,i2,4,2)
     &                          =m2pdfpdfiitt_0(2,i1,i2,4,2)
                            m2pdfpdfiitt_0(3,i1,i2,4,3)
     &                          =m2pdfpdfiitt_0(2,i1,i2,4,3)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+3
	     iref2=(nset-1)*maxps+2
        mm2pdfpdfiitt_0(iref1,i1,i2,1,2)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,1,2)
        mm2pdfpdfiitt_0(iref1,i1,i2,1,3)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,1,3)
        mm2pdfpdfiitt_0(iref1,i1,i2,1,4)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,1,4)
        mm2pdfpdfiitt_0(iref1,i1,i2,2,3)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,2,3)
        mm2pdfpdfiitt_0(iref1,i1,i2,2,4)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,2,4)
        mm2pdfpdfiitt_0(iref1,i1,i2,3,4)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,3,4)
        mm2pdfpdfiitt_0(iref1,i1,i2,2,1)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,2,1)
        mm2pdfpdfiitt_0(iref1,i1,i2,3,1)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,3,1)
        mm2pdfpdfiitt_0(iref1,i1,i2,4,1)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,4,1)
        mm2pdfpdfiitt_0(iref1,i1,i2,3,2)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,3,2)
        mm2pdfpdfiitt_0(iref1,i1,i2,4,2)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,4,2)
        mm2pdfpdfiitt_0(iref1,i1,i2,4,3)
     &  =mm2pdfpdfiitt_0(iref2,i1,i2,4,3)
      enddo
#endif
                          endif
                        enddo
                      enddo
                    endif
                  else
                    call crosssection(k,xconv(1),xconv(2),
     &                  generator,phasespace,0,0,switch)
                  endif
                else if (phasespace.eq.5) then
                  if(psflag.eq.4) then
                    if(lgencon(0,7))then
                      m2pdfpdfq2_0(5,1)=m2pdfpdfq2_0(4,1)
                      m2pdfpdfq2_0(5,2)=m2pdfpdfq2_0(4,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+5
	     iref2=(nset-1)*maxps+4
        mm2pdfpdfq2_0(iref1,1)=mm2pdfpdfq2_0(iref2,1)
        mm2pdfpdfq2_0(iref1,2)=mm2pdfpdfq2_0(iref2,2)
      enddo
#endif
                      do i1=-4,4
                        do i2=-4,4
                          if(i1*i2.ne.0)then
                            m2pdfpdfiiq2_0(5,i1,i2,1)
     &                          =m2pdfpdfiiq2_0(4,i1,i2,1)
                            m2pdfpdfiiq2_0(5,i1,i2,2)
     &                          =m2pdfpdfiiq2_0(4,i1,i2,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+5
	     iref2=(nset-1)*maxps+4
        mm2pdfpdfiiq2_0(iref1,i1,i2,1)
     &  =mm2pdfpdfiiq2_0(iref2,i1,i2,1)
        mm2pdfpdfiiq2_0(iref1,i1,i2,2)
     &  =mm2pdfpdfiiq2_0(iref2,i1,i2,2)
      enddo
#endif
                          endif
                        enddo
                      enddo
                    endif
                    if(lgencon(0,9))then
                      m2pdfpdft2_0(5,1)=m2pdfpdft2_0(4,1)
                      m2pdfpdft2_0(5,2)=m2pdfpdft2_0(4,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+5
	     iref2=(nset-1)*maxps+4
        mm2pdfpdft2_0(iref1,1)=mm2pdfpdft2_0(iref2,1)
        mm2pdfpdft2_0(iref1,2)=mm2pdfpdft2_0(iref2,2)
      enddo
#endif
                      do i1=-4,4
                        do i2=-4,4
                          if(i1*i2.ne.0)then
                            m2pdfpdfiit2_0(5,i1,i2,1)
     &                          =m2pdfpdfiit2_0(4,i1,i2,1)
                            m2pdfpdfiit2_0(5,i1,i2,2)
     &                          =m2pdfpdfiit2_0(4,i1,i2,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
	     iref1=(nset-1)*maxps+5
	     iref2=(nset-1)*maxps+4
        mm2pdfpdfiit2_0(iref1,i1,i2,1)
     &  =mm2pdfpdfiit2_0(iref2,i1,i2,1)
        mm2pdfpdfiit2_0(iref1,i1,i2,2)
     &  =mm2pdfpdfiit2_0(iref2,i1,i2,2)
      enddo
#endif
                          endif
                        enddo
                      enddo
                    endif
                  else
                    call crosssection(k,xconv(1),xconv(2),
     &                  generator,phasespace,0,0,switch)
                  endif
                endif
                endif
#endif

                call dets(k,s(1,1,phasespace),nextgen(generator),
     &            switch)



                fac(phasespace)=0.5d0/pi/gsum(phasespace)*wconv


                if (phasespace.eq.1.and.ssli(generator).ne.0.and.
     &              (sgencon(generator,3).ne.0.or.
     &               sgencon(generator,4).ne.0.or.
     &               sgencon(generator,6).ne.0.or.
     &               sgencon(generator,7).ne.0.or.
     &               sgencon(generator,8).ne.0.or.
     &               sgencon(generator,9).ne.0)
     &              )
     &              then

c     boost momenta to cms
                  do i1=0,3
                    q(i1)=k(1,i1)+k(2,i1)
                  enddo


                  do ext=1,nextgen(generator)


                    do vcomp=0,3
                      q1(vcomp)=k(ext,vcomp)
                    enddo


                    call boost(shat,q,q1,1d0,switch)
                    do vcomp=0,3
                      kcms(ext,vcomp)=q1(vcomp)
                    enddo


                    ecms(ext,phasespace)=kcms(ext,0)
                  enddo
                endif
              endif
            endif
          else
            if(cut(phasespace).eq.0)then
              cut(phasespace)=1
            endif
          endif
          if (switch.gt.0) return


          xisr(phasespace)=x
          omxisr(phasespace)=omx
          xdisr(phasespace)=xd
          omxdisr(phasespace)=omxd
c          write(*,*) 'integrand x= ',phasespace,x
        endif
      enddo
c end generation of momenta and calculation of jacobians and crosssection
c (end loop over phasespaces)
c        write(*,*) 'integrand: b switch= ',switch,cut(1)

c        write(*,*) 'integrand befborn',switch,cut(1),
c     &    cut(2),cut(3),cut(4),cut(5)

c tree-level amplitude and virtual correction
        if(switch.eq.0)then

c          write(*,*) ' integrand: sborn(gen) = ',sborn(generator)
c     &        mod(nevt,freqgencon(generator,1))

          if(cut(1).eq.0)then
            if(sborn(generator).ne.0.and.
     &          mod(nevt,iNumProcs*freqgencon(generator,1)).lt.
     &              iNumProcs)then
              weight(1,1)=weight(1,1)+dble(isign(1,sborn(generator)))
     &            *m2pdfpdf_0(1)*wconv*factor(generator)/gsum(1)
     &            *freqgencon(generator,1)



#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
              mweight(nset,1,1)=mweight(nset,1,1)+
     &        dble(isign(1,sborn(generator)))
     &            *mm2pdfpdf_0(iref)*wconv*factor(generator)/gsum(1)
     &            *freqgencon(generator,1)
      enddo
#endif

c        write(*,*) 'integrand weightborn', weight(1,1)


#ifdef SUBPROCESSES
              do parton1=-5,5
              do parton2=-5,5
              if (parton1*parton2.ne.0) then
                weightii(1,parton1,parton2,1)
     &              =m2pdfpdfii_0(1,parton1,parton2)
     &              *wconv*factor(generator)/gsum(1)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweightii(nset,1,parton1,parton2,1)
     &              =mm2pdfpdfii_0(iref,parton1,parton2)
     &              *wconv*factor(generator)/gsum(1)
      enddo
#endif
 &              *freqgencon(generator,1)
              endif
              enddo
              enddo
c          write(*,*) ' integrand: born(gen) = ',born(0,1)
c          write(*,*) ' integrand: wconv     = ',wconv
c          write(*,*) ' integrand: factor    = ',factor(generator)
c          write(*,*) ' integrand: gsum(1)   = ',gsum(1)
c          write(*,*) ' integrand: born(gen) = ',born
#endif
            endif

            if(svirt(generator).ne.0)then
              if((sweak.ne.0.or.shh2.ne.0)
     &	        .and.mod(nevt,iNumProcs*freqgencon(generator,2)).lt.
     &                   iNumProcs)
     &            then
                weight(2,1)=weight(2,1)
     &              +m2pdfpdf_vw(1)*wconv*factor(generator)/gsum(1)
     &              *freqgencon(generator,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweight(nset,2,1)=mweight(nset,2,1)
     &              +mm2pdfpdf_vw(iref)*wconv*factor(generator)/gsum(1)
     &              *freqgencon(generator,2)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                    weightii(2,parton1,parton2,1)
     &                  =m2pdfpdfii_vw(1,parton1,parton2)
     &                  *wconv*factor(generator)/gsum(1)
     &                  *freqgencon(generator,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,2,parton1,parton2,1)
     &                  =mm2pdfpdfii_vw(iref,parton1,parton2)
     &                  *wconv*factor(generator)/gsum(1)
     &                  *freqgencon(generator,2)
      enddo
#endif
                  endif
                enddo
                enddo
#endif
              endif
              if(sqcd.ne.0.and.
     &           mod(nevt,iNumProcs*freqgencon(generator,5)).lt.
     &               iNumProcs)
     &            then
                weight(5,1)=weight(5,1)
     &              +m2pdfpdf_vs(1)*wconv*factor(generator)/gsum(1)
     &              *freqgencon(generator,5)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweight(nset,5,1)=mweight(nset,5,1)
     &              +mm2pdfpdf_vs(iref)*wconv*factor(generator)/gsum(1)
     &              *freqgencon(generator,5)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                    weightii(5,parton1,parton2,1)
     &                  =m2pdfpdfii_vs(1,parton1,parton2)
     &                  *wconv*factor(generator)/gsum(1)
     &                  *freqgencon(generator,5)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,5,parton1,parton2,1)
     &                  =mm2pdfpdfii_vs(iref,parton1,parton2)
     &                  *wconv*factor(generator)/gsum(1)
     &                  *freqgencon(generator,5)
      enddo
#endif
                  endif
                enddo
                enddo
#endif
              endif
            endif

            if(swborn(generator).ne.0.and.
     &          mod(nevt,iNumProcs*freqgencon(generator,1))
     &              .lt.iNumProcs)then
              weight_0=m2pdfpdf_0(1)*wconv*factor(generator)/gsum(1)
     &            *freqgencon(generator,1)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
              mweight_0(nset)=
     &        mm2pdfpdf_0(iref)*wconv*factor(generator)/gsum(1)
     &            *freqgencon(generator,1)
      enddo
#endif


#ifdef SUBPROCESSES
              do parton1=-5,5
                do parton2=-5,5
                  if (parton1*parton2.ne.0) then
                    weightii_0(parton1,parton2)
     &                  =m2pdfpdfii_0(1,parton1,parton2)
     &                  *wconv*factor(generator)/gsum(1)
     &                  *freqgencon(generator,1)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii_0(nset,parton1,parton2)
     &                  =mm2pdfpdfii_0(iref,parton1,parton2)
     &                  *wconv*factor(generator)/gsum(1)
     &                  *freqgencon(generator,1)
      enddo
#endif
                  endif
                enddo
              enddo
#endif
            endif

c          write(*,*) ' integrand: weight = ',weight(1,1),weight_0
c     &        ,wconv
c          write(*,*) ' integrand: weight(1) = ',born(0,2),wconv,
c     &        factor(generator),gsum(1)
          endif

c        write(*,*) 'integrand cut',cut(1)

          if(sborn(generator).ne.0)then
            rejectedcon(1,1)=cut(1)
            rejected(1)=cut(1)
          endif

c          write(*,*) 'integrand befvirtrej',svirt(generator)

          if(svirt(generator).ne.0)then
            rejectedcon(2,1)=cut(1)
            rejected(2)=cut(1)
            rejectedcon(5,1)=cut(1)
            rejected(5)=cut(1)

c            write(*,*) 'integrand rejvirt',rejected(2)

          endif
          if(swborn(generator).ne.0)then
            rejected_0=cut(1)

c            write(*,*) 'integrand cutb=',rejected_0

          endif
        endif

c subtraction terms

c       write(*,*) 'integrand: ssub ',ssub(generator),generator

        if(ssub(generator).ne.0.and.
     &      (lgencon(generator,3).or.lgencon(generator,4))
     &      .and.switch.eq.0) then
          if(cut(1).eq.0.or.cut(2).eq.0.or.cut(3).eq.0)then
c final-state emitter with final-state spectator
c          do em=3,nextgen(generator)
c          do sp=3,nextgen(generator)
c ADAPTED FOR UNCHARGED HIGGS
          do em=3,nextsub(generator)
          do sp=3,nextsub(generator)
          if(em.ne.sp)then
c            pf=qedfactor(em,sp,generator)+qcdfactor(em,sp,generator)
            pf= factor(generator)
            if(pf.ne.0d0)then
              if(ssub(generator).eq.1)then
                if(cut(1).eq.0)then
                  wfac=-pf*(1d0-pi2/3d0-const(em,sp))*fac(1)
c     &              -pf*0.5d0*fac(1)*(born(em,1)-born(0,1))

                  if(lgencon(0,3))then
                    wfacp=mcalpha*wfac*freqgencon(generator,3)
                    weight(3,1)=weight(3,1)+wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweight(nset,3,1)=mweight(nset,3,1)+
     &              wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    wfacg=mcalphas*wfac*freqgencon(generator,4)
                    weight(4,1)=weight(4,1)+wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweight(nset,4,1)=mweight(nset,4,1)+
     &              wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                  endif
#ifdef SUBPROCESSES
                  do parton1=-4,4
                  do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                    if(lgencon(0,3))then
                      weightii(3,parton1,parton2,1) =
     &                    weightii(3,parton1,parton2,1) +
     &                    wfacp*m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweightii(nset,3,parton1,parton2,1) =
     &                    weightii(3,parton1,parton2,1) +
     &                    wfacp*mm2pdfpdfiiqq_0(iref,parton1,parton2,em,
     &                    sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      weightii(4,parton1,parton2,1) =
     &                    weightii(4,parton1,parton2,1) +
     &                    wfacg*m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweightii(nset,4,parton1,parton2,1) =
     &                    weightii(4,parton1,parton2,1) +
     &                    wfacg*mm2pdfpdfiitt_0(iref,parton1,parton2,em,
     &                    sp)
      enddo
#endif
                    endif
                  endif
                  enddo
                  enddo
#endif
               endif
c "exclusive" subtraction terms
              elseif(ssub(generator).eq.2)then
                if(cut(1).eq.0)then
                  wfac = -pf*(2.5d0-2d0/3d0*pi2-const(em,sp))*fac(1)
c     &              -pf*0.5d0*fac(1)*(born(em,1)-born(0,1))
                  if(lgencon(0,3))then
                    wfacp=mcalpha*wfac*freqgencon(generator,3)
                    weight(3,1)=weight(3,1)+wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweight(nset,3,1)=mweight(nset,3,1)+
     &              wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    wfacg=mcalphas*wfac*freqgencon(generator,4)
                    weight(4,1)=weight(4,1)+wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweight(nset,4,1)=mweight(nset,4,1)+
     &              wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                  endif
#ifdef SUBPROCESSES
                  do parton1=-4,4
                  do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                    if(lgencon(0,3))then
                      weightii(3,parton1,parton2,1) =
     &                    weightii(3,parton1,parton2,1) +
     &                  wfacp*m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweightii(nset,3,parton1,parton2,1) =
     &                    weightii(3,parton1,parton2,1) +
     &                  wfacp*mm2pdfpdfiiqq_0(iref,parton1,parton2,em,
     &                  sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      weightii(4,parton1,parton2,1) =
     &                    weightii(4,parton1,parton2,1) +
     &                    wfacg*m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweightii(nset,4,parton1,parton2,1) =
     &                    weightii(4,parton1,parton2,1) +
     &                    wfacg*mm2pdfpdfiitt_0(iref,parton1,parton2,em,
     &                    sp)
      enddo
#endif
                    endif
                  endif
                  enddo
                  enddo
#endif
                endif
c "exclusive" subtraction terms
              endif
            endif
          endif
          enddo
          enddo

c final-state emitter with initial-state spectator
c          do em=3,nextgen(generator)
c ADAPTED FOR UNCHARGED HIGGS
          do em=3,nextsub(generator)
          do sp=1,2
          phasespace=sp+1
          x=xisr(phasespace)
          omx=omxisr(phasespace)
          xd=xdisr(phasespace)
          omxd=omxdisr(phasespace)
c          pf=(qedfactor(em,sp,generator)+qedfactor(em,sp,generator))
c     &        *woaisr(phasespace)
c minus sign from incoming*outgoing particles
          pf= -factor(generator) * woaisr(phasespace)
          if(pf.ne.0d0)then
            if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
              f=(2d0*dlog((2d0-x)/omx)-1.5d0)/omx
              if(cut(phasespace).eq.0)then
                wfac=-pf*f*fac(phasespace)/x
                if(lgencon(0,3))then
                  wfacp=mcalpha*wfac*freqgencon(generator,3)
                  weight(3,phasespace)=weight(3,phasespace)
     &              +wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweight(nset,3,phasespace)=mweight(nset,3,phasespace)
     &              +wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                endif
                if(lgencon(0,4))then
                  wfacg=mcalphas*wfac*freqgencon(generator,4)
                  weight(4,phasespace)=weight(4,phasespace)
     &              +wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweight(nset,4,phasespace)=mweight(nset,4,phasespace)
     &              +wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                endif
c                test=0d0
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  if(lgencon(0,3))then
                    weightii(3,parton1,parton2,phasespace) =
     &                  weightii(3,parton1,parton2,phasespace) +
     &                  wfacp*
     &                  m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweightii(nset,3,parton1,parton2,phasespace) =
     &                  weightii(3,parton1,parton2,phasespace) +
     &                  wfacp*
     &                  mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    weightii(4,parton1,parton2,phasespace) =
     &                  weightii(4,parton1,parton2,phasespace) +
     &                  wfacg*
     &                  m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
c                  test = test +
c     &                m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweightii(nset,4,parton1,parton2,phasespace) =
     &                  weightii(4,parton1,parton2,phasespace) +
     &                  wfacg*
     &                  mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
c                  test = test +
c     &                mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                endif
                enddo
                enddo
#endif
              endif
              if(cut(1).eq.0)then
                wfac=+pf*f*fac(1)
     &            -pf*fac(1)*(1d0-0.5d0*pi2-const(em,sp))
                if(lgencon(0,3))then
                  wfacp=mcalpha*wfac*freqgencon(generator,3)
                  weight(3,1)=weight(3,1)
     &                +wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                  mweight(nset,3,1)=mweight(nset,3,1)
     &                +wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                endif
                if(lgencon(0,4))then
                  wfacg=mcalphas*wfac*freqgencon(generator,4)
                  weight(4,1)=weight(4,1)
     &                +wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                  mweight(nset,4,1)=mweight(nset,4,1)
     &                +wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                    if(lgencon(0,3))then
                      weightii(3,parton1,parton2,1) =
     &                    weightii(3,parton1,parton2,1) +
     &                    wfacp*m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweightii(nset,3,parton1,parton2,1) =
     &                    weightii(3,parton1,parton2,1) +
     &                    wfacp*mm2pdfpdfiiqq_0(iref,parton1,parton2,em,
     &                    sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      weightii(4,parton1,parton2,1) =
     &                    weightii(4,parton1,parton2,1) +
     &                    wfacg*m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweightii(nset,4,parton1,parton2,1) =
     &                    weightii(4,parton1,parton2,1) +
     &                    wfacg*mm2pdfpdfiitt_0(iref,parton1,parton2,em,
     &                    sp)
      enddo
#endif
                    endif
                  endif
                enddo
                enddo
#endif
              endif
            endif
          endif
          enddo
          enddo

c initial-state emitter with final-state spectator
          do em=1,2
c          do sp=3,nextgen(generator)
c ADAPTED FOR UNCHARGED HIGGS
          do sp=3,nextsub(generator)
            phasespace=em+1
            x=xisr(phasespace)
            omx=omxisr(phasespace)
            xd=xdisr(phasespace)
            omxd=omxdisr(phasespace)
c          pf=(qedfactor(em,sp,generator)+qedfactor(em,sp,generator))
c     &        *woaisr(phasespace)
c minus sign from incoming*outgoing particles
            pf= -factor(generator) * woaisr(phasespace)
            if(pf.ne.0d0)then
              if(s(em,sp,phasespace).le.0d0.or.s(em,sp,1).le.0d0)then
                switch=29
                if(numout.lt.maxout.and.lnoutmc.ge.5)then
                  write(nout,100) nevt,cogen,cocha,switch,
c                write(*,'(" event= ",i9,",",(a))'),nevt,
     &                ' integrand: s(em,sp,...) < 0'
                 write(nout,*) 's(em,sp,ps) = ',em,sp,phasespace,
     &                s(em,sp,phasespace),s(em,sp,1)
                  numout=numout+1
                endif
                return
              else
                if(ssub(generator).eq.1.and.sfactqed.eq.0
     &              .and.sfactqcd.eq.0)then
                  f=(-2d0)/omx*dlog(2d0-x)+(1d0+x)*dlog(omx)
                  do parton1=-4,4
                  do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                    if(em.eq.1)then
                      mass2(em,generator) = m2parton(parton1)
c                      write(*,*) 'integrand: mass1 ',
c     &                    parton1,mass2(em,generator)
                    else
                      mass2(em,generator) = m2parton(parton2)
c                      write(*,*) 'integrand: mass1 ',
c     &                    parton1,mass2(em,generator)
                    endif
c                    write(*,*) 'integrand: mass  ',mass2(em,generator)
c                    mass2(em,generator)=qedfacscale2/omx**2/exp(1d0)
                    if(cut(phasespace).eq.0)then
                      wfac=
     &                    -pf*(sfx(em)
     &                    *(dlog(s(em,sp,phasespace)/mass2(em,generator)
     &                                     /x)
     &                    -1d0)+f)*fac(phasespace)/x
     &                    -pf*omx*fac(phasespace)/x
c     &              -pf*omx*fac(phasespace)*born(em,phasespace)/x
c     &             *(born(em,phasespace)-born(0,phasespace))
                      if(lgencon(0,3))then
                        wfacp=mcalpha*wfac*freqgencon(generator,3)
#ifdef SUBPROCESSES
                        weightii(3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*m2pdfpdfiiqq_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*mm2pdfpdfiiqq_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(3,phasespace)=weight(3,phasespace) +
     &                      wfacp*m2pdfpdfiiqq_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweight(nset,3,phasespace)=
     &                  mweight(nset,3,phasespace) +
     &                      wfacp*mm2pdfpdfiiqq_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        wfacg=mcalphas*wfac*freqgencon(generator,4)
#ifdef SUBPROCESSES
                        weightii(4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*m2pdfpdfiitt_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*mm2pdfpdfiitt_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(4,phasespace)=weight(4,phasespace) +
     &                      wfacg*m2pdfpdfiitt_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweight(nset,4,phasespace)=
     &                  mweight(nset,4,phasespace) +
     &                      wfacg*mm2pdfpdfiitt_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif


                    endif
                    if(cut(1).eq.0)then
                      wfac= pf*
     &                  (sfx(em)*(dlog(s(em,sp,1)/mass2(em,generator)/x)
     &                  -1d0)+f)*fac(1)
     &                  +pf*omx*fac(1)
     &                  -pf*(-(3d0/2d0)+pi2/6d0-const(em,sp))
     &                  *fac(1)
c     &              +pf*omx*fac(1)*(born(em,1)-born(0,1))
c     &              -pf*(0.5d0)*fac(1)*(born(em,1)-born(0,1))
                      if(lgencon(0,3))then
                        wfacp=mcalpha*wfac*freqgencon(generator,3)
#ifdef SUBPROCESSES
                        weightii(3,parton1,parton2,1) =
     &                      weightii(3,parton1,parton2,1) +
     &                      wfacp
     &                      *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweightii(nset,3,parton1,parton2,1) =
     &                      weightii(3,parton1,parton2,1) +
     &                      wfacp
     &                      *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(3,1)=weight(3,1)+
     &                      wfacp
     &                      *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweight(nset,3,1)=mweight(nset,3,1)+
     &                      wfacp
     &                      *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        wfacg=mcalphas*wfac*freqgencon(generator,4)
#ifdef SUBPROCESSES
                        weightii(4,parton1,parton2,1) =
     &                      weightii(4,parton1,parton2,1) +
     &                      wfacg
     &                      *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweightii(nset,4,parton1,parton2,1) =
     &                      weightii(4,parton1,parton2,1) +
     &                      wfacg
     &                      *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(4,1)=weight(4,1)+
     &                      wfacg
     &                      *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweight(nset,4,1)=mweight(nset,4,1)+
     &                      wfacg
     &                      *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                      endif
                    endif
                  endif
                  enddo
                  enddo
#ifdef SUBPROCESSES
#endif

                elseif(ssub(generator).eq.2.and.sfactqed.eq.0
     &                .and.sfactqcd.eq.0)then
                  f=2d0/omx*dlog(omx/(2d0-x))-sfx(em)*(dlog(omx)+1d0)
                  do parton1=-4,4
                  do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                    if(em.eq.1)then
                      mass2(em,generator) = m2parton(parton1)
                    else
                      mass2(em,generator) = m2parton(parton2)
                    endif
                    if(cut(phasespace).eq.0)then
                      wfac=
     &                    -pf*(f-sfx(em)
     &                    *dlog(mass2(em,generator)*x/
     &                    s(em,sp,phasespace)))
     &                    *fac(phasespace)/x
     &                    -pf*omx*fac(phasespace)/x
c     &              -pf*omx*fac(phasespace)/x
c     &                 *(born(em,phasespace)-born(0,phasespace))
                      if(lgencon(0,3))then
                        wfacp=mcalpha*wfac*freqgencon(generator,3)
#ifdef SUBPROCESSES
                        weightii(3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*m2pdfpdfiiqq_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*mm2pdfpdfiiqq_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(3,phasespace)=weight(3,phasespace) +
     &                      wfacp*m2pdfpdfiiqq_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweight(nset,3,phasespace)=
     &                  mweight(nset,3,phasespace) +
     &                      wfacp*mm2pdfpdfiiqq_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        wfacg=mcalphas*wfac*freqgencon(generator,4)
#ifdef SUBPROCESSES
                        weightii(4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*m2pdfpdfiitt_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*mm2pdfpdfiitt_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(4,phasespace)=weight(4,phasespace) +
     &                      wfacg*m2pdfpdfiitt_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweight(nset,4,phasespace)=
     &                  mweight(nset,4,phasespace) +
     &                      wfacg*mm2pdfpdfiitt_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                    endif
                    if(cut(1).eq.0)then
                      wfac=pf*
     &                 (f-sfx(em)*dlog(mass2(em,generator)/s(em,sp,1)))
     &                    *fac(1)
     &                    +pf*omx*fac(1)
     &                    -pf*(-0.25d0-pi2/6d0-const(em,sp))
     &                    *fac(1)
c     &              +pf*omx*fac(1)*(born(em,1)-born(0,1))
c     &              -pf*0.5d0*fac(1)*(born(em,1)-born(0,1))
                      if(lgencon(0,3))then
                        wfacp=mcalpha*wfac*freqgencon(generator,3)
#ifdef SUBPROCESSES
                        weightii(3,parton1,parton2,1) =
     &                      weightii(3,parton1,parton2,1) +
     &                      wfacp
     &                      *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweightii(nset,3,parton1,parton2,1) =
     &                      weightii(3,parton1,parton2,1) +
     &                      wfacp
     &                      *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(3,1)=weight(3,1) +
     &                      wfacp
     &                      *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweight(nset,3,1)=mweight(nset,3,1) +
     &                      wfacp
     &                      *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        wfacg=mcalphas*wfac*freqgencon(generator,4)
#ifdef SUBPROCESSES
                        weightii(4,parton1,parton2,1) =
     &                      weightii(4,parton1,parton2,1) +
     &                      wfacg
     &                      *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweightii(nset,4,parton1,parton2,1) =
     &                      weightii(4,parton1,parton2,1) +
     &                      wfacg
     &                      *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                        weight(4,1)=weight(4,1) +
     &                      wfacg
     &                      *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweight(nset,4,1)=mweight(nset,4,1) +
     &                      wfacg
     &                      *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                      endif
                    endif
                  endif
                  enddo
                  enddo


                else if(ssub(generator).eq.1.and.sfactqed.gt.0
     &                .and.sfactqcd.gt.0)then
                  f=(-2d0)/omx*dlog(2d0-x)+(1d0+x)*dlog(omx)
                  if(cut(phasespace).eq.0)then
                    if(lgencon(0,3))then
                      if(sfactqed.eq.1)then
                        wfac=
     &                      -pf*fac(phasespace)*(f+omx+sfx(em)
     &                      *log(s(em,sp,phasespace)*omx*omx/
     &                      (qedfacscale2*x))
     &                      )/x
                      elseif(sfactqed.eq.2)then
                        wfac=
     &                      -pf*fac(phasespace)*(f+omx+sfx(em)
     &                      *(log(s(em,sp,phasespace)*omx/
     &                      (qedfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*x
     &                      )/x
                      endif
                      wfacp=mcalpha*wfac*freqgencon(generator,3)
                      weight(3,phasespace)=weight(3,phasespace)
     &                    +wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweight(nset,3,phasespace)=
     &                mweight(nset,3,phasespace)
     &                    +wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      if(sfactqcd.eq.1)then
                        wfac=
     &                      -pf*fac(phasespace)*(f+omx+sfx(em)
     &                      *log(s(em,sp,phasespace)*omx*omx/
     &                      (qcdfacscale2*x))
     &                      )/x
                      elseif(sfactqcd.eq.2)then
                        wfac=
     &                      -pf*fac(phasespace)*(f+omx+sfx(em)
     &                      *(log(s(em,sp,phasespace)*omx/
     &                      (qcdfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*x
     &                      )/x
                      endif
                      wfacg=mcalphas*wfac*freqgencon(generator,4)
                      weight(4,phasespace)=weight(4,phasespace)
     &                    +wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweight(nset,4,phasespace)=
     &                mweight(nset,4,phasespace)
     &                    +wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                    endif
#ifdef SUBPROCESSES
                    do parton1=-4,4
                    do parton2=-4,4
                    if (parton1*parton2.ne.0) then
                      if(lgencon(0,3))then
                        weightii(3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*m2pdfpdfiiqq_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*mm2pdfpdfiiqq_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        weightii(4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*m2pdfpdfiitt_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*mm2pdfpdfiitt_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                    endif
                    enddo
                    enddo

#endif
                 endif
                  if(cut(1).eq.0)then
                    if(lgencon(0,3))then
                      if(sfactqed.eq.1)then
                        wfac= pf*fac(1)*
     &                      (f+omx+sfx(em)*
     &                      dlog(s(em,sp,1)*omx*omx/(qedfacscale2*x)))
     &                      -pf*fac(1)*(-(3d0/2d0)+pi2/6d0-const(em,sp))
                      elseif(sfactqed.eq.2)then
                        wfac= pf*fac(1)*
     &                      (f+omx+sfx(em)*
     &                      (dlog(s(em,sp,1)*omx/(qedfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*x
     &                      )
     &                      -pf*fac(1)*(-(3d0/2d0)+pi2/6d0-const(em,sp))
                      endif
                      wfacp=mcalpha*wfac*freqgencon(generator,3)
                      weight(3,1)=weight(3,1)+
     &                    wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweight(nset,3,1)=mweight(nset,3,1)+
     &                    wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      if(sfactqcd.eq.1)then
                        wfac= pf*fac(1)*
     &                      (f+omx+sfx(em)*
     &                      dlog(s(em,sp,1)*omx*omx/(qcdfacscale2*x)))
     &                      -pf*fac(1)*(-(3d0/2d0)+pi2/6d0-const(em,sp))
                      elseif(sfactqcd.eq.2)then
                        wfac= pf*fac(1)*
     &                      (f+omx+sfx(em)*
     &                      (dlog(s(em,sp,1)*omx/(qcdfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*x
     &                      )
     &                      -pf*fac(1)*(-(3d0/2d0)+pi2/6d0-const(em,sp))
                      endif
                      wfacg=mcalphas*wfac*freqgencon(generator,4)
                      weight(4,1)=weight(4,1)+
     &                    wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweight(nset,4,1)=mweight(nset,4,1)+
     &                    wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                    endif
#ifdef SUBPROCESSES
                    do parton1=-4,4
                    do parton2=-4,4
                      if (parton1*parton2.ne.0) then
                        if(lgencon(0,3))then
                          weightii(3,parton1,parton2,1) =
     &                        weightii(3,parton1,parton2,1) +
     &                        wfacp
     &                        *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                          mweightii(nset,3,parton1,parton2,1) =
     &                        weightii(3,parton1,parton2,1) +
     &                        wfacp
     &                        *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,
     &                        sp)
      enddo
#endif
                        endif
                        if(lgencon(0,4))then
                          weightii(4,parton1,parton2,1) =
     &                        weightii(4,parton1,parton2,1) +
     &                        wfacg
     &                        *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                          mweightii(nset,4,parton1,parton2,1) =
     &                        weightii(4,parton1,parton2,1) +
     &                        wfacg
     &                        *mm2pdfpdfiitt_0(iref,parton1,parton2,em,
     &                        sp)
      enddo
#endif
                        endif
                      endif
                    enddo
                    enddo
#endif
                  endif

                elseif(ssub(generator).eq.2.and.sfactqed.gt.0
     &                .and.sfactqcd.gt.0)then
                  write(*,*) 'integrand: ssub = 2,sfactqed>0',
     &                ' not yet tested'
                  stop
                  if(lgencon(0,3))then
                    if(sfactqed.eq.1)then
                      fp=2d0/omx*dlog(omx/(2d0-x))+sfx(em)*dlog(omx)
                    elseif(sfactqed.eq.2)then
                      fp=2d0/omx*dlog(omx/(2d0-x))
     &                    +sfx(em)*(log(x)+.75d0)
     &                    -2.25d0-1.25d0*x
                    endif
                  endif
                  if(lgencon(0,4))then
                    if(sfactqcd.eq.1)then
                      fg=2d0/omx*dlog(omx/(2d0-x))+sfx(em)*dlog(omx)
                    elseif(sfactqcd.eq.2)then
                      fg=2d0/omx*dlog(omx/(2d0-x))
     &                    +sfx(em)*(log(x)+.75d0)
     &                    -2.25d0-1.25d0*x
                    endif
                  endif
                  if(cut(phasespace).eq.0)then
                    if(lgencon(0,3))then
                      wfac=
     &                  -pf*(fp-sfx(em)
     &                  *dlog(qedfacscale2*x/s(em,sp,phasespace)))
     &                  *fac(phasespace)/x
     &                  -pf*omx*fac(phasespace)/x
                      wfacp=mcalpha*wfac*freqgencon(generator,3)
                      weight(3,phasespace)=weight(3,phasespace) +
     &                    wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweight(nset,3,phasespace)=
     &                mweight(nset,3,phasespace) +
     &                    wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      wfac=
     &                  -pf*(fg-sfx(em)
     &                  *dlog(qcdfacscale2*x/s(em,sp,phasespace)))
     &                  *fac(phasespace)/x
     &                  -pf*omx*fac(phasespace)/x
                      wfacg=mcalphas*wfac*freqgencon(generator,4)
                      weight(4,phasespace)=weight(4,phasespace) +
     &                    wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweight(nset,4,phasespace)=
     &                mweight(nset,4,phasespace) +
     &                    wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                    endif
#ifdef SUBPROCESSES
                    do parton1=-4,4
                    do parton2=-4,4
                    if (parton1*parton2.ne.0) then
                      if(lgencon(0,3))then
                        weightii(3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*m2pdfpdfiiqq_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*mm2pdfpdfiiqq_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        weightii(4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*m2pdfpdfiitt_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*mm2pdfpdfiitt_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                    endif
                    enddo
                    enddo
#endif
                  endif
                  if(cut(1).eq.0)then
                    if(lgencon(0,3))then
                      wfac=pf*
     &                    (fp-sfx(em)*dlog(qedfacscale2/s(em,sp,1)))
     &                    *fac(1)
     &                    +pf*omx*fac(1)
     &                    -pf*(-0.25d0-pi2/6d0-const(em,sp))
     &                    *fac(1)
                      wfacp=mcalpha*wfac*freqgencon(generator,3)
                      weight(3,1)=weight(3,1) +
     &                    wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweight(nset,3,1)=mweight(nset,3,1) +
     &                    wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      wfac=pf*
     &                  (fg-sfx(em)*dlog(qcdfacscale2/s(em,sp,1)))
     &                  *fac(1)
     &                  +pf*omx*fac(1)
     &                  -pf*(-0.25d0-pi2/6d0-const(em,sp))
     &                  *fac(1)
c     &              +pf*omx*fac(1)*(born(em,1)-born(0,1))
c     &              -pf*0.5d0*fac(1)*(born(em,1)-born(0,1))
                      wfacg=mcalphas*wfac*freqgencon(generator,4)
                      weight(4,1)=weight(4,1) +
     &                    wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweight(nset,4,1)=mweight(nset,4,1) +
     &                    wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                    endif
#ifdef SUBPROCESSES
                    do parton1=-4,4
                    do parton2=-4,4
                      if (parton1*parton2.ne.0) then
                        if(lgencon(0,3))then
                          weightii(3,parton1,parton2,1) =
     &                        weightii(3,parton1,parton2,1) +
     &                        wfacp
     &                        *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                          mweightii(nset,3,parton1,parton2,1) =
     &                        weightii(3,parton1,parton2,1) +
     &                        wfacp
     &                        *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,
     &                        sp)
      enddo
#endif
                        endif
                        if(lgencon(0,4))then
                          weightii(4,parton1,parton2,1) =
     &                        weightii(4,parton1,parton2,1) +
     &                        wfacg
     &                        *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                          mweightii(nset,4,parton1,parton2,1) =
     &                        weightii(4,parton1,parton2,1) +
     &                        wfacg
     &                        *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,
     &                        sp)
      enddo
#endif
                        endif
                      endif
                    enddo
                    enddo
#endif
                  endif
                endif
              endif
            endif
          enddo
          enddo

c initial-state emitter with initial-state spectator
          do em=1,2
          do sp=1,2
          phasespace=em+1
          x=xisr(phasespace)
          omx=omxisr(phasespace)
          xd=xdisr(phasespace)
          omxd=omxdisr(phasespace)
c          pf=(qedfactor(em,sp,generator)+qedfactor(em,sp,generator))
c     &        *woaisr(phasespace)
          pf=factor(generator) * woaisr(phasespace)
          if(pf.ne.0d0.and.em.ne.sp)then
            if((ssub(generator).eq.1.or.ssub(generator).eq.2)
     &          .and.sfactqed.eq.0.and.sfactqcd.eq.0)then
              do parton1=-4,4
              do parton2=-4,4
              if (parton1*parton2.ne.0) then
                if(em.eq.1)then
                  mass2(em,generator) = m2parton(parton1)
c                  write(*,*) 'integrand: mass1 ',
c     &                parton1,mass2(em,generator)
                else
                  mass2(em,generator) = m2parton(parton2)
c                write(*,*) 'integrand: mass2 ',
c     &                parton2,mass2(em,generator)
                endif
c                write(*,*) 'integrand: mass ',mass2(em,generator)
c                mass2(em,generator)=qedfacscale2/omx**2/exp(1d0)
                if(s(1,2,1).gt.0d0)then
                  f=sfx(em)*(dlog(s(1,2,1)/mass2(em,generator))-1d0)
                else
                  switch=47
                  if(numout.lt.maxout.and.lnoutmc.ge.5)then
                    write(nout,100) nevt,cogen,cocha,switch,
     &                  ' integrand: s(1,2,1) < 0'
                    write(nout,*) 's(1,2,1) = ',s(1,2,1)
                    numout=numout+1
                  endif
                  return
                  f=0d0
                endif
                if(cut(phasespace).eq.0)then
                  wfac=
     &                -pf*f*fac(phasespace)/x
     &                -pf*omx*fac(phasespace)/x
c     &            -pf*omx*fac(phasespace)/x
c     &            *(born(em,phasespace)-born(em,phasespace))
                  if(lgencon(0,3))then
                    wfacp=mcalpha*wfac*freqgencon(generator,3)
#ifdef SUBPROCESSES
                    weightii(3,parton1,parton2,phasespace) =
     &                  weightii(3,parton1,parton2,phasespace) +
     &                  wfacp*
     &                  m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweightii(nset,3,parton1,parton2,phasespace) =
     &                  weightii(3,parton1,parton2,phasespace) +
     &                  wfacp*
     &                  mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                    weight(3,phasespace)=weight(3,phasespace) +
     &                  wfacp*
     &                  m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
c                  write(*,*) 'integrand: weight(3,ps) ',em,sp,
c     &                parton1,parton2,
c     &                weightii(3,parton1,parton2,phasespace),wfacp,
c     &                m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,3,phasespace)=
     &              mweight(nset,3,phasespace) +
     &                  wfacp*
     &                  mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
c                  write(*,*) 'integrand: mweight(nset,3,ps) ',em,sp,
c     &                parton1,parton2,
c     &                weightii(3,parton1,parton2,phasespace),wfacp,
c     &                mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    wfacg=mcalphas*wfac*freqgencon(generator,4)
#ifdef SUBPROCESSES
                    weightii(4,parton1,parton2,phasespace) =
     &                  weightii(4,parton1,parton2,phasespace) +
     &                  wfacg*
     &                  m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweightii(nset,4,parton1,parton2,phasespace) =
     &                  weightii(4,parton1,parton2,phasespace) +
     &                  wfacg*
     &                  mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                    weight(4,phasespace)=weight(4,phasespace) +
     &                  wfacg*
     &                  m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,4,phasespace)=
     &              mweight(nset,4,phasespace) +
     &                  wfacg*
     &                  mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                endif
                if(cut(1).eq.0)then
                  wfac=
     &                +pf*f*fac(1)
     &                +pf*omx*fac(1)
     &                -pf*(1.5d0-pi2/3d0-const(em,sp))*fac(1)
c     &            +pf*omx*fac(1)*(born(em,1)-born(0,1))
c     &            -pf*0.5d0*fac(1)*(born(em,1)-born(0,1))
                  if(lgencon(0,3))then
                    wfacp=mcalpha*wfac*freqgencon(generator,3)
#ifdef SUBPROCESSES
                    weightii(3,parton1,parton2,1) =
     &                  weightii(3,parton1,parton2,1) +
     &                  wfacp
     &                  *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,3,parton1,parton2,1) =
     &                  weightii(3,parton1,parton2,1) +
     &                  wfacp
     &                  *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                    weight(3,1)=weight(3,1) +
     &                  wfacp
     &                  *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
c                  write(*,*) 'integrand: weight(3,1) ',em,sp,
c     &                parton1,parton2,
c     &                weightii(3,parton1,parton2,1),wfacp,
c     &                m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweight(nset,3,1)=mweight(nset,3,1) +
     &                  wfacp
     &                  *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
c                  write(*,*) 'integrand: mweight(nset,3,1) ',em,sp,
c     &                parton1,parton2,
c     &                weightii(3,parton1,parton2,1),wfacp,
c     &                mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    wfacg=mcalphas*wfac*freqgencon(generator,4)
#ifdef SUBPROCESSES
                    weightii(4,parton1,parton2,1) =
     &                  weightii(4,parton1,parton2,1) +
     &                  wfacg
     &                  *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,4,parton1,parton2,1) =
     &                  weightii(4,parton1,parton2,1) +
     &                  wfacg
     &                  *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
#endif
                    weight(4,1)=weight(4,1) +
     &                  wfacg
     &                  *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweight(nset,4,1)=mweight(nset,4,1) +
     &                  wfacg
     &                  *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                endif
              endif
              enddo
              enddo
#ifdef SUBPROCESSES
#endif
            elseif((ssub(generator).eq.1.or.ssub(generator).eq.2)
     &            .and.sfactqed.gt.0.and.sfactqcd.gt.0)then
              if(cut(phasespace).eq.0.or.cut(1).eq.0)then

c                write(*,*) 'integrand spp',phasespace,
c     &              s(1,2,phasespace),shat,spp,s(1,2,1)

                if(lgencon(0,3))then
                  if(sfactqed.eq.1)then
                    fp=sfx(em)*(log(spp/qedfacscale2)+2d0*log(omx))
                  elseif(sfactqed.eq.2)then
                    fp=sfx(em)*(log(spp/qedfacscale2)
     &                  +log(omx*x)+.75d0)-2.25d0-1.25d0*x
                  endif
                endif
                if(lgencon(0,4))then
                  if(sfactqcd.eq.1)then
                    fg=sfx(em)*(log(spp/qcdfacscale2)+2d0*log(omx))
                  elseif(sfactqcd.eq.2)then
                    fg=sfx(em)*(log(spp/qcdfacscale2)
     &                  +log(omx*x)+.75d0)-2.25d0-1.25d0*x
                  endif
                endif
              endif
              if(cut(phasespace).eq.0)then
                if(lgencon(0,3))then
                  wfac=
     &              -pf*fac(phasespace)*(fp+omx)/x
                  wfacp=mcalpha*wfac*freqgencon(generator,3)
                  weight(3,phasespace)=weight(3,phasespace) +
     &                wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweight(nset,3,phasespace)=
     &            mweight(nset,3,phasespace) +
     &                wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                endif
                if(lgencon(0,4))then
                  wfac=
     &              -pf*fac(phasespace)*(fg+omx)/x
                  wfacg=mcalphas*wfac*freqgencon(generator,4)
                  weight(4,phasespace)=weight(4,phasespace) +
     &                wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweight(nset,4,phasespace)=
     &            mweight(nset,4,phasespace) +
     &                wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  if(lgencon(0,3))then
                    weightii(3,parton1,parton2,phasespace) =
     &                  weightii(3,parton1,parton2,phasespace) +
     &                  wfacp*
     &                  m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweightii(nset,3,parton1,parton2,phasespace) =
     &                  weightii(3,parton1,parton2,phasespace) +
     &                  wfacp*
     &                  mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    weightii(4,parton1,parton2,phasespace) =
     &                  weightii(4,parton1,parton2,phasespace) +
     &                  wfacg*
     &                  m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweightii(nset,4,parton1,parton2,phasespace) =
     &                  weightii(4,parton1,parton2,phasespace) +
     &                  wfacg*
     &                  mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                endif
                enddo
                enddo
#endif
              endif
              if(cut(1).eq.0)then
                if(lgencon(0,3))then
                  wfac=
     &              +pf*fac(1)*(fp+omx)
     &              -pf*fac(1)*(1.5d0-pi2/3d0-const(em,sp))
                  wfacp=mcalpha*wfac*freqgencon(generator,3)
                  weight(3,1)=weight(3,1) +
     &                wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                  mweight(nset,3,1)=mweight(nset,3,1) +
     &                wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                endif
                if(lgencon(0,4))then
                  wfac=
     &              +pf*fac(1)*(fg+omx)
     &              -pf*fac(1)*(1.5d0-pi2/3d0-const(em,sp))
                  wfacg=mcalphas*wfac*freqgencon(generator,4)
                  weight(4,1)=weight(4,1) +
     &                wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                  mweight(nset,4,1)=mweight(nset,4,1) +
     &                wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  if(lgencon(0,3))then
                    weightii(3,parton1,parton2,1) =
     &                  weightii(3,parton1,parton2,1) +
     &                  wfacp
     &                  *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,3,parton1,parton2,1) =
     &                  weightii(3,parton1,parton2,1) +
     &                  wfacp
     &                  *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    weightii(4,parton1,parton2,1) =
     &                  weightii(4,parton1,parton2,1) +
     &                  wfacg
     &                  *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,4,parton1,parton2,1) =
     &                  weightii(4,parton1,parton2,1) +
     &                  wfacg
     &                  *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                  endif
                endif
                enddo
                enddo
#endif
              endif
#ifdef SUBPROCESSES
#endif
            endif
          endif
          enddo
          enddo
          endif
          if(lgencon(0,3))then
            rejectedcon(3,1)=cut(1)
            rejectedcon(3,2)=cut(2)
            rejectedcon(3,3)=cut(3)
            if(cut(1).eq.0.or.cut(2).eq.0.or.cut(3).eq.0) then
              rejected(3)=0
            else
              rejected(3)=max(cut(1),cut(2),cut(3))
            endif
c            rejected(3)=min(cut(1),cut(2),cut(3))
          endif
          if(lgencon(0,4))then
            rejectedcon(4,1)=cut(1)
            rejectedcon(4,2)=cut(2)
            rejectedcon(4,3)=cut(3)
            if(cut(1).eq.0.or.cut(2).eq.0.or.cut(3).eq.0) then
              rejected(4)=0
            else
              rejected(4)=max(cut(1),cut(2),cut(3))
            endif
c            rejected(4)=min(cut(1),cut(2),cut(3))

c            write(*,*) 'integrand cut04=',rejected(4)

          endif
        endif
c end subtraction terms

c        write(*,*) 'integrand weights',weight(1,1),weight(2,1),
c     &  weight(3,1),weight(4,1),weight(5,1)

c slicing terms
c        write(*,*) 'integrand: ssli ',ssli(generator),generator

        if(ssli(generator).ne.0.and.
     &      (lgencon(0,3).or.lgencon(0,4))
     &      .and.switch.eq.0) then
          if(cut(1).eq.0.or.cut(2).eq.0.or.cut(3).eq.0)then

c final-state emitter
c          do em=3,nextgen(generator)
c          do sp=1,nextgen(generator)
c ADAPTED FOR UNCHARGED HIGGS
          do em=3,nextsub(generator)
          do sp=1,nextsub(generator)
c minus sign from incoming*outgoing particles
          pf=factor(generator)*dir(em)*dir(sp)
          if(pf.ne.0d0.and.em.ne.sp)then
            if(ssli(generator).eq.1.and.sfactqed.gt.0
     &          .and.sfactqcd.gt.0)then
              if(s(em,sp,1).lt.0d0)then
                switch=48
                if(numout.lt.maxout.and.lnoutmc.ge.5)then
                  write(nout,100) nevt,cogen,cocha,switch,
     &                ' integrand: s(em,sp,1) < 0'
                 write(nout,*) 's(em,sp,1) = ',em,sp,s(em,sp,1)
                  numout=numout+1
                endif
                return
              endif
               if(cut(1).eq.0)then
c const=Cij-1/2
                f=pi*pi-4d0+const(em,sp)
     &              + dli2(1d0-4d0*ecms(em,1)*ecms(sp,1)/s(em,sp,1),
     &                           switch)
     &              + log(2d0*ecms(em,1)**2*mcslideltac/s(em,sp,1))
     &              * (1.5d0+log(mcslideltas**2*s(1,2,1)/
     &                           (4d0*ecms(em,1)**2)))
     &              + .5d0*(log(4d0*ecms(em,1)**2/s(em,sp,1)))**2
                wfac=pf*f*fac(1)
                if(lgencon(0,3))then
                  wfacp=mcalpha*wfac*freqgencon(generator,3)
                  weight(3,1)=weight(3,1)
     &                +wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                  mweight(nset,3,1)=mweight(nset,3,1)
     &                +wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                endif
                if(lgencon(0,4))then
                    wfacg=mcalphas*wfac*freqgencon(generator,4)
                  weight(4,1)=weight(4,1)
     &                +wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                  mweight(nset,4,1)=mweight(nset,4,1)
     &                +wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  if(lgencon(0,3))then
                    weightii(3,parton1,parton2,1) =
     &                  weightii(3,parton1,parton2,1) +
     &                  wfacp*m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,3,parton1,parton2,1) =
     &                  weightii(3,parton1,parton2,1) +
     &                  wfacp*mm2pdfpdfiiqq_0(iref,parton1,parton2,em,
     &                  sp)
      enddo
#endif
                  endif
                  if(lgencon(0,4))then
                    weightii(4,parton1,parton2,1) =
     &                  weightii(4,parton1,parton2,1) +
     &                  wfacg*m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                    mweightii(nset,4,parton1,parton2,1) =
     &                  weightii(4,parton1,parton2,1) +
     &                  wfacg*mm2pdfpdfiitt_0(iref,parton1,parton2,em,
     &                  sp)
      enddo
#endif
                  endif
                endif
                enddo
                enddo
#endif
             endif
            endif
          endif
          enddo
          enddo

c initial-state emitter
          do em=1,2
c          do sp=3,nextgen(generator)
c ADAPTED FOR UNCHARGED HIGGS
          do sp=1,nextsub(generator)
            phasespace=em+1
            x=xisr(phasespace)
            omx=omxisr(phasespace)
            xd=xdisr(phasespace)
            omxd=omxdisr(phasespace)
c          pf=(qedfactor(em,sp,generator)+qedfactor(em,sp,generator))
c     &        *woaisr(phasespace)
            pf= factor(generator)*dir(em)*dir(sp)
            if(pf.ne.0d0.and.em.ne.sp)then
              if(s(em,sp,phasespace).lt.0d0.or.s(em,sp,1).lt.0d0)then
                switch=30
                if(numout.lt.maxout.and.lnoutmc.ge.5)then
                  write(nout,100) nevt,cogen,cocha,switch,
c                  write(*,'(" event= ",i9,",",(a))'),nevt,
     &                ' integrand: s(em,sp,...) < 0'
                  numout=numout+1
                endif
c                mcexitevt(4,generator)=mcexitevt(4,generator)+1
                return
              else
                if(ssli(generator).eq.1
     &              .and.sfactqed.gt.0.and.sfactqcd.gt.0)then
                  if(cut(phasespace).eq.0)then
                    if(lgencon(0,3))then
                      if(sfactqed.eq.1)then
                        fp=omx+sfx(em)*
     &                      (log(spp*omx*omx*mcslideltac/
     &                      (2d0*qedfacscale2)))
                      elseif(sfactqed.eq.2)then
                        fp=omx+sfx(em)*
     &                      (log(spp*omx*x*mcslideltac/
     &                  (2d0*qedfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*x
                      endif
                      wfac=
     &                  -pf*fac(phasespace)*fp/x*woaisr(phasespace)
                      wfacp=mcalpha*wfac*freqgencon(generator,3)
                      weight(3,phasespace)=weight(3,phasespace)
     &                    +wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweight(nset,3,phasespace)=
     &                mweight(nset,3,phasespace)
     &                    +wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then

c                write(*,*) 'integrand spp',phasespace,
c     &              s(1,2,phasespace),shat,spp,s(1,2,1)

                      if(sfactqcd.eq.1)then
                        fg=omx+sfx(em)*
     &                      (log(spp*omx*omx*mcslideltac/
     &                      (2d0*qcdfacscale2)))
                      elseif(sfactqcd.eq.2)then
                        fg=omx+sfx(em)*
     &                      (log(spp*omx*x*mcslideltac/
     &                      (2d0*qcdfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*x
                      endif
                      wfac=
     &                  -pf*fac(phasespace)*fg/x*woaisr(phasespace)
                      wfacg=mcalphas*wfac*freqgencon(generator,4)
                      weight(4,phasespace)=weight(4,phasespace)
     &                    +wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweight(nset,4,phasespace)=
     &                mweight(nset,4,phasespace)
     &                    +wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
                    endif
#ifdef SUBPROCESSES
                    do parton1=-4,4
                    do parton2=-4,4
                    if (parton1*parton2.ne.0) then
                      if(lgencon(0,3))then
                        weightii(3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*m2pdfpdfiiqq_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,3,parton1,parton2,phasespace) =
     &                      weightii(3,parton1,parton2,phasespace) +
     &                      wfacp*mm2pdfpdfiiqq_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        weightii(4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*m2pdfpdfiitt_0(phasespace,
     &                      parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                        mweightii(nset,4,parton1,parton2,phasespace) =
     &                      weightii(4,parton1,parton2,phasespace) +
     &                      wfacg*mm2pdfpdfiitt_0(iref,
     &                      parton1,parton2,em,sp)
      enddo
#endif
                      endif
                    endif
                    enddo
                    enddo

#endif
                  endif
                  if(cut(1).eq.0)then
                    wfac= pf*fac(1)*(
c const=Cij-1/2
     &                  pi*pi/3d0-1.5d0+const(em,sp)
     &                  + dli2(1d0-4d0*ecms(em,1)*ecms(sp,1)/s(em,sp,1),
     &                                  switch)
     &                  + log(s(1,2,1)*mcslideltac/(2d0*s(em,sp,1)))
     &                  * (1.5d0+2d0*log(mcslideltas))
     &                  + .5d0*(log(s(1,2,1)/s(em,sp,1)))**2
     &                  )
                    if(lgencon(0,3))then
                      if(sfactqed.eq.1)then
                        fpd=omxd+sfxd(em)*
     &                      (log(s(1,2,1)*omxd*omxd*mcslideltac/
     &                      (2d0*qedfacscale2)))
                      elseif(sfactqed.eq.2)then
                        fpd=omxd+sfxd(em)*
     &                      (log(s(1,2,1)*omxd*xd*mcslideltac/
     &                      (2d0*qedfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*xd
                      endif
                      wfacp=wfac+ pf*fac(1)*fpd*woaisrd(phasespace)
                      wfacp=mcalpha*wfacp*freqgencon(generator,3)
                      weight(3,1)=weight(3,1)+
     &                    wfacp*m2pdfpdfqq_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweight(nset,3,1)=mweight(nset,3,1)+
     &                    wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
                    endif
                    if(lgencon(0,4))then
                      if(sfactqcd.eq.1)then
                        fgd=omxd+sfxd(em)*
     &                      (log(s(1,2,1)*omxd*omxd*mcslideltac/
     &                      (2d0*qcdfacscale2)))
                      elseif(sfactqcd.eq.2)then
                        fgd=omxd+sfxd(em)*
     &                      (log(s(1,2,1)*omxd*xd*mcslideltac/
     &                      (2d0*qcdfacscale2))+.75d0)
     &                      -2.25d0-1.25d0*xd
                      endif
                      wfacg=wfac+ pf*fac(1)*fgd*woaisrd(phasespace)
                      wfacg=mcalphas*wfacg*freqgencon(generator,4)
                      weight(4,1)=weight(4,1)+
     &                    wfacg*m2pdfpdftt_0(1,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                      mweight(nset,4,1)=mweight(nset,4,1)+
     &                    wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif

                    endif
#ifdef SUBPROCESSES
                    do parton1=-4,4
                    do parton2=-4,4
                    if (parton1*parton2.ne.0) then
                      if(lgencon(0,3))then
                        weightii(3,parton1,parton2,1) =
     &                      weightii(3,parton1,parton2,1) +
     &                      wfacp
     &                      *m2pdfpdfiiqq_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweightii(nset,3,parton1,parton2,1) =
     &                      weightii(3,parton1,parton2,1) +
     &                      wfacp
     &                      *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                      endif
                      if(lgencon(0,4))then
                        weightii(4,parton1,parton2,1) =
     &                      weightii(4,parton1,parton2,1) +
     &                      wfacg
     &                      *m2pdfpdfiitt_0(1,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                        mweightii(nset,4,parton1,parton2,1) =
     &                      weightii(4,parton1,parton2,1) +
     &                      wfacg
     &                      *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                      endif
                    endif
                    enddo
                    enddo
#endif

                  endif
                endif
              endif
            endif
          enddo
          enddo
          endif
          if(lgencon(0,3))then
            rejectedcon(3,1)=cut(1)
            rejectedcon(3,2)=cut(2)
            rejectedcon(3,3)=cut(3)
            if(cut(1).eq.0.or.cut(2).eq.0.or.cut(3).eq.0) then
              rejected(3)=0
            else
              rejected(3)=max(cut(1),cut(2),cut(3))
            endif
c            rejected(3)=max(cut(1),cut(2),cut(3))
          endif
          if(lgencon(0,4))then
            rejectedcon(4,1)=cut(1)
            rejectedcon(4,2)=cut(2)
            rejectedcon(4,3)=cut(3)
            if(cut(1).eq.0.or.cut(2).eq.0.or.cut(3).eq.0) then
              rejected(4)=0
            else
              rejected(4)=max(cut(1),cut(2),cut(3))
            endif
c            rejected(4)=max(cut(1),cut(2),cut(3))
          endif
        endif
* end slicing contributions


c end-point part of subtraction functions
        if(sendp(generator).eq.1.and.switch.eq.0)then
          if(cut(1).eq.0)then
c          do em=1,nextgen(generator)
c          do sp=em+1,nextgen(generator)
c ADAPTED FOR UNCHARGED HIGGS
          do em=1,nextsub(generator)-1
          do sp=em+1,nextsub(generator)
c          pf=qedfactor(em,sp,generator)+qcdfactor(em,sp,generator)
          pf= factor(generator)*dir(em)*dir(sp)
          if(pf.ne.0d0)then
            p2=s(em,sp,1)
            if(p2.le.0d0.and.cut(1).eq.0)then
              switch=31
              if(numout.lt.maxout.and.lnoutmc.ge.5)then
                write(nout,100) nevt,cogen,cocha,switch,
c                write(*,'(" event= ",i9,",",(a))'),nevt,
     &              ' integrand: s(em,sp,1) <= 0'
                numout=numout+1
              endif
c              mcexitevt(5,generator)=mcexitevt(5,generator)+1
              return
            elseif(cut(1).eq.0)then
              do parton1=-4,4
              do parton2=-4,4
              do parton3=-4,4
              do parton4=-4,4
              if (parton1*parton2*parton3*parton4.ne.0) then
                if(em.eq.1)then
                  mass2(em,generator) = m2parton(parton1)
                elseif(em.eq.2)then
                  mass2(em,generator) = m2parton(parton2)
                elseif(em.eq.3)then
                  mass2(em,generator) = m2parton(parton3)
                elseif(em.eq.4)then
                  mass2(em,generator) = m2parton(parton4)
                endif
                if(sp.eq.4)then
                  mass2(sp,generator) = m2parton(parton3)
                else if(sp.eq.3)then
                  mass2(sp,generator) = m2parton(parton4)
                else if(sp.eq.2)then
                  mass2(sp,generator) = m2parton(parton4)
                else if(sp.eq.1)then
                  mass2(sp,generator) = m2parton(parton4)
                else
                  write(*,*) ' integrand: mass2 for spectator > 4 ',
     &                'not defined'
                  write(*,*) nextsub(generator),em,sp
                  write(*,*) parton1,parton2,parton3,parton4
                  stop
                endif
                logs=(dlog(mass2(em,generator)/p2)
     &              +dlog(mass2(sp,generator)/p2)+2d0)
     &              *dlog(lambda2(generator)/p2)
     &              -0.5d0*dlog(mass2(em,generator)/p2)**2
     &              +0.5d0*dlog(mass2(em,generator)/p2)
     &              -0.5d0*dlog(mass2(sp,generator)/p2)**2
     &              +0.5d0*dlog(mass2(sp,generator)/p2)
                wfac=
     &              -pf*(logs+const(em,sp)+const(sp,em)+1d0)*fac(1)
                wfacp=mcalpha*wfac*freqgencon(generator,2)
                wfacg=mcalphas*wfac*freqgencon(generator,5)


                if(lgencon(0,2))then
#ifdef SUBPROCESSES
                  weightii(2,parton1,parton2,1) =
     &                weightii(2,parton1,parton2,1) +
     &                wfacp
     &                *m2pdfpdfiiiiqq_0(1,parton1,parton2,
     &                parton3,parton4,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
      enddo
#endif
#endif
                  weight(2,1)=weight(2,1) +
     &                wfacp
     &                *m2pdfpdfiiiiqq_0(1,parton1,parton2,
     &                parton3,parton4,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
      enddo
#endif
                endif
                if(lgencon(0,5))then
#ifdef SUBPROCESSES
                  weightii(5,parton1,parton2,1) =
     &                weightii(5,parton1,parton2,1) +
     &                wfacg
     &                *m2pdfpdfiiiitt_0(1,parton1,parton2,
     &                parton3,parton4,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
      enddo
#endif
#endif
                  weight(5,1)=weight(5,1) +
     &                wfacg
     &                *m2pdfpdfiiiitt_0(1,parton1,parton2,
     &                parton3,parton4,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
      enddo
#endif
                endif
              endif
              enddo
              enddo
              enddo
              enddo
            endif
          endif
          enddo
          enddo
#ifdef SUBPROCESSES
#endif

           endif
         endif

c incoming photon and gluon subtraction terms

c       write(*,*) 'integrand: ssub ',ssub(generator),generator

        if(ssub(generator).ne.0.and.
     &       (lgencon(generator,6).or.lgencon(generator,7).or.
     &       lgencon(generator,8).or.lgencon(generator,9))
     &       .and.switch.eq.0) then
          if (cut(4).eq.0.or.cut(5).eq.0)then

c initial-state emitter with initial-state spectator
          do em=1,2
            phasespace=em+3
            x=xisr(phasespace)
            omx=omxisr(phasespace)
c          pf=(qedfactor(em,sp,generator)+qedfactor(em,sp,generator))
c     &        *woaisr(phasespace)
            pf=factor(generator) * woaisr(phasespace)
            if(pf.ne.0d0)then

            if((ssub(generator).eq.1.or.ssub(generator).eq.2)
     &            .and.sfactqed.gt.0.and.sfactqcd.gt.0)then
              if(cut(phasespace).eq.0)then
                if(lgencon(0,6).or.lgencon(0,7))then
                  if(sfactqed.eq.1)then
                    fp=(omx*omx+x*x)*
     &                  log(spp*omx*omx/qedfacscale2)
     &                  +2d0*x*omx
                  elseif(sfactqed.eq.2)then
                    fp=(omx*omx+x*x)*
     &                  log(spp*omx*x/qedfacscale2)
     &                  +1d0-6d0*x*omx
                  endif
                  wfac=
     &              pf*fac(phasespace)*fp/x
                  wfacp=mcalpha*wfac*freqgencon(generator,6)
                  if(em.eq.1.and.lgencon(0,6))then
                    weight(6,phasespace)=weight(6,phasespace) +
     &                  wfacp*m2pdfpdfq2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,6,phasespace)=
     &              mweight(nset,6,phasespace) +
     &                  wfacp*mm2pdfpdfq2_0(iref,em)
      enddo
#endif
                  elseif(em.eq.2.and.lgencon(0,7))then
                    weight(7,phasespace)=weight(7,phasespace) +
     &                  wfacp*m2pdfpdfq2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,7,phasespace)=
     &              mweight(nset,7,phasespace) +
     &                  wfacp*mm2pdfpdfq2_0(iref,em)
      enddo
#endif
                  endif
                endif
                if(lgencon(0,8).or.lgencon(0,9))then
                  if(sfactqcd.eq.1)then
                    fg=(omx*omx+x*x)*
     &                  log(spp*omx*omx/qcdfacscale2)
     &                  +2d0*x*omx
                  elseif(sfactqcd.eq.2)then
                    fg=(omx*omx+x*x)*
     &                  log(spp*omx*x/qcdfacscale2)
     &                  +1d0-6d0*x*omx
                  endif
                  wfac=
     &              pf*fac(phasespace)*fg/x
                  wfacg=mcalphas*wfac*freqgencon(generator,8)
                  if(em.eq.1.and.lgencon(0,8))then
                    weight(8,phasespace)=weight(8,phasespace) +
     &                  wfacg*m2pdfpdft2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,8,phasespace)=
     &              mweight(nset,8,phasespace) +
     &                  wfacg*mm2pdfpdft2_0(iref,em)
      enddo
#endif
                  elseif(em.eq.2.and.lgencon(0,9))then
                    weight(9,phasespace)=weight(9,phasespace) +
     &                  wfacg*m2pdfpdft2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,9,phasespace)=
     &              mweight(nset,9,phasespace) +
     &                  wfacg*mm2pdfpdft2_0(iref,em)
      enddo
#endif
                  endif
                endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                if (parton1.ne.0) then
                    if(em.eq.1.and.lgencon(0,6))then
                      weightii(6,0,parton1,phasespace) =
     &                    weightii(6,0,parton1,phasespace) +
     &                    wfacp*
     &                    m2pdfpdfiiq2_0(phasespace,0,parton1,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,6,0,parton1,phasespace) =
     &                    weightii(6,0,parton1,phasespace) +
     &                    wfacp*
     &                    mm2pdfpdfiiq2_0(iref,0,parton1,em)
      enddo
#endif
                    elseif(em.eq.2.and.lgencon(0,7))then
                      weightii(7,parton1,0,phasespace) =
     &                    weightii(7,parton1,0,phasespace) +
     &                    wfacp*
     &                    m2pdfpdfiiq2_0(phasespace,parton1,0,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,7,parton1,0,phasespace) =
     &                    weightii(7,parton1,0,phasespace) +
     &                    wfacp*
     &                    mm2pdfpdfiiq2_0(iref,parton1,0,em)
      enddo
#endif
                    endif
                    if(em.eq.1.and.lgencon(0,8))then
                      weightii(8,0,parton1,phasespace) =
     &                    weightii(8,0,parton1,phasespace) +
     &                    wfacg*
     &                    m2pdfpdfiit2_0(phasespace,0,parton1,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,8,0,parton1,phasespace) =
     &                    weightii(8,0,parton1,phasespace) +
     &                    wfacg*
     &                    mm2pdfpdfiit2_0(iref,0,parton1,em)
      enddo
#endif
                    elseif(em.eq.2.and.lgencon(0,9))then
                      weightii(9,parton1,0,phasespace) =
     &                    weightii(9,parton1,0,phasespace) +
     &                    wfacg*
     &                    m2pdfpdfiit2_0(phasespace,parton1,0,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,9,parton1,0,phasespace) =
     &                    weightii(9,parton1,0,phasespace) +
     &                    wfacg*
     &                    mm2pdfpdfiit2_0(iref,parton1,0,em)
      enddo
#endif
                    endif
                endif
                enddo
#endif
              endif
            endif
          endif
          enddo
          endif
          if(lgencon(0,6))then
            rejectedcon(6,4)=cut(4)
            rejected(6)=cut(4)
          endif
          if(lgencon(0,7))then
            rejectedcon(7,5)=cut(5)
            rejected(7)=cut(5)
          endif
          if(lgencon(0,8))then
            rejectedcon(8,4)=cut(4)
            rejected(8)=cut(4)
          endif
          if(lgencon(0,9))then
            rejectedcon(9,5)=cut(5)
            rejected(9)=cut(5)
          endif
        endif

c        write(*,*) 'integrand ingasli',generator,ssli(generator)
c     &      ,sgencon(generator,6),sgencon(generator,7)

c incoming photon and gluon slicing terms

c       write(*,*) 'integrand: ssub ',ssub(generator),generator

        if(ssli(generator).ne.0.and.
     &      (lgencon(generator,6).or.lgencon(generator,7).or.
     &       lgencon(generator,8).or.lgencon(generator,9))
     &      .and.switch.eq.0)then
          if(cut(4).eq.0.or.cut(5).eq.0)then

c initial-state emitter with initial-state spectator
          do em=1,2
          phasespace=em+3
          x=xisr(phasespace)
          omx=omxisr(phasespace)
c          pf=(qedfactor(em,sp,generator)+qedfactor(em,sp,generator))
c     &        *woaisr(phasespace)
          pf=factor(generator) * woaisr(phasespace)
          if(pf.ne.0d0)then

            if(ssli(generator).eq.1
     &            .and.sfactqed.gt.0.and.sfactqcd.gt.0)then
              if(cut(phasespace).eq.0)then
                if(lgencon(0,6).or.lgencon(0,7))then
                  if(sfactqed.eq.1)then
                    fp=(omx*omx+x*x)*
     &                  log(spp*omx*omx*mcslideltac/
     &                  (2d0*qedfacscale2))
     &                  +2d0*x*omx
                  elseif(sfactqed.eq.2)then
                    fp=(omx*omx+x*x)*
     &                  log(spp*omx*x*mcslideltac/(2d0*qedfacscale2))
     &                  +1d0-6d0*x*omx
                  endif
                  wfac=
     &              pf*fac(phasespace)*fp/x
                  wfacp=mcalpha*wfac*freqgencon(generator,6)
                  if(em.eq.1.and.lgencon(0,6))then
                    weight(6,phasespace)=weight(6,phasespace) +
     &                  wfacp*m2pdfpdfq2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,6,phasespace)=
     &              mweight(nset,6,phasespace) +
     &                  wfacp*mm2pdfpdfq2_0(iref,em)
      enddo
#endif
                  elseif(em.eq.2.and.lgencon(0,7))then
                    weight(7,phasespace)=weight(7,phasespace) +
     &                  wfacp*m2pdfpdfq2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,7,phasespace)=
     &              mweight(nset,7,phasespace) +
     &                  wfacp*mm2pdfpdfq2_0(iref,em)
      enddo
#endif
                  endif
                endif
                if(lgencon(0,8).or.lgencon(0,9))then
                  if(sfactqcd.eq.1)then
                    fg=(omx*omx+x*x)*
     &                  log(spp*omx*omx*mcslideltac/
     &                  (2d0*qcdfacscale2))
     &                  +2d0*x*omx
                  elseif(sfactqcd.eq.2)then
                    fg=(omx*omx+x*x)*
     &                  log(spp*omx*x*mcslideltac/(2d0*qcdfacscale2))
     &                  +1d0-6d0*x*omx
                  endif
                  wfac=
     &              pf*fac(phasespace)*fg/x
                  wfacg=mcalphas*wfac*freqgencon(generator,8)
                  if(em.eq.1.and.lgencon(0,8))then
                    weight(8,phasespace)=weight(8,phasespace) +
     &                  wfacg*m2pdfpdft2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,8,phasespace)=
     &              mweight(nset,8,phasespace) +
     &                  wfacg*mm2pdfpdft2_0(iref,em)
      enddo
#endif
                  elseif(em.eq.2.and.lgencon(0,9))then
                    weight(9,phasespace)=weight(9,phasespace) +
     &                  wfacg*m2pdfpdft2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,9,phasespace)=
     &              mweight(nset,9,phasespace) +
     &                  wfacg*mm2pdfpdft2_0(iref,em)
      enddo
#endif
                  endif
                endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                if (parton1.ne.0) then
                    if(em.eq.1.and.lgencon(0,6))then
                      weightii(6,0,parton1,phasespace) =
     &                    weightii(6,0,parton1,phasespace) +
     &                    wfacp*
     &                    m2pdfpdfiiq2_0(phasespace,0,parton1,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,6,0,parton1,phasespace) =
     &                    weightii(6,0,parton1,phasespace) +
     &                    wfacp*
     &                    mm2pdfpdfiiq2_0(iref,0,parton1,em)
      enddo
#endif
                    elseif(em.eq.2.and.lgencon(0,7))then
                      weightii(7,parton1,0,phasespace) =
     &                    weightii(7,parton1,0,phasespace) +
     &                    wfacp*
     &                    m2pdfpdfiiq2_0(phasespace,parton1,0,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,7,parton1,0,phasespace) =
     &                    weightii(7,parton1,0,phasespace) +
     &                    wfacp*
     &                    mm2pdfpdfiiq2_0(iref,parton1,0,em)
      enddo
#endif
                    endif
                    if(em.eq.1.and.lgencon(0,8))then
                      weightii(8,0,parton1,phasespace) =
     &                    weightii(8,0,parton1,phasespace) +
     &                    wfacg*
     &                    m2pdfpdfiit2_0(phasespace,0,parton1,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,8,0,parton1,phasespace) =
     &                    weightii(8,0,parton1,phasespace) +
     &                    wfacg*
     &                    mm2pdfpdfiit2_0(iref,0,parton1,em)
      enddo
#endif
                    elseif(em.eq.2.and.lgencon(0,9))then
                      weightii(9,parton1,0,phasespace) =
     &                    weightii(9,parton1,0,phasespace) +
     &                    wfacg*
     &                    m2pdfpdfiit2_0(phasespace,parton1,0,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,9,parton1,0,phasespace) =
     &                    weightii(9,parton1,0,phasespace) +
     &                    wfacg*
     &                    mm2pdfpdfiit2_0(iref,parton1,0,em)
      enddo
#endif
                    endif
                endif
                enddo
#endif
              endif
            endif
          endif
          enddo
          endif
          if(lgencon(0,6))then
            rejectedcon(6,4)=cut(4)
            rejected(6)=cut(4)
          endif
          if(lgencon(0,7))then
            rejectedcon(7,5)=cut(5)
            rejected(7)=cut(5)
          endif
          if(lgencon(0,8))then
            rejectedcon(8,4)=cut(4)
            rejected(8)=cut(4)
          endif
          if(lgencon(0,9))then
            rejectedcon(9,5)=cut(5)
            rejected(9)=cut(5)
          endif
        endif

c incoming photon and gluon convolution terms for eff. coll. factors

c       write(*,*) 'integrand: seff ',seff(generator),generator

        if(seff(generator).ne.0.and.
     &      (lgencon(generator,6).or.lgencon(generator,7).or.
     &       lgencon(generator,8).or.lgencon(generator,9))
     &      .and.switch.eq.0)then
          if(cut(4).eq.0.or.cut(5).eq.0)then

c initial-state emitter with initial-state spectator
          do em=1,2
          phasespace=em+3
          x=xisr(phasespace)
          omx=omxisr(phasespace)
c          pf=(qedfactor(em,sp,generator)+qedfactor(em,sp,generator))
c     &        *woaisr(phasespace)
          pf=factor(generator) * woaisr(phasespace)
          if(pf.ne.0d0)then

            if(seff(generator).eq.1
     &            .and.sfactqed.gt.0.and.sfactqcd.gt.0)then
              if(lgencon(0,6).or.lgencon(0,7))then
                if(sfactqed.eq.1)then
                  fp=(omx*omx+x*x)*
     &                log(mcollreg2/qedfacscale2)
                elseif(sfactqed.eq.2)then
                  fp=(omx*omx+x*x)*
     &                log(mcollreg2*x/(omx*qedfacscale2))
     &                +1d0-8d0*x*omx
                endif
              endif
              if(lgencon(0,8).or.lgencon(0,9))then
                if(sfactqcd.eq.1)then
                  fg=(omx*omx+x*x)*
     &                log(mcollreg2/qcdfacscale2)
                elseif(sfactqcd.eq.2)then
                  fg=(omx*omx+x*x)*
     &                log(mcollreg2*x/(omx*qcdfacscale2))
     &                +1d0-8d0*x*omx
                endif
              endif
              if(cut(phasespace).eq.0)then
                if(lgencon(0,6).or.lgencon(0,7))then
                  wfac=fp*pf*fac(phasespace)/x
                  wfacp=mcalpha*wfac*freqgencon(generator,6)
                  if(em.eq.1.and.lgencon(0,6))then
                    weight(6,phasespace)=weight(6,phasespace) +
     &                  wfacp*m2pdfpdfq2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,6,phasespace)=
     &              mweight(nset,6,phasespace) +
     &                  wfacp*mm2pdfpdfq2_0(iref,em)
      enddo
#endif
                  elseif(em.eq.2.and.lgencon(0,7))then
                    weight(7,phasespace)=weight(7,phasespace) +
     &                  wfacp*m2pdfpdfq2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,7,phasespace)=
     &              mweight(nset,7,phasespace) +
     &                  wfacp*mm2pdfpdfq2_0(iref,em)
      enddo
#endif
                  endif
                endif
                if(lgencon(0,8).or.lgencon(0,9))then
                  wfac=fg*pf*fac(phasespace)/x
                  wfacg=mcalphas*wfac*freqgencon(generator,8)
                  if(em.eq.1.and.lgencon(0,8))then
                    weight(8,phasespace)=weight(8,phasespace) +
     &                  wfacg*m2pdfpdft2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,8,phasespace)=
     &              mweight(nset,8,phasespace) +
     &                  wfacg*mm2pdfpdft2_0(iref,em)
      enddo
#endif
                  elseif(em.eq.2.and.lgencon(0,9))then
                    weight(9,phasespace)=weight(9,phasespace) +
     &                  wfacg*m2pdfpdft2_0(phasespace,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                    mweight(nset,9,phasespace)=
     &              mweight(nset,9,phasespace) +
     &                  wfacg*mm2pdfpdft2_0(iref,em)
      enddo
#endif
                  endif
                endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                if (parton1.ne.0) then
                    if(em.eq.1.and.lgencon(0,6))then
                      weightii(6,0,parton1,phasespace) =
     &                    weightii(6,0,parton1,phasespace) +
     &                    wfacp*
     &                    m2pdfpdfiiq2_0(phasespace,0,parton1,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,6,0,parton1,phasespace) =
     &                    weightii(6,0,parton1,phasespace) +
     &                    wfacp*
     &                    mm2pdfpdfiiq2_0(iref,0,parton1,em)
      enddo
#endif
                    elseif(em.eq.2.and.lgencon(0,7))then
                      weightii(7,parton1,0,phasespace) =
     &                    weightii(7,parton1,0,phasespace) +
     &                    wfacp*
     &                    m2pdfpdfiiq2_0(phasespace,parton1,0,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,7,parton1,0,phasespace) =
     &                    weightii(7,parton1,0,phasespace) +
     &                    wfacp*
     &                    mm2pdfpdfiiq2_0(iref,parton1,0,em)
      enddo
#endif
                    endif
                    if(em.eq.1.and.lgencon(0,8))then
                      weightii(8,0,parton1,phasespace) =
     &                    weightii(8,0,parton1,phasespace) +
     &                    wfacg*
     &                    m2pdfpdfiit2_0(phasespace,0,parton1,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,8,0,parton1,phasespace) =
     &                    weightii(8,0,parton1,phasespace) +
     &                    wfacg*
     &                    mm2pdfpdfiit2_0(iref,0,parton1,em)
      enddo
#endif
                    elseif(em.eq.2.and.lgencon(0,9))then
                      weightii(9,parton1,0,phasespace) =
     &                    weightii(9,parton1,0,phasespace) +
     &                    wfacg*
     &                    m2pdfpdfiit2_0(phasespace,parton1,0,em)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                      mweightii(nset,9,parton1,0,phasespace) =
     &                    weightii(9,parton1,0,phasespace) +
     &                    wfacg*
     &                    mm2pdfpdfiit2_0(iref,parton1,0,em)
      enddo
#endif
                    endif
                endif
                enddo
#endif
              endif
            endif
          endif
          enddo
          endif
          if(lgencon(0,6))then
            rejectedcon(6,4)=cut(4)
            rejected(6)=cut(4)
          endif
          if(lgencon(0,7))then
            rejectedcon(7,5)=cut(5)
            rejected(7)=cut(5)
          endif
          if(lgencon(0,8))then
            rejectedcon(8,4)=cut(4)
            rejected(8)=cut(4)
          endif
          if(lgencon(0,9))then
            rejectedcon(9,5)=cut(5)
            rejected(9)=cut(5)
          endif
        endif

c        write(*,*) 'integrand weights',weight(1,1),weight(2,1),
c     &  weight(3,1),weight(4,1),weight(5,1)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     tree-level process and                                      c
c     subtraction terms for real photonic corrections             c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      write(*,*) 'integrand ',generator,sgen(generator)
      else if(generator.eq.1.and.sgen(generator).ne.0
     &      .and.mod(nevt,iNumProcs*freqgencon(generator,1)).lt.
     &               iNumProcs)then

c        write(*,*) 'integrand branch for gen=1'

        ncontr(generator)=1
        phasespace=1
        do vcomp=0,3
          kbeam(1,vcomp)=xconv(1)*pbeam(1,vcomp)
          kbeam(2,vcomp)=xconv(2)*pbeam(2,vcomp)
        enddo
        shat=xconv(1)*xconv(2)*energy*energy
c        write(*,*) ' integrand: xc  =',(xconv(vcomp),vcomp=1,2)
c        write(*,*) ' integrand: pb1 =',(pbeam(1,vcomp),vcomp=0,3)
c        write(*,*) ' integrand: pb2 =',(pbeam(2,vcomp),vcomp=0,3)
c        write(*,*) ' integrand: kb1 =',(kbeam(1,vcomp),vcomp=0,3)
c        write(*,*) ' integrand: kb2 =',(kbeam(2,vcomp),vcomp=0,3)
c generate momenta
c        write(*,*) 'integrand'

c phase space point for testing
           call generate_momenta(random(9),kbeam,k,kcms,
     &         g(1,phasespace),channel,generator,switch)
c           call generation(random(9),kbeam,k,g(1,phasespace),
c     &         channel,generator,switch)

#ifdef PRINTWEIGHTMAX
           if(lprintweightmax)then
             do vcomp=0,3
               do ext=1,nextgen(generator)
                 pprint(ext,vcomp)=k(ext,vcomp)
               enddo
             enddo
           endif
#endif

c        write(*,*) 'integrand switch',switch
c                do ext=1,nextgen(generator)
c                  do vcomp=0,3
c                    write(*,100) ext,vcomp,k(ext,vcomp)
c                  enddo
c                enddo
c 100        !    format('integrand:',' k(',i1,',',i1,')    = ',d20.14)

c        write(*,*) 'integrand: gen=1 bef subtraction cuts'

c technical cuts for subtraction branch
        if(ssub(generator).ne.0)then
          call dets(k,sk,nextgen(generator),switch)


          do ext=1,nextsub(generator)
             if (mccharge(ext,generator).ne.0) then

c              write(*,*) 'integrand: gen=1  techcuts 1',
c     &             ext,sk(ext,nextgen(generator)),tcdeltas

              if(sk(ext,nextgen(generator)).lt.sk(1,2)*tcdeltas)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              kk=k(ext,1)*k(nextgen(generator),1)
     &          +k(ext,2)*k(nextgen(generator),2)
     &          +k(ext,3)*k(nextgen(generator),3)
              kvec=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)

c              write(*,*) 'integrand techcuts 2',
c     &             ext,kk,tcdeltac*kvec*k(nextgen(generator),0)

              if(kk.gt.tcdeltac*kvec*k(nextgen(generator),0))then
                rejectedcon(1,phasespace)=-ext-nextgen(generator)
                rejected(1)=-ext-nextgen(generator)
                return
              endif
            endif
          enddo
          if(k(nextgen(generator),0).le.tcdeltae*sqrt(sk(1,2)))then
            rejectedcon(1,phasespace)=-nextgen(generator)
            rejected(1)=-nextgen(generator)
            return
          endif

c         write(*,*) 'integrand techcuts 3',
c     &             k(nextgen(generator),0),tcdeltae

        endif

c        write(*,*) 'integrand bef slicing cuts'

c slicing cuts
        if (ssli(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
c     write(*,*) 'integrand: q ',(q(vcomp),vcomp=0,3)
          do ext=1,nextgen(generator)
c     write(*,*) 'integrand: ext,k ',ext,(k(ext,vcomp),vcomp=0,3)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
c     write(*,*) 'integrand: q1 ',(q1(vcomp),vcomp=0,3)
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
c     write(*,*)'integrand: kcms ',ext,(kcms(ext,vcomp),vcomp=0,3)
            ecms(ext,phasespace)=kcms(ext,0)
          enddo
          do ext=1,nextsub(generator)
            if (mccharge(ext,generator).ne.0) then
              kk=kcms(ext,1)*kcms(nextgen(generator),1)
     &            +kcms(ext,2)*kcms(nextgen(generator),2)
     &            +kcms(ext,3)*kcms(nextgen(generator),3)
              kvec=sqrt(kcms(ext,1)**2+kcms(ext,2)**2
     &            +kcms(ext,3)**2)
              if(kk.gt.(1d0-mcslideltac)*kvec*
     &            kcms(nextgen(generator),0))then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
            endif
          enddo
          if(kcms(nextgen(generator),0).le.
     &        mcslideltas*kcms(1,0))then
            rejectedcon(1,phasespace)=-nextgen(generator)
            rejected(1)=-nextgen(generator)
            return
          endif
        endif

c        write(*,*) 'integrand after slicing cuts'

        call recombination(pbeam,k,krec,generator,nextgen(generator),
     &    cut(phasespace),switch)

        if(switch.eq.0)then
          rejectedcon(1,phasespace)=cut(phasespace)
          rejected(1)=cut(phasespace)
        endif
c        write(*,*) 'integrand: afterrec',cut(1),switch

c if event not cutted ...
c        if((sincludecuts(generator).eq.0.or.cut(phasespace).eq.0).and.
c     &    switch.eq.0)then
c changed AD 10.11.06: density needed if subtraction terms not cutted!
        if(switch.eq.0)then
c calculate densities
          call density(k,g,generator,switch)

c          write(*,*) 'integrand gsum',gsum(phasespace)

c        write(*,*) 'integrand: afterrdens',switch
          if(switch.eq.0)then
            do cha=1,nchannel(generator)
c ADDED for testing AD 6.04.06
              gsum(phasespace)=gsum(phasespace)+g(cha,phasespace)
     &            *alphaopt(cha,opt(generator),generator)
            enddo

c            write(*,*) 'integrand gsum',gsum(phasespace)

            gsum(phasespace)=gsum(phasespace)/freqgencon(generator,1)
c ADDED for testing AD 6.04.06
            gsumm(phasespace)=gsum(phasespace)
            if(cut(phasespace).eq.0.and.switch.eq.0)then
              call crosssection(k,xconv(1),xconv(2),
     &            generator,phasespace,0,0,switch)
              weight(1,phasespace)=m2pdfpdf_0(phasespace)*wconv
     &          *factor(generator)/gsum(phasespace)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
              mweight(nset,1,phasespace)=mm2pdfpdf_0(iref)*wconv
     &          *factor(generator)/gsum(phasespace)
      enddo
#endif

c              write(*,*) 'integrand weight(1,1)',
c     &            weight(1,phasespace),m2pdfpdf_0(phasespace),wconv,
c     &          factor(generator),gsum(phasespace)

#ifdef SUBPROCESSES
              do parton1=-4,4
              do parton2=-4,4
              if (parton1*parton2.ne.0) then
                weightii(1,parton1,parton2,phasespace)
     &              =m2pdfpdfii_0(1,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweightii(nset,1,parton1,parton2,phasespace)
     &              =mm2pdfpdfii_0(iref,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
      enddo
#endif
              endif
              enddo
              enddo
#endif


              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
          endif
        endif

c        write(*,*) 'integrand: ssub= ',ssub(generator),switch

c subtraction terms
        if(ssub(generator).ne.0.and.switch.eq.0)then
          co=nextgen(generator)
c final-state emitter with final-state spectator
c          do em=3,nextgen(generator)-1
c          do sp=3,nextgen(generator)-1
c ADAPTED FOR UNCHARGED HIGGS
          do em=3,nextsub(generator)
          do sp=3,nextsub(generator)
            pf= mcalpha*factor(generator)

c            write(*,*) 'integrand: pf =',pf,em,sp
c            write(*,*) 'integrand: gen =',generator,
c     &          nextgen(generator),em,sp

          if(pf.ne.0d0.and.em.ne.sp)then
            phasespace=phasespace+1
            z=sk(em,sp)/(sk(em,sp)+sk(sp,co))
            y=sk(em,co)/(sk(em,sp)+sk(em,co)+sk(sp,co))
            do vcomp=0,3
              do ext=1,nextgen(generator)
                pevent(ext,vcomp,phasespace)=k(ext,vcomp)
              enddo
              pevent(co,vcomp,phasespace)=0d0
            enddo
c massless case
            if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
              do vcomp=0,3
                pevent(em,vcomp,phasespace)=k(em,vcomp)+k(co,vcomp)
     &              -y/(1d0-y)*k(sp,vcomp)
                pevent(sp,vcomp,phasespace)=1d0/(1d0-y)*k(sp,vcomp)
              enddo
c subtraction for massive case
            endif

            if(sexcl.eq.0)then
c "inclusive" subtraction terms
               call recombination(pbeam,pevent(1,0,phasespace),krec,
     &            generator,nextgen(generator)-1,cut(phasespace),switch)
            else
c "exclusive" subtraction terms
              write(*,*) 'integrand: sexcl = 1 never used'
              write(*,*) 'integrand: check implementation!'
              stop
              do vcomp=0,3
                pevent(co,vcomp,phasespace)=
     &              (1d0-z)*pevent(em,vcomp,phasespace)
                pevent(em,vcomp,phasespace)=
     &              z*pevent(em,vcomp,phasespace)
              enddo
              call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator),cut(phasespace),switch)
              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
            if(switch.eq.0)then
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
              rejectedcon(1,phasespace)=cut(phasespace)
            endif

c determine subtraction terms
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,em,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1)then
                wfacp=8d0*pi*wconv*pf/gsum(1)
     &            *(2d0/(1d0-z*(1d0-y))-(1d0+z))/(1d0-y)/sk(em,co)
                weight(1,phasespace)=
     &              wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacp
     &                *m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacp
     &                *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif

              elseif(ssub(generator).eq.2)then
                wfacp=8d0*pi*wconv*pf /gsum(1)
     &            *(2d0/(1d0-z*(1d0-y))-(1d0+z))/sk(em,co)
                weight(1,phasespace)=
     &              wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacp
     &                *m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacp
     &                *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif
              endif
            endif
          endif
c            write(*,*) 'integrand: weight =',
c     &      weight(phasespace),phasespace,generator,em,sp
          enddo
          enddo

c final-state emitter with initial-state spectator
c          do em=3,nextgen(generator)-1
c ADAPTED FOR UNCHARGED HIGGS
          do em=3,nextsub(generator)
          do sp=1,2
c minus sign from incoming*outgoing particles
            pf= -mcalpha*factor(generator)
          if(pf.ne.0d0)then
            phasespace=phasespace+1
            x=(sk(em,sp)+sk(sp,co)-sk(em,co))/(sk(em,sp)+sk(sp,co))
            z=sk(em,sp)/(sk(em,sp)+sk(sp,co))
            do ext=1,nextgen(generator)
            do vcomp=0,3
              pevent(ext,vcomp,phasespace)=k(ext,vcomp)
            enddo
            enddo
            do vcomp=0,3
              pevent(em,vcomp,phasespace)=k(em,vcomp)+k(co,vcomp)
     &            -(1d0-x)*k(sp,vcomp)
              pevent(sp,vcomp,phasespace)=x*k(sp,vcomp)
              pevent(co,vcomp,phasespace)=0d0
            enddo

            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)
            if(switch.eq.0)then
              rejectedcon(1,phasespace)=cut(phasespace)
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
            endif
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,em,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacp=8d0*pi*wconv*pf
     &            *( (2d0/(2d0-x-z)-1d0-z)/x/sk(em,co)
c initial-state emitter with final-state spectator (em <-> sp)
     &              +(2d0/(2d0-x-z)-1d0-x)/x/sk(sp,co))
     &            /gsum(1)
                weight(1,phasespace)=
     &              wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacp
     &                *m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacp
     &                *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif

              endif
            endif
          endif
c            write(*,*) 'integrand: weight =',
c     &      weight(phasespace),phasespace,generator,em,sp
          enddo
          enddo

c initial-state emitter with initial-state spectator
          do em=1,2
          do sp=1,2
            pf= mcalpha*factor(generator)
          if(pf.ne.0d0.and.em.ne.sp)then
            phasespace=phasespace+1
            x=(sk(em,sp)-sk(em,co)-sk(sp,co))/sk(em,sp)
            v=sk(em,co)/sk(em,sp)
            do vcomp=0,3
              ck(vcomp)=k(em,vcomp)+k(sp,vcomp)-k(co,vcomp)
              ckt(vcomp)=x*k(em,vcomp)+k(sp,vcomp)
            enddo
            do vcomp=0,3
              do j=3,nextgen(generator)-1
                pevent(j,vcomp,phasespace)=k(j,vcomp)
     &            -((1d0+x)*sk(em,j)+2d0*sk(sp,j)-sk(j,co))
     &              /(4d0*x+v-x*v)/sk(em,sp)*(ck(vcomp)+ckt(vcomp))
     &            +(sk(em,j)+sk(sp,j)-sk(j,co))/x/sk(em,sp)*ckt(vcomp)
              enddo
              pevent(em,vcomp,phasespace)=x*k(em,vcomp)
              pevent(sp,vcomp,phasespace)=k(sp,vcomp)
              pevent(co,vcomp,phasespace)=0d0
            enddo
            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)
            if(switch.eq.0)then
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
              rejectedcon(1,phasespace)=cut(phasespace)
            endif
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,em,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacp=8d0*pi*wconv*pf
     &            *(2d0/(1d0-x)-1d0-x)/x/sk(em,co)
     &            /gsum(1)

                weight(1,phasespace)=
     &              wfacp*m2pdfpdfqq_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacp*mm2pdfpdfqq_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacp
     &                *m2pdfpdfiiqq_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacp
     &                *mm2pdfpdfiiqq_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif


              endif
            endif
          endif
c            write(*,*) 'integrand: weight =',
c     &      weight(phasespace),phasespace,generator,em,sp
          enddo
          enddo
        endif

c            write(*,*) 'integrand: phasespace =',phasespace

c        nphsp(generator)=phasespace
        nphsp(generator)=9

c            write(*,*) 'integrand: ouga weights =',generator,
c     &      (weight(generator,phasespace),phasespace=1,nphsp(generator))

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     tree-level process and                                      c
c     subtraction terms for real gluonic corrections              c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      else if(generator.eq.2.and.sgen(generator).ne.0
     &      .and.mod(nevt,iNumProcs*freqgencon(generator,1)).lt.
     &               iNumProcs)then
        ncontr(generator) = 1

c        write(*,*) 'integrand  gen=2 branch',nevt

        phasespace=1
        do vcomp=0,3
          kbeam(1,vcomp)=xconv(1)*pbeam(1,vcomp)
          kbeam(2,vcomp)=xconv(2)*pbeam(2,vcomp)
        enddo
        shat=xconv(1)*xconv(2)*energy*energy
c        write(*,*) ' integrand: xc  =',(xconv(vcomp),vcomp=1,2)
c        write(*,*) ' integrand: pb1 =',(pbeam(1,vcomp),vcomp=0,3)
c        write(*,*) ' integrand: pb2 =',(pbeam(2,vcomp),vcomp=0,3)
c        write(*,*) ' integrand: kb1 =',(kbeam(1,vcomp),vcomp=0,3)
c        write(*,*) ' integrand: kb2 =',(kbeam(2,vcomp),vcomp=0,3)
c generate momenta
c        write(*,*) 'integrand'

c phase space point for testing
           call generate_momenta(random(9),kbeam,k,kcms,
     &         g(1,phasespace),channel,generator,switch)
c           call generation(random(9),kbeam,k,g(1,phasespace),
c     &         channel,generator,switch)


#ifdef PRINTWEIGHTMAX
           if(lprintweightmax)then
             do vcomp=0,3
               do ext=1,nextgen(generator)
                 pprint(ext,vcomp)=k(ext,vcomp)
               enddo
             enddo
           endif
#endif

c        write(*,*) 'integrand switch',switch
c                do ext=1,nextgen(generator)
c                  do vcomp=0,3
c                    write(*,100) ext,vcomp,k(ext,vcomp)
c                  enddo
c                enddo
c 100            format('integrand:',' k(',i1,',',i1,')    = ',d20.14)


c        write(*,*) 'integrand: gen=2 bef subtraction cuts'

c technical cuts for subtraction branch
        if(ssub(generator).ne.0)then
          call dets(k,sk,nextgen(generator),switch)

          do ext=1,nextsub(generator)
             if (mccharge(ext,generator).ne.0) then

              if(sk(ext,nextgen(generator)).lt.sk(1,2)*tcdeltas)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              kk=k(ext,1)*k(nextgen(generator),1)
     &          +k(ext,2)*k(nextgen(generator),2)
     &          +k(ext,3)*k(nextgen(generator),3)
              kvec=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)

c              write(*,*) 'integrand techcuts 2',
c     &             ext,kk,tcdeltac*kvec*k(nextgen(generator),0)

              if(kk.gt.tcdeltac*kvec*k(nextgen(generator),0))then
                rejectedcon(1,phasespace)=-ext-nextgen(generator)
                rejected(1)=-ext-nextgen(generator)
                return
              endif
            endif
          enddo
          if(k(nextgen(generator),0).le.tcdeltae*sqrt(sk(1,2)))then
            rejectedcon(1,phasespace)=-nextgen(generator)
            rejected(1)=-nextgen(generator)
            return
          endif

c         write(*,*) 'integrand techcuts 3',
c     &             k(nextgen(generator),0),tcdeltae

        endif

c slicing cuts
        if (ssli(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo
          do ext=1,nextsub(generator)
            if (mccharge(ext,generator).ne.0) then
              kk=kcms(ext,1)*kcms(nextgen(generator),1)
     &            +kcms(ext,2)*kcms(nextgen(generator),2)
     &            +kcms(ext,3)*kcms(nextgen(generator),3)
              kvec=sqrt(kcms(ext,1)**2+kcms(ext,2)**2
     &            +kcms(ext,3)**2)
              if(kk.gt.(1d0-mcslideltac)*kvec*
     &            kcms(nextgen(generator),0))then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
            endif
          enddo
          if(kcms(nextgen(generator),0).le.
     &        mcslideltas*kcms(1,0))then
            rejectedcon(1,phasespace)=-nextgen(generator)
            rejected(1)=-nextgen(generator)
            return
          endif
        endif

c recombination

c        write(*,*) 'integrand befrec ',generator,nextgen(generator)
c        write(*,*) 'integrand befrec ',nevt

        call recombination(pbeam,k,krec,generator,nextgen(generator),
     &    cut(phasespace),switch)


        if(switch.eq.0)then
          rejectedcon(1,phasespace)=cut(phasespace)
          rejected(1)=cut(phasespace)
c              if(nevt.eq.73) write(*,*) 'integrand rej = ',
c     &            cut(phasespace),rejected(1)
        endif
c        write(*,*) 'integrand real',phasespace,
c     &      rejected(1),rejectedcon(phasespace,1)


c if event not cutted ...
c        if((sincludecuts(generator).eq.0.or.cut(phasespace).eq.0).and.
c     &    switch.eq.0)then
c changed AD 10.11.06: density needed if subtraction terms not cutted!
        if(switch.eq.0)then
c calculate densities
          call density(k,g,generator,switch)
c        write(*,*) 'integrand: afterrdens',switch
          if(switch.eq.0)then
            do cha=1,nchannel(generator)
c ADDED for testing AD 6.04.06
              gcha(cha,phasespace)=g(cha,phasespace)
              gsum(phasespace)=gsum(phasespace)+g(cha,phasespace)
     &            *alphaopt(cha,opt(generator),generator)


            enddo

c            write(*,*) 'integrand: gsum ',gsum(phasespace),
c     &          freqgencon(generator,1)

            gsum(phasespace)=gsum(phasespace)/freqgencon(generator,1)
c ADDED for testing AD 6.04.06
            gsumm(phasespace)=gsum(phasespace)
            if(cut(phasespace).eq.0.and.switch.eq.0)then
              call crosssection(k,xconv(1),xconv(2),
     &            generator,phasespace,0,0,switch)
              weight(1,phasespace)=m2pdfpdf_0(phasespace)*wconv
     &          *factor(generator)/gsum(phasespace)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
              mweight(nset,1,phasespace)=mm2pdfpdf_0(iref)*wconv
     &          *factor(generator)/gsum(phasespace)
      enddo
#endif
#ifdef SUBPROCESSES
              do parton1=-4,4
              do parton2=-4,4
              if (parton1*parton2.ne.0) then
                weightii(1,parton1,parton2,phasespace)
     &              =m2pdfpdfii_0(1,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweightii(nset,1,parton1,parton2,phasespace)
     &              =mm2pdfpdfii_0(iref,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
      enddo
#endif
              endif
              enddo
              enddo
#endif


              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
          endif
        endif
c        write(*,*) 'integrand: qcd ',weight(1,phasespace),
c     &      cut(phasespace)

c        write(*,*) 'integrand: ssub= ',ssub(generator),switch

c subtraction terms
        if(ssub(generator).ne.0.and.switch.eq.0)then
          co=nextgen(generator)
c final-state emitter with final-state spectator
c          do em=3,nextgen(generator)-1
c          do sp=3,nextgen(generator)-1
c ADAPTED FOR UNCHARGED HIGGS
          do em=3,nextsub(generator)
          do sp=3,nextsub(generator)
            pf= mcalphas*factor(generator)

c            write(*,*) 'integrand: pf ff =',pf,em,sp
c            write(*,*) 'integrand: gen =',generator,
c     &          nextgen(generator),em,sp

          if(pf.ne.0d0.and.em.ne.sp)then
            phasespace=phasespace+1
            z=sk(em,sp)/(sk(em,sp)+sk(sp,co))
            y=sk(em,co)/(sk(em,sp)+sk(em,co)+sk(sp,co))
            do vcomp=0,3
              do ext=1,nextgen(generator)
                pevent(ext,vcomp,phasespace)=k(ext,vcomp)
              enddo
              pevent(co,vcomp,phasespace)=0d0
            enddo
c massless case
            if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
              do vcomp=0,3
                pevent(em,vcomp,phasespace)=k(em,vcomp)+k(co,vcomp)
     &              -y/(1d0-y)*k(sp,vcomp)
                pevent(sp,vcomp,phasespace)=1d0/(1d0-y)*k(sp,vcomp)
              enddo
            endif

            if(sexcl.eq.0)then
c "inclusive" subtraction terms
               call recombination(pbeam,pevent(1,0,phasespace),krec,
     &            generator,nextgen(generator)-1,cut(phasespace),switch)
            else
c "exclusive" subtraction terms
              write(*,*) 'integrand: sexcl = 1 never used'
              write(*,*) 'integrand: check implementation!'
              stop
              do vcomp=0,3
                pevent(co,vcomp,phasespace)=
     &              (1d0-z)*pevent(em,vcomp,phasespace)
                pevent(em,vcomp,phasespace)=
     &              z*pevent(em,vcomp,phasespace)
              enddo
              call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator),cut(phasespace),switch)
              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
            if(switch.eq.0)then
              rejectedcon(1,phasespace)=cut(phasespace)
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))

c              if(nevt.eq.73) write(*,*) 'integrand rej = ',
c     &            cut(phasespace),rejected(1)

            endif

c            write(*,*) 'integrand ff',em,sp,phasespace,
c     &          rejected(1),rejectedcon(1,phasespace)

c determine subtraction terms
            if(cut(phasespace).eq.0)then


              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,em,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1)then
                wfacg=8d0*pi*wconv*pf/gsum(1)
     &            *(2d0/(1d0-z*(1d0-y))-(1d0+z))/(1d0-y)/sk(em,co)
                weight(1,phasespace)=
     &              wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                  if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacg
     &                *m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacg
     &                *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif

              elseif(ssub(generator).eq.2)then
                wfacg=8d0*pi*wconv*pf /gsum(1)
     &            *(2d0/(1d0-z*(1d0-y))-(1d0+z))/sk(em,co)
                weight(1,phasespace)=
     &              wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacg
     &                *m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacg
     &                *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif
              endif
            endif


          endif
          enddo
          enddo

c final-state emitter with initial-state spectator
c          do em=3,nextgen(generator)-1
c ADAPTED FOR UNCHARGED HIGGS
          do em=3,nextsub(generator)
          do sp=1,2

c minus sign from incoming*outgoing particles

            pf= -mcalphas*factor(generator)
          if(pf.ne.0d0)then
            phasespace=phasespace+1
            x=(sk(em,sp)+sk(sp,co)-sk(em,co))/(sk(em,sp)+sk(sp,co))
            z=sk(em,sp)/(sk(em,sp)+sk(sp,co))
            do ext=1,nextgen(generator)
            do vcomp=0,3
              pevent(ext,vcomp,phasespace)=k(ext,vcomp)
            enddo
            enddo
            do vcomp=0,3
              pevent(em,vcomp,phasespace)=k(em,vcomp)+k(co,vcomp)
     &            -(1d0-x)*k(sp,vcomp)
              pevent(sp,vcomp,phasespace)=x*k(sp,vcomp)
              pevent(co,vcomp,phasespace)=0d0
            enddo
            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)

c              write(*,*) 'integrand if',em,sp,phasespace,
c     &            cut(phasespace)

            if(switch.eq.0)then
              rejectedcon(1,phasespace)=cut(phasespace)
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))

c              if(nevt.eq.73) write(*,*) 'integrand rej = ',
c     &            cut(phasespace),rejected(1)

            endif
c            write(*,*) 'integrand if',em,sp,phasespace,
c     &          rejected(1),rejectedcon(1,phasespace)
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,em,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacg=8d0*pi*wconv*pf
     &            *( (2d0/(2d0-x-z)-1d0-z)/x/sk(em,co)
c initial-state emitter with final-state spectator (em <-> sp)
     &              +(2d0/(2d0-x-z)-1d0-x)/x/sk(sp,co))
     &            /gsum(1)
                weight(1,phasespace)=
     &              wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacg
     &                *m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacg
     &                *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif

              endif
            endif


         endif

          enddo
          enddo


c initial-state emitter with initial-state spectator
          do em=1,2
          do sp=1,2
            pf= mcalphas*factor(generator)

c            write(*,*) 'integrand: pf ii =',pf,em,sp
          if(pf.ne.0d0.and.em.ne.sp)then
            phasespace=phasespace+1
            x=(sk(em,sp)-sk(em,co)-sk(sp,co))/sk(em,sp)
            v=sk(em,co)/sk(em,sp)
            do vcomp=0,3
              ck(vcomp)=k(em,vcomp)+k(sp,vcomp)-k(co,vcomp)
              ckt(vcomp)=x*k(em,vcomp)+k(sp,vcomp)
            enddo
            do vcomp=0,3
              do j=3,nextgen(generator)-1
                pevent(j,vcomp,phasespace)=k(j,vcomp)
     &            -((1d0+x)*sk(em,j)+2d0*sk(sp,j)-sk(j,co))
     &              /(4d0*x+v-x*v)/sk(em,sp)*(ck(vcomp)+ckt(vcomp))
     &            +(sk(em,j)+sk(sp,j)-sk(j,co))/x/sk(em,sp)*ckt(vcomp)
              enddo
              pevent(em,vcomp,phasespace)=x*k(em,vcomp)
              pevent(sp,vcomp,phasespace)=k(sp,vcomp)
              pevent(co,vcomp,phasespace)=0d0
            enddo
            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)

c              write(*,*) 'integrand ii',em,sp,phasespace,
c     &            cut(phasespace)

            if(switch.eq.0)then
              rejectedcon(1,phasespace)=cut(phasespace)
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
            endif

c            write(*,*) 'integrand ii',em,sp,phasespace,
c     &          rejected(1),rejectedcon(1,phasespace)

            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,em,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacg=8d0*pi*wconv*pf
     &            *(2d0/(1d0-x)-1d0-x)/x/sk(em,co)
     &            /gsum(1)

                weight(1,phasespace)=
     &              wfacg*m2pdfpdftt_0(phasespace,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacg*mm2pdfpdftt_0(iref,em,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                do parton1=-4,4
                do parton2=-4,4
                if (parton1*parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacg
     &                *m2pdfpdfiitt_0(phasespace,parton1,parton2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacg
     &                *mm2pdfpdfiitt_0(iref,parton1,parton2,em,sp)
      enddo
#endif
                endif
                enddo
                enddo
#endif


              endif
            endif


          endif

          enddo
          enddo

c          write(*,*) 'integrand qcdcut =',rejected(1)

        endif


c            write(*,*) 'integrand: phasespace =',phasespace

c        nphsp(generator)=phasespace
        nphsp(generator)=9



***********************************************************************
*                                                                     *
*     tree-level process and                                          *
*     subtraction terms for initial photon contributions 1            *
*                                                                     *
***********************************************************************
      else if(generator.eq.3.and.sgen(generator).ne.0
     &      .and.mod(nevt,iNumProcs*freqgencon(generator,1)).lt.
     &               iNumProcs)then
c        write(*,*) 'integrand sgen',generator,sgen(generator)
        ncontr(generator) = 1
c no real corrections for energy < energyibadpa
        phasespace=1
        do vcomp=0,3
          kbeam(1,vcomp)=xconv(1)*pbeam(1,vcomp)
          kbeam(2,vcomp)=xconv(2)*pbeam(2,vcomp)
        enddo
        shat=xconv(1)*xconv(2)*energy*energy

c generate momenta

        call generate_momenta(random(9),kbeam,k,kcms,
     &      g(1,phasespace),channel,generator,switch)
c        call generation(random(9),kbeam,k,g(1,phasespace),
c     &    channel,generator,switch)
c phase space point for testing

#ifdef PRINTWEIGHTMAX
        if(lprintweightmax)then
          do vcomp=0,3
            do ext=1,nextgen(generator)
              pprint(ext,vcomp)=k(ext,vcomp)
            enddo
          enddo
        endif
#endif

        collfact=1d0

c technical cuts for subtraction branch
        if(ssub(generator).ne.0)then
          call dets(k,sk,nextgen(generator),switch)
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then

c              write(*,*) 'integrand techcuts 1',
c     &             ext,sk(1,ext),sk(1,2)*tcdeltas,tcdeltas

              if(sk(1,ext).lt.sk(1,2)*tcdeltas)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              kk=k(ext,1)*k(1,1)
     &          +k(ext,2)*k(1,2)
     &          +k(ext,3)*k(1,3)
              kvec=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)

c              write(*,*) 'integrand techcuts 2',
c     &             ext,kk,tcdeltac*kvec*k(1,0)

              if(kk.gt.tcdeltac*kvec*k(1,0))then
                rejectedcon(1,phasespace)=-ext-nextgen(generator)
                rejected(1)=-ext-nextgen(generator)
                return
              endif
            endif
          enddo
          if(k(1,0).le.tcdeltae*sqrt(sk(1,2)))then
            rejectedcon(1,phasespace)=-1
            rejected(1)=-1
            return
          endif

c         write(*,*) 'integrand techcuts 3',
c     &             k(nextgen(generator),0),tcdeltae

        endif
c        write(*,*) 'integrand: aftersubcuts',cut(1),switch


c slicing cuts
        if (ssli(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              kk=kcms(ext,1)*kcms(1,1)
     &            +kcms(ext,2)*kcms(1,2)
     &            +kcms(ext,3)*kcms(1,3)
              kvec=sqrt(kcms(ext,1)**2+kcms(ext,2)**2
     &            +kcms(ext,3)**2)
              if(kk.gt.(1d0-mcslideltac)*kvec*
     &            kcms(1,0))then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
c                write(*,*) 'integrand slicuts',ext,kk,kvec,kcms(1,0),
c     &         mcslideltac,(1d0-mcslideltac)*kvec*kcms(1,0)
                return
              endif
            endif
          enddo
c          if(kcms(1,0).le.mcslideltas*kcms(1,0))then
c            rejectedcon(1,phasespace)=-1
c            rejected(1)=-1
c            return
c          endif
        endif
c        write(*,*) 'integrand: afterslicuts',cut(1),switch

c input for effective collinear factors
        if (seff(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo

          collfact=1d0
c          collfact1=1d0
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              spk=k(ext,0)*k(1,0)-k(ext,1)*k(1,1)
     &            -k(ext,2)*k(1,2)-k(ext,3)*k(1,3)

c              write(*,*) 'integrand cut',spk,mceffcut*shat

              if(spk.lt.mceffcut*shat) then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              omz=ecms(ext,phasespace)/ecms(1,phasespace)
              omz2=omz*omz
              z2=(1d0-omz)**2
c              s2th2=(1d0-kk/(kvec*kcms(1,0)))*.5d0
              aux=2d0*omz*spk
              collfact=collfact/(omz2+z2)
     &            *aux*(mcollreg2+aux*(omz2+z2))/(mcollreg2+aux)**2

            endif
          enddo
        endif


c recombination
        call recombination(pbeam,k,krec,generator,nextgen(generator),
     &    cut(phasespace),switch)
        if(switch.eq.0)then
          rejectedcon(1,phasespace)=cut(phasespace)
          rejected(1)=cut(phasespace)
        endif
c        write(*,*) 'integrand: afterrec',cut(1),switch

c if event not cutted ...
        if(switch.eq.0)then
c calculate densities
          call density(k,g,generator,switch)

          if(switch.eq.0)then
            do cha=1,nchannel(generator)
c ADDED for testing AD 6.04.06
              gcha(cha,phasespace)=g(cha,phasespace)
              gsum(phasespace)=gsum(phasespace)+g(cha,phasespace)
     &            *alphaopt(cha,opt(generator),generator)
            enddo
            gsum(phasespace)=gsum(phasespace)/freqgencon(generator,1)
c ADDED for testing AD 6.04.06
            gsumm(phasespace)=gsum(phasespace)
            if(cut(phasespace).eq.0.and.switch.eq.0)then
              call crosssection(k,xconv(1),xconv(2),
     &            generator,phasespace,0,0,switch)
              weight(1,phasespace)=m2pdfpdf_0(phasespace)*wconv
     &          *factor(generator)/gsum(phasespace)
     &            *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
              mweight(nset,1,phasespace)=mm2pdfpdf_0(iref)*wconv
     &          *factor(generator)/gsum(phasespace)
     &            *collfact
      enddo
#endif
c              write(*,*) 'integrand ingaweight',
c     &             phasespace,weight(1,phasespace)
#ifdef SUBPROCESSES
              parton1=0
              do parton2=-4,4
              if (parton2.ne.0) then
                weightii(1,parton1,parton2,phasespace)
     &              =m2pdfpdfii_0(1,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &            *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweightii(nset,1,parton1,parton2,phasespace)
     &              =mm2pdfpdfii_0(iref,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &            *collfact
      enddo
#endif
              endif
              enddo

#endif

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
          endif
        endif

c subtraction terms

c        write(*,*) 'integrand ssub',ssub(generator),switch

        if(ssub(generator).ne.0.and.switch.eq.0)then
          last=nextgen(generator)

c initial-state emitter (=photon) with initial-state spectator
c sum over collinear final state particles
          do em=1,1
          do sp=2,2
          do co=3,nextgen(generator)
            pf= mcalpha*factor(generator)
          if(mccharge(co,generator).ne.0d0.and.em.ne.sp)then
            phasespace=phasespace+1
            x=(sk(em,sp)-sk(em,co)-sk(sp,co))/sk(em,sp)
            v=sk(em,co)/sk(em,sp)
            do vcomp=0,3
              ck(vcomp)=k(em,vcomp)+k(sp,vcomp)-k(co,vcomp)
              ckt(vcomp)=x*k(em,vcomp)+k(sp,vcomp)
            enddo
            do vcomp=0,3
              do j=3,nextgen(generator)
                pevent(j,vcomp,phasespace)=k(j,vcomp)
     &            -((1d0+x)*sk(em,j)+2d0*sk(sp,j)-sk(j,co))
     &              /(4d0*x+v-x*v)/sk(em,sp)*(ck(vcomp)+ckt(vcomp))
     &            +(sk(em,j)+sk(sp,j)-sk(j,co))/x/sk(em,sp)*ckt(vcomp)
              enddo
              pevent(em,vcomp,phasespace)=x*k(em,vcomp)
              pevent(sp,vcomp,phasespace)=k(sp,vcomp)
              if(co.eq.3)then
                pevent(3,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              elseif(co.eq.4)then
                pevent(4,vcomp,phasespace)=pevent(3,vcomp,phasespace)
                pevent(3,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              endif
              pevent(nextgen(generator),vcomp,phasespace)=0d0
            enddo
            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)
            if(switch.eq.0)then
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
              rejectedcon(1,phasespace)=cut(phasespace)
            endif
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,co,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacp=-8d0*pi*wconv*pf
     &            *(x*x+(1d0-x)**2)/(x*sk(em,co))
     &            /gsum(1)

                weight(1,phasespace)=
     &              wfacp*m2pdfpdfqq_0(phasespace,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacp*mm2pdfpdfqq_0(iref,co,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                parton1=0
                do parton2=-4,4
                if (parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacp
     &                *m2pdfpdfiiqq_0(phasespace,parton1,parton2,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacp
     &                *mm2pdfpdfiiqq_0(iref,parton1,parton2,co,sp)
      enddo
#endif
                endif
                enddo
#endif
c                write(*,*) 'integrand ingaweightsub',
c     &              phasespace,weight(1,phasespace)

              else
                write(*,*) ' generator 3: not implemented ssub = ',
     &              ssub(3)
                stop
              endif
            endif
          endif
          enddo
          enddo
          enddo
        endif

c        nphsp(generator)=phasespace
        nphsp(generator)=4

c            write(*,*) 'integrand: weights =',
c     &      (weight(phasespace),phasespace=1,nphsp(generator)),generator

***********************************************************************
*                                                                     *
*     tree-level process and                                          *
*     subtraction terms for initial photon contributions 2            *
*                                                                     *
***********************************************************************
c       write(*,*) 'integrand sgen',generator,sgen(generator)
      else if(generator.eq.4.and.sgen(generator).ne.0
     &      .and.mod(nevt,iNumProcs*freqgencon(generator,1))
     &               .lt.iNumProcs)then
        ncontr(generator) = 1
        phasespace=1
        do vcomp=0,3
          kbeam(1,vcomp)=xconv(1)*pbeam(1,vcomp)
          kbeam(2,vcomp)=xconv(2)*pbeam(2,vcomp)
        enddo
        shat=xconv(1)*xconv(2)*energy*energy

c generate momenta

        call generate_momenta(random(9),kbeam,k,kcms,
     &      g(1,phasespace),channel,generator,switch)
c        call generation(random(9),kbeam,k,g(1,phasespace),
c     &    channel,generator,switch)
c phase space point for testing

#ifdef PRINTWEIGHTMAX
        if(lprintweightmax)then
          do vcomp=0,3
            do ext=1,nextgen(generator)
              pprint(ext,vcomp)=k(ext,vcomp)
            enddo
          enddo
        endif
#endif

        collfact=1d0
c        write(*,*) 'collfact = ',collfact

c technical cuts for subtraction branch
        if(ssub(generator).ne.0)then
          call dets(k,sk,nextgen(generator),switch)
          do ext=3,nextgen(generator)
             if (mccharge(ext,generator).ne.0) then

c              write(*,*) 'integrand techcuts 1',
c     &             ext,sk(2,ext),tcdeltas*sk(1,2),
c     &             tcdeltas

              if(sk(2,ext).lt.sk(1,2)*tcdeltas)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              kk=k(ext,1)*k(2,1)
     &          +k(ext,2)*k(2,2)
     &          +k(ext,3)*k(2,3)
              kvec=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)

c              write(*,*) 'integrand techcuts 2',
c     &             ext,kk,tcdeltac*kvec*k(nextgen(generator),0)

              if(kk.gt.tcdeltac*kvec*k(2,0))then
                rejectedcon(1,phasespace)=-ext-nextgen(generator)
                rejected(1)=-ext-nextgen(generator)
                return
              endif
            endif
          enddo
          if(k(2,0).le.tcdeltae*sqrt(sk(1,2)))then
            rejectedcon(1,phasespace)=-2
            rejected(1)=-2
            return
          endif

c         write(*,*) 'integrand techcuts 3',
c     &             k(2,0),tcdeltae

        endif

c slicing cuts
        if (ssli(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
c          write(*,*) 'integrand shat',shat,
c     &        q(0)**2-q(1)**2-q(2)**2-q(3)**2
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              kk=kcms(ext,1)*kcms(2,1)
     &            +kcms(ext,2)*kcms(2,2)
     &            +kcms(ext,3)*kcms(2,3)
              kvec=sqrt(kcms(ext,1)**2+kcms(ext,2)**2
     &            +kcms(ext,3)**2)
              if(kk.gt.(1d0-mcslideltac)*kvec*
     &            kcms(2,0))then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
            endif
          enddo
c          if(kcms(2,0).le.mcslideltas*kcms(1,0))then
c            rejectedcon(1,phasespace)=-2
c            rejected(1)=-2
c            return
c          endif
        endif

        if (seff(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo

          collfact=1d0
c          collfact1=1d0
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              spk=k(ext,0)*k(2,0)-k(ext,1)*k(2,1)
     &            -k(ext,2)*k(2,2)-k(ext,3)*k(2,3)
c              write(*,*) 'integrand spk',spk,mceffcut*shat,
c     &            spk.lt.mceffcut*shat
              if(spk.lt.mceffcut*shat)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              omz=ecms(ext,phasespace)/ecms(2,phasespace)
              omz2=omz*omz
              z2=(1d0-omz)**2
              aux=2d0*omz*spk
              collfact=collfact/(omz2+z2)
     &            *aux*(mcollreg2+aux*(omz2+z2))/(mcollreg2+aux)**2

            endif
          enddo
        endif


c recombination
        call recombination(pbeam,k,krec,generator,nextgen(generator),
     &    cut(phasespace),switch)
        if(switch.eq.0)then
          rejectedcon(1,phasespace)=cut(phasespace)
          rejected(1)=cut(phasespace)
        endif
c        write(*,*) 'integrand: afterrec',cut(1),switch

c if event not cutted ...
        if(switch.eq.0)then
c calculate densities
          call density(k,g,generator,switch)

          if(switch.eq.0)then
            do cha=1,nchannel(generator)
c ADDED for testing AD 6.04.06
              gcha(cha,phasespace)=g(cha,phasespace)
              gsum(phasespace)=gsum(phasespace)+g(cha,phasespace)
     &            *alphaopt(cha,opt(generator),generator)
            enddo
            gsum(phasespace)=gsum(phasespace)/freqgencon(generator,1)
c ADDED for testing AD 6.04.06
            gsumm(phasespace)=gsum(phasespace)
            if(cut(phasespace).eq.0.and.switch.eq.0)then
              call crosssection(k,xconv(1),xconv(2),
     &            generator,phasespace,0,0,switch)
              weight(1,phasespace)=m2pdfpdf_0(phasespace)*wconv
     &          *factor(generator)/gsum(phasespace)
     &                *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
              mweight(nset,1,phasespace)=mm2pdfpdf_0(iref)*wconv
     &          *factor(generator)/gsum(phasespace)
     &                *collfact
      enddo
#endif
#ifdef SUBPROCESSES
              parton2=0
              do parton1=-4,4
              if (parton1.ne.0) then
                weightii(1,parton1,parton2,phasespace)
     &              =m2pdfpdfii_0(1,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &                *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweightii(nset,1,parton1,parton2,phasespace)
     &              =mm2pdfpdfii_0(iref,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &                *collfact
      enddo
#endif
              endif
              enddo

#endif

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
          endif
        endif

c subtraction terms
        if(ssub(generator).ne.0.and.switch.eq.0)then
          last=nextgen(generator)

c initial-state emitter (=photon) with initial-state spectator
c sum over collinear final state particles
          do em=2,2
          do sp=1,1
          do co=3,nextgen(generator)
            pf= mcalpha*factor(generator)
          if(mccharge(co,generator).ne.0d0.and.em.ne.sp)then
            phasespace=phasespace+1
            x=(sk(em,sp)-sk(em,co)-sk(sp,co))/sk(em,sp)
            v=sk(em,co)/sk(em,sp)
            do vcomp=0,3
              ck(vcomp)=k(em,vcomp)+k(sp,vcomp)-k(co,vcomp)
              ckt(vcomp)=x*k(em,vcomp)+k(sp,vcomp)
            enddo
            do vcomp=0,3
              do j=3,nextgen(generator)
                pevent(j,vcomp,phasespace)=k(j,vcomp)
     &            -((1d0+x)*sk(em,j)+2d0*sk(sp,j)-sk(j,co))
     &              /(4d0*x+v-x*v)/sk(em,sp)*(ck(vcomp)+ckt(vcomp))
     &            +(sk(em,j)+sk(sp,j)-sk(j,co))/x/sk(em,sp)*ckt(vcomp)
              enddo
              pevent(em,vcomp,phasespace)=x*k(em,vcomp)
              pevent(sp,vcomp,phasespace)=k(sp,vcomp)
              if(co.eq.3)then
                pevent(3,vcomp,phasespace)=pevent(4,vcomp,phasespace)
                pevent(4,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              elseif(co.eq.4)then
                pevent(4,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              endif
              pevent(nextgen(generator),vcomp,phasespace)=0d0
            enddo
            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)
            if(switch.eq.0)then
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
              rejectedcon(1,phasespace)=cut(phasespace)
            endif
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,co,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacp=-8d0*pi*wconv*pf
     &            *(x*x+(1d0-x)**2)/(x*sk(em,co))
     &            /gsum(1)

                weight(1,phasespace)=
     &              wfacp*m2pdfpdfqq_0(phasespace,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacp*mm2pdfpdfqq_0(iref,co,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                parton2=0
                do parton1=-4,4
                if (parton1.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacp
     &                *m2pdfpdfiiqq_0(phasespace,parton1,parton2,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacp
     &                *mm2pdfpdfiiqq_0(iref,parton1,parton2,co,sp)
      enddo
#endif
                endif
                enddo
#endif

              else
                write(*,*) ' generator 4: not implemented ssub = ',
     &              ssub(4)
                stop
              endif
            endif
          endif
          enddo
          enddo
          enddo
        endif

c        nphsp(generator)=phasespace
        nphsp(generator)=4

c            write(*,*) 'integrand: weights =',
c     &      (weight(phasespace),phasespace=1,nphsp(generator)),generator

***********************************************************************
*                                                                     *
*     tree-level process and                                          *
*     subtraction terms for initial gluon contributions 1             *
*                                                                     *
***********************************************************************
c       write(*,*) 'integrand sgen',generator,sgen(generator)
      else if(generator.eq.5.and.sgen(generator).ne.0
     &      .and.mod(nevt,iNumProcs*freqgencon(generator,1))
     &               .lt.iNumProcs)then
        ncontr(generator) = 1
        phasespace=1
        do vcomp=0,3
          kbeam(1,vcomp)=xconv(1)*pbeam(1,vcomp)
          kbeam(2,vcomp)=xconv(2)*pbeam(2,vcomp)
        enddo
        shat=xconv(1)*xconv(2)*energy*energy


c generate momenta

        call generate_momenta(random(9),kbeam,k,kcms,
     &      g(1,phasespace),channel,generator,switch)



#ifdef PRINTWEIGHTMAX
        if(lprintweightmax)then
          do vcomp=0,3
            do ext=1,nextgen(generator)
              pprint(ext,vcomp)=k(ext,vcomp)
            enddo
          enddo
        endif
#endif

        collfact=1d0

c technical cuts for subtraction branch
        if(ssub(generator).ne.0)then
          call dets(k,sk,nextgen(generator),switch)
          do ext=3,nextgen(generator)
             if (mccharge(ext,generator).ne.0) then


              if(sk(1,ext).lt.sk(1,2)*tcdeltas)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              kk=k(ext,1)*k(1,1)
     &          +k(ext,2)*k(1,2)
     &          +k(ext,3)*k(1,3)
              kvec=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)


              if(kk.gt.tcdeltac*kvec*k(1,0))then
                rejectedcon(1,phasespace)=-ext-nextgen(generator)
                rejected(1)=-ext-nextgen(generator)
                return
              endif
            endif
          enddo
          if(k(1,0).le.tcdeltae*sqrt(sk(1,2)))then
            rejectedcon(1,phasespace)=-1
            rejected(1)=-1
            return
          endif


        endif


c slicing cuts
        if (ssli(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              kk=kcms(ext,1)*kcms(1,1)
     &            +kcms(ext,2)*kcms(1,2)
     &            +kcms(ext,3)*kcms(1,3)
              kvec=sqrt(kcms(ext,1)**2+kcms(ext,2)**2
     &            +kcms(ext,3)**2)
              if(kk.gt.(1d0-mcslideltac)*kvec*
     &            kcms(1,0))then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
            endif
          enddo
        endif

c input for effective collinear factors
        if (seff(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo

          collfact=1d0
          collfact1=1d0
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              spk=k(ext,0)*k(1,0)-k(ext,1)*k(1,1)
     &            -k(ext,2)*k(1,2)-k(ext,3)*k(1,3)

c              write(*,*) 'integrand cut',spk,mceffcut*shat

              if(spk.lt.mceffcut*shat) then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              omz=ecms(ext,phasespace)/ecms(1,phasespace)
              omz2=omz*omz
              z2=(1d0-omz)**2
c              s2th2=(1d0-kk/(kvec*kcms(1,0)))*.5d0
              aux=2d0*omz*spk
              collfact=collfact/(omz2+z2)
     &            *aux*(mcollreg2+aux*(omz2+z2))/(mcollreg2+aux)**2

            endif
          enddo
        endif


c recombination
        call recombination(pbeam,k,krec,generator,nextgen(generator),
     &    cut(phasespace),switch)
        if(switch.eq.0)then
          rejectedcon(1,phasespace)=cut(phasespace)
          rejected(1)=cut(phasespace)
        endif


c if event not cutted ...
        if(switch.eq.0)then
c calculate densities
          call density(k,g,generator,switch)


          if(switch.eq.0)then
            do cha=1,nchannel(generator)
c ADDED for testing AD 6.04.06
              gcha(cha,phasespace)=g(cha,phasespace)
              gsum(phasespace)=gsum(phasespace)+g(cha,phasespace)
     &            *alphaopt(cha,opt(generator),generator)
            enddo
            gsum(phasespace)=gsum(phasespace)/freqgencon(generator,1)
c ADDED for testing AD 6.04.06
            gsumm(phasespace)=gsum(phasespace)
            if(cut(phasespace).eq.0.and.switch.eq.0)then
              call crosssection(k,xconv(1),xconv(2),
     &            generator,phasespace,0,0,switch)
              weight(1,phasespace)=m2pdfpdf_0(phasespace)*wconv
     &          *factor(generator)/gsum(phasespace)
     &            *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
              mweight(nset,1,phasespace)=mm2pdfpdf_0(iref)*wconv
     &          *factor(generator)/gsum(phasespace)
     &            *collfact
      enddo
#endif


#ifdef SUBPROCESSES
              parton1=0
              do parton2=-4,4
              if (parton2.ne.0) then
                weightii(1,parton1,parton2,phasespace)
     &              =m2pdfpdfii_0(1,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &            *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweightii(nset,1,parton1,parton2,phasespace)
     &              =mm2pdfpdfii_0(iref,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &            *collfact
      enddo
#endif
              endif
              enddo

#endif

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
          endif
        endif


c subtraction terms
        if(ssub(generator).ne.0.and.switch.eq.0)then
          last=nextgen(generator)

c initial-state emitter (=gluon) with initial-state spectator
c sum over collinear final state particles
          do em=1,1
          do sp=2,2
          do co=3,nextgen(generator)
            pf= mcalphas*factor(generator)
          if(mccharge(co,generator).ne.0d0.and.em.ne.sp)then


            phasespace=phasespace+1
            x=(sk(em,sp)-sk(em,co)-sk(sp,co))/sk(em,sp)
            v=sk(em,co)/sk(em,sp)
            do vcomp=0,3
              ck(vcomp)=k(em,vcomp)+k(sp,vcomp)-k(co,vcomp)
              ckt(vcomp)=x*k(em,vcomp)+k(sp,vcomp)
            enddo
            do vcomp=0,3
              do j=3,nextgen(generator)
                pevent(j,vcomp,phasespace)=k(j,vcomp)
     &            -((1d0+x)*sk(em,j)+2d0*sk(sp,j)-sk(j,co))
     &              /(4d0*x+v-x*v)/sk(em,sp)*(ck(vcomp)+ckt(vcomp))
     &            +(sk(em,j)+sk(sp,j)-sk(j,co))/x/sk(em,sp)*ckt(vcomp)
              enddo
              pevent(em,vcomp,phasespace)=x*k(em,vcomp)
              pevent(sp,vcomp,phasespace)=k(sp,vcomp)
              if(co.eq.3)then
                pevent(3,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              elseif(co.eq.4)then
                pevent(4,vcomp,phasespace)=pevent(3,vcomp,phasespace)
                pevent(3,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              endif
              pevent(nextgen(generator),vcomp,phasespace)=0d0
            enddo
            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)


            if(switch.eq.0)then
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
              rejectedcon(1,phasespace)=cut(phasespace)
            endif
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,co,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacg=-8d0*pi*wconv*pf
     &            *(x*x+(1d0-x)**2)/(x*sk(em,co))
     &            /gsum(1)


                weight(1,phasespace)=
     &              wfacg*m2pdfpdftt_0(phasespace,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacg*mm2pdfpdftt_0(iref,co,sp)
      enddo
#endif





#ifdef SUBPROCESSES
                parton1=0
                do parton2=-4,4
                if (parton2.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacg
     &                *m2pdfpdfiitt_0(phasespace,parton1,parton2,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacg
     &                *mm2pdfpdfiitt_0(iref,parton1,parton2,co,sp)
      enddo
#endif
                endif
                enddo
#endif

              else
                write(*,*) ' generator 5: not implemented ssub = ',
     &              ssub(5)
                stop
              endif
            endif
          endif
          enddo
          enddo
          enddo
        endif

c        nphsp(generator)=phasespace
        nphsp(generator)=4

c            write(*,*) 'integrand: weights =',
c     &      (weight(phasespace),phasespace=1,nphsp(generator)),generator

***********************************************************************
*                                                                     *
*     tree-level process and                                          *
*     subtraction terms for initial gluon contributions 2             *
*                                                                     *
***********************************************************************
c       write(*,*) 'integrand sgen',generator,sgen(generator)
       else if(generator.eq.6.and.sgen(generator).ne.0
     &      .and.mod(nevt,iNumProcs*freqgencon(generator,1)).lt.
     &               iNumProcs)then
        ncontr(generator) = 1
        phasespace=1
        do vcomp=0,3
          kbeam(1,vcomp)=xconv(1)*pbeam(1,vcomp)
          kbeam(2,vcomp)=xconv(2)*pbeam(2,vcomp)
        enddo
        shat=xconv(1)*xconv(2)*energy*energy
        collfact=1d0

c generate momenta

        call generate_momenta(random(9),kbeam,k,kcms,
     &      g(1,phasespace),channel,generator,switch)
c        call generation(random(9),kbeam,k,g(1,phasespace),
c     &    channel,generator,switch)
c phase space point for testing

#ifdef PRINTWEIGHTMAX
        if(lprintweightmax)then
          do vcomp=0,3
            do ext=1,nextgen(generator)
              pprint(ext,vcomp)=k(ext,vcomp)
            enddo
          enddo
        endif
#endif

c technical cuts for subtraction branch
        if(ssub(generator).ne.0)then
          call dets(k,sk,nextgen(generator),switch)
          do ext=3,nextgen(generator)
             if (mccharge(ext,generator).ne.0) then

c              write(*,*) 'integrand techcuts 1',
c     &             ext,sk(2,ext),tcdeltas*sk(1,2),
c     &             tcdeltas

              if(sk(2,ext).lt.sk(1,2)*tcdeltas)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              kk=k(ext,1)*k(2,1)
     &          +k(ext,2)*k(2,2)
     &          +k(ext,3)*k(2,3)
              kvec=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)

c              write(*,*) 'integrand techcuts 2',
c     &             ext,kk,tcdeltac*kvec*k(nextgen(generator),0)

              if(kk.gt.tcdeltac*kvec*k(2,0))then
                rejectedcon(1,phasespace)=-ext-nextgen(generator)
                rejected(1)=-ext-nextgen(generator)
                return
              endif
            endif
          enddo
          if(k(2,0).le.tcdeltae*sqrt(sk(1,2)))then
            rejectedcon(1,phasespace)=-2
            rejected(1)=-2
            return
          endif

c         write(*,*) 'integrand techcuts 3',
c     &             k(2,0),tcdeltae

        endif

c slicing cuts
        if (ssli(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              kk=kcms(ext,1)*kcms(2,1)
     &            +kcms(ext,2)*kcms(2,2)
     &            +kcms(ext,3)*kcms(2,3)
              kvec=sqrt(kcms(ext,1)**2+kcms(ext,2)**2
     &            +kcms(ext,3)**2)
              if(kk.gt.(1d0-mcslideltac)*kvec*
     &            kcms(2,0))then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
            endif
          enddo
c          if(kcms(2,0).le.mcslideltas*kcms(1,0))then
c            rejectedcon(1,phasespace)=-2
c            rejected(1)=-2
c            return
c          endif
        endif

c input for effective collinear factors
        if (seff(generator).ne.0) then

c     boost momenta to cms
          do i1=0,3
            q(i1)=k(1,i1)+k(2,i1)
          enddo
          do ext=1,nextgen(generator)
            do vcomp=0,3
              q1(vcomp)=k(ext,vcomp)
            enddo
            call boost(shat,q,q1,1d0,switch)
            do vcomp=0,3
              kcms(ext,vcomp)=q1(vcomp)
            enddo
            ecms(ext,phasespace)=kcms(ext,0)
          enddo

          collfact=1d0
          collfact1=1d0
          do ext=3,nextgen(generator)
            if (mccharge(ext,generator).ne.0) then
              spk=k(ext,0)*k(2,0)-k(ext,1)*k(2,1)
     &            -k(ext,2)*k(2,2)-k(ext,3)*k(2,3)
c              write(*,*) 'integrand spk',spk,mceffcut*shat,
c     &            spk.lt.mceffcut*shat
              if(spk.lt.mceffcut*shat)then
                rejectedcon(1,phasespace)=-ext
                rejected(1)=-ext
                return
              endif
              omz=ecms(ext,phasespace)/ecms(2,phasespace)
              omz2=omz*omz
              z2=(1d0-omz)**2
              aux=2d0*omz*spk
              collfact=collfact/(omz2+z2)
     &            *aux*(mcollreg2+aux*(omz2+z2))/(mcollreg2+aux)**2

            endif
          enddo
        endif


c recombination
        call recombination(pbeam,k,krec,generator,nextgen(generator),
     &    cut(phasespace),switch)
        if(switch.eq.0)then
          rejectedcon(1,phasespace)=cut(phasespace)
          rejected(1)=cut(phasespace)
        endif

c        write(*,*) 'integrand cut',generator,phasespace,
c     &      cut(phasespace)

c if event not cutted ...
        if(switch.eq.0)then
c calculate densities
          call density(k,g,generator,switch)
          if(switch.eq.0)then
            do cha=1,nchannel(generator)
c ADDED for testing AD 6.04.06
              gsum(phasespace)=gsum(phasespace)+g(cha,phasespace)
     &            *alphaopt(cha,opt(generator),generator)
            enddo
            gsum(phasespace)=gsum(phasespace)/freqgencon(generator,1)
c ADDED for testing AD 6.04.06
            gsumm(phasespace)=gsum(phasespace)
            if(cut(phasespace).eq.0.and.switch.eq.0)then
              call crosssection(k,xconv(1),xconv(2),
     &            generator,phasespace,0,0,switch)
              weight(1,phasespace)=m2pdfpdf_0(phasespace)*wconv
     &          *factor(generator)/gsum(phasespace)
     &                *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
              mweight(nset,1,phasespace)=mm2pdfpdf_0(iref)*wconv
     &          *factor(generator)/gsum(phasespace)
     &                *collfact
      enddo
#endif
#ifdef SUBPROCESSES
              parton2=0
              do parton1=-4,4
              if (parton1.ne.0) then
                weightii(1,parton1,parton2,phasespace)
     &              =m2pdfpdfii_0(1,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &                *collfact
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+1
                mweightii(nset,1,parton1,parton2,phasespace)
     &              =mm2pdfpdfii_0(iref,parton1,parton2)
     &              *wconv*factor(generator)/gsum(phasespace)
     &                *collfact
      enddo
#endif
              endif
              enddo

#endif

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo
            endif
          endif
        endif

c subtraction terms
        if(ssub(generator).ne.0.and.switch.eq.0)then
          last=nextgen(generator)

c initial-state emitter (=photon) with initial-state spectator
c sum over collinear final state particles
          do em=2,2
          do sp=1,1
          do co=3,nextgen(generator)
            pf= mcalphas*factor(generator)
          if(mccharge(co,generator).ne.0d0.and.em.ne.sp)then
            phasespace=phasespace+1
            x=(sk(em,sp)-sk(em,co)-sk(sp,co))/sk(em,sp)
            v=sk(em,co)/sk(em,sp)
            do vcomp=0,3
              ck(vcomp)=k(em,vcomp)+k(sp,vcomp)-k(co,vcomp)
              ckt(vcomp)=x*k(em,vcomp)+k(sp,vcomp)
            enddo
            do vcomp=0,3
              do j=3,nextgen(generator)
                pevent(j,vcomp,phasespace)=k(j,vcomp)
     &            -((1d0+x)*sk(em,j)+2d0*sk(sp,j)-sk(j,co))
     &              /(4d0*x+v-x*v)/sk(em,sp)*(ck(vcomp)+ckt(vcomp))
     &            +(sk(em,j)+sk(sp,j)-sk(j,co))/x/sk(em,sp)*ckt(vcomp)
              enddo
              pevent(em,vcomp,phasespace)=x*k(em,vcomp)
              pevent(sp,vcomp,phasespace)=k(sp,vcomp)
              if(co.eq.3)then
                pevent(3,vcomp,phasespace)=pevent(4,vcomp,phasespace)
                pevent(4,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              elseif(co.eq.4)then
                pevent(4,vcomp,phasespace)=pevent(last,vcomp,phasespace)
              endif
              pevent(nextgen(generator),vcomp,phasespace)=0d0
            enddo
            call recombination(pbeam,pevent(1,0,phasespace),krec,
     &          generator,nextgen(generator)-1,cut(phasespace),switch)

c            write(*,*) 'integrand cut',generator,phasespace,
c     &          cut(phasespace)

            if(switch.eq.0)then
              if(cut(phasespace).eq.0) then
                rejected(1)=0
              elseif(rejected(1).gt.0
     &              .and.cut(phasespace).gt.rejected(1))then
                rejected(1)=cut(phasespace)
              endif
c              rejected(1)=min(rejected(1),cut(phasespace))
              rejectedcon(1,phasespace)=cut(phasespace)
            endif
            if(cut(phasespace).eq.0)then
              call crosssection(pevent(1,0,phasespace),
     &            xconv(1),xconv(2),
     &            generator,phasespace,co,sp,switch)

              do ext=1,nextgen(generator)
              do vcomp=0,3
                pevent(ext,vcomp,phasespace)=krec(ext,vcomp)
              enddo
              enddo

              if(ssub(generator).eq.1.or.ssub(generator).eq.2)then
                wfacg=-8d0*pi*wconv*pf
     &            *(x*x+(1d0-x)**2)/(x*sk(em,co))
     &            /gsum(1)

                weight(1,phasespace)=
     &              wfacg*m2pdfpdftt_0(phasespace,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                mweight(nset,1,phasespace)=
     &              wfacg*mm2pdfpdftt_0(iref,co,sp)
      enddo
#endif
#ifdef SUBPROCESSES
                parton2=0
                do parton1=-4,4
                if (parton1.ne.0) then
                  weightii(1,parton1,parton2,phasespace)
     &                =wfacg
     &                *m2pdfpdfiitt_0(phasespace,parton1,parton2,co,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        iref=(nset-1)*maxps+phasespace
                  mweightii(nset,1,parton1,parton2,phasespace)
     &                =wfacg
     &                *mm2pdfpdfiitt_0(iref,parton1,parton2,co,sp)
      enddo
#endif
                endif
                enddo
#endif

              else
                write(*,*) ' generator 4: not implemented ssub = ',
     &              ssub(4)
                stop
              endif
            endif
          endif
          enddo
          enddo
          enddo
        endif

c        nphsp(generator)=phasespace
        nphsp(generator)=4

c            write(*,*) 'integrand: weights =',generator,
c     &      (weight(1,phasespace),phasespace=1,nphsp(generator))

      endif

c end separate generators


c optimization
      weighttot=0d0
      if(switch.gt.0)then
        do iphsp=1,nphsp(generator)
          do icon=1,ncontr(generator)
            weight(icon,iphsp)=0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
            mweight(nset,icon,iphsp)=0
      enddo
#endif
          enddo
        enddo
        weight_0=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        mweight_0(nset)=0d0
      enddo
#endif
      else
        do iphsp=1,nphsp(generator)
          do icon=1,ncontr(generator)
            weighttot=weighttot+weight(icon,iphsp)
          enddo
        enddo
      endif

c used for case where weighttot is always zero owing to switches
c if not weighttot should be zero only in exceptional cases
c eliminated 29.03.07 AD
c      if(weighttot.eq.0d0)weighttot=weight_0

c      write(*,*) 'integrand: final weights = ',weight_0,weighttot,
c     &    (weight(iweight),iweight=1,nphsp(generator))
      call optimization(weighttot,g(1,1),gsum(1),nevt,generator,
     *  nchannel(generator))
c      if(sconv(generator).ne.0.and.(generator.ne.1.or.ssub(1).ne.0))then
      if(sconv(generator).ne.0)then
        call rancum(rand1,weighttot,1,generator,switch)
        call rancum(rand2,weighttot,2,generator,switch)
      endif

      end

***********************************************************************
